/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_class.c
 *
 * class control functions.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"
#include "ps_tdef.h"
#include "ps_proto.h"


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


lex* cmd_lexp;
hashtbl* class_hashtbl;


static unsigned int classtbl_hcode(void* q) {
	return ((classtbl*)q)->sym->code;
	}


ENTRY classtbl* classtbl_lookup(hashtbl* hp,symbol* sym) {
	alloc_ctl* acp = hp->acp;
	unsigned int i,ix;
	classtbl* p;
	if (sym == 0) return 0;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			++(hp->tblent);
			p = new_alloc(acp,sizeof(classtbl));
			p->sym = sym;
			hp->tblpp[ix] = p;
			goto ret;
			}
		if (p->sym == sym) goto ret;
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,20,classtbl_hcode);
	goto retry;
ret:
	/* VȃGgPmɓo^łpɂĂ */
	if (p->tblent >= p->tblsiz) {
		size_t newsiz  = size_doubler(p->tblsiz,2);
		p->tblpp  = resize_segmem(acp, p->tblpp,
			sizeof(void*) * p->tblsiz, sizeof(void*) * newsiz);
		p->tblsiz = newsiz;
		}
	return p;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


/* %%%
#include<dirent.h>
*/



static void ready_made_comp(hashtbl* hp,char* path,char* filter) {
	DIR* dirp;
	char* cname;
	struct dirent* entp;
	dirp = opendir(path);
	if (dirp == NULL) return;
	while((entp = readdir(dirp)) != NULL) {
		if (wildcmp(filter,entp->d_name,1) == 0) {
			cname = str_tok(entp->d_name,". \t\n");
			classtbl_lookup(hp,symbol_lookup(cmd_lexp,cname));
			}
		}
	closedir(dirp);
	}


static void setup_classtbl(hashtbl* hp,char* comp_path) {

	char* path;
	bag_arr* bagp;
	int no;
	bagp = str_tok_arr(comp_path,PATH_DELM);
	if (bagp == 0) return;
	for (no = 0 ; no < bagp->ix ; ++no) {
		path = bagp->ap[no];
		ready_made_comp(hp,path,"*.sfl");
		ready_made_comp(hp,path,"*.nld");
		ready_made_comp(hp,path,"*.pcd");
		}
	del_mactl(bagp->acp);
	}


extern char* cmd_exec_path;
extern char* lib_comp_path;
extern char* user_comp_path;
extern char* comp_exec_path;
extern char* comp_exec_ext;


ENTRY  void make_class_def(
	char* cname,
	char* ctype,
	int   figure,
	int   width,
	char  program_type
){

	static hashtbl* hp = 0;
	char* path;
	char* buf = get_looped_buf(0);
	char* cmd = get_looped_buf(0);
	unsigned int ent;
	if (hp == 0) {
		hp = new_hashtbl(cmd_lexp->cmnacp);
		setup_classtbl(hp,lib_comp_path);
		setup_classtbl(hp,user_comp_path);
		if (access(user_comp_path,0) != 0) {
			mkdir(user_comp_path MKDIR_777);
			}
		}
	ent = hp->tblent;
	classtbl_lookup(hp,symbol_lookup(cmd_lexp,cname));
	if (ent == hp->tblent) return;
	if (cmd_exec_path[0] == 0) {
		/* R}hpXݒ肳ĂȂ̂ŁAJgT */
		sprintf(buf,"%s%c%c_%s%s",
			comp_exec_path,fdelm_char,
			program_type,ctype,comp_exec_ext);
		}
	else {
		sprintf(buf,"%s%c%s%c%c_%s%s",
			cmd_exec_path,fdelm_char,comp_exec_path,fdelm_char ,
			program_type,ctype,comp_exec_ext);
		}
	if (access(buf,1) != 0) {
		sprintf(serr_buf,"create program '%s' is not exist.\n",buf);
		dsp_error(0);
		return;
		}
	path = str_tok(user_comp_path,PATH_DELM);
	sprintf(cmd,"%s %s %s %s %d %d ",buf,path,cname,ctype,figure,width);
	system(cmd);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


enum {radix = 7776};


static char* fw2str(int i1,int i2) {
	static char* no2char = "0123456789abcdefghijklmnopqrstuvwxyz";
	char* buf = get_looped_buf(0);
	int  d;
	int  i;
	long data;
	data = (long)i1 * radix + i2;
	for (i = 0 ; i < 5 ; ++i) {
		d = (int)(data % 36);
		data /= 36;
		buf[4-i] = no2char[d];
		}
	buf[i] = 0;
	return buf;
	}


/* NX */


ENTRY  char* get_class_name(
	char* ctype,
	int   opr,
	int   figure,
	int   width,
	char*  program_typep
){
	char* cname = get_looped_buf(0);
	char* buf   = get_looped_buf(0);
	int hyphen;
	/* NX */
	switch(*program_typep) {
	case 'm':
	case 'c': hyphen = '_'; break;
	case 'n':
	case 'p':
	default:  hyphen = '-'; break;
		}
	sprintf(cname,"%s%c%d%c%d",ctype,hyphen,figure,hyphen,width);
	switch(opr) {
	case NLD_const:
	case NLD_sfln:
	case DEF_submod  :
	case DEF_input   :
	case DEF_output  :
	case DEF_bidirect:
	case DEF_instrin :
	case DEF_instrout:
	case OPR_expand:
	case OPR_0expand:
		*program_typep = 0;
		goto ret;
		}
	if (strcmp(ctype,"buf") == 0   ||
	   (figure == 0 && width == 0) ){
		*program_typep = 0;
		goto ret;
		}
	if (strlen(cname) > 8) {
		if (figure > radix || width > radix) {
			sprintf(serr_buf,"nld file name(%s) is too long.\n",cname);
			dsp_error(0);
			exit(0);
			}
		sprintf(buf,"%s---",ctype);
		buf[3] = 0;
		sprintf(cname,"%s%s",buf,fw2str(figure,width));
		}
ret:
	return cname;
	}


/* NX */


ENTRY classtbl* get_class_tblp(
	char* ctype,
	int   opr,
	int   figure,
	int   width,
	char  program_type
){
	char* cname;
	classtbl* classp;
	/* NX */
	cname = get_class_name(ctype,opr,figure,width,&program_type);
	if (program_type != 0) {
		make_class_def(cname,ctype,figure,width,program_type);
		}
	/* NXI */
	classp = classtbl_lookup(class_hashtbl,symbol_lookup(cmd_lexp,cname));
	return classp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


