/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_cmd.c
 *
 * SFL command main.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


extern char *Version_no;


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"
#include "ps_tdef.h"
#include "ps_proto.h"


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_init_instl)
#	define Ex_init_instl(my) 
#	endif


/* ========================================================================= */
/* =====    cmd misc func                                              ===== */
/* ========================================================================= */


/* XNvg̃lXeBO\ */


ENTRY void script_backtrace(lex* lexp) {
	token* tp = (token*)(lexp->cmd_tp);
	put_source_back(lexp->claimfp,&(tp->loc));
	}


ENTRY void cmd_error(lex* lexp, int rtc) {
	token* tp = (token*)(lexp->cmd_tp);
	error_type(lexp->claimfp,rtc);
	fprintf(lexp->claimfp,"command %s(%s -%d) : ",
		tp->tokren->name,token_file(tp),token_line(tp));
	fprintf(lexp->claimfp,"%s.\n",lexp->errbuf);
	script_backtrace(lexp);
	longjmp(**(lexp->jmpbfpp),rtc);
	}


#undef def_err
#define def_err(code) case ERR_##code: return #code;

static char* error_name(int code) {
	switch(code) {
	all_ecode
		}
	return "(none)";
	}


#undef def_err
#define def_err(code) fprintf(wfp,"setenv ERR_%s %d\n", #code, ERR_##code);

ENTRY void  put_error_code(char* fn) {
	FILE* wfp;
	if (fn == 0) fn = "err_code.scr";
	wfp = fopen(fn,"wt");
	if (wfp == NULL) return;
	all_ecode
	fclose(wfp);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static unsigned int remark_hcode(void* q) {
	return ((symbol*)q)->code;
	}


ENTRY int remark_lookup(hashtbl* hp,symbol* sym) {
	unsigned int i,ix;
	if (sym == 0) return 0;
retry:
	ix = sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		symbol* p;
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			++(hp->tblent);
			hp->tblpp[ix] = sym;
			return 1;
			}
		if (p->code == sym->code) return 0;
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,100,remark_hcode);
	goto retry;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY int cal_bit_width(int data) {
	int i;
	unsigned int fig = (unsigned int)data;
	if (fig == 0) return 1;
	--fig;
	for (i = 0 ; fig != 0 ; ++i) fig >>= 1;
	if (i == 0) i = 1;
	return i;
	}


/* rekf[^POi̕ɕϊ */

ENTRY char* sflntok2dec_str(token* tp) {
	word* vp;
	int bitsiz;
	if (tp == 0) return "";
	bitsiz = tp->figure;
	vp = get_sfln_word(tp);
	return word2str(bitsiz, vp, 'D', register_data);
	}


/* rekf[^PUi̕ɕϊ */

ENTRY char* sflntok2str(token* tp) {
	if (tp == 0) return "";
	return word2hexstr(tp->figure, get_sfln_word(tp));
	}


static int memadr_by_dec = 28;


ENTRY char* memadr2str(token* tp) {
	token* ma;
	ma = get_mem_adr_tokp(tp);
	if (ma->figure <= (unsigned int)memadr_by_dec) {
		return sflntok2dec_str(ma);
		}
	return sflntok2str(ma);
	}


/* -----------------------------------------------

@@rek萔f[^z\
sfln_word :
        -> 0: fedcba9876543210
           1: ................
           2: ................
           3: ................
        -> 0: fedcba9876543210
           1: ................
           2: ................
           3: ................
Oް-> 0: fedcba9876543210
           1: ................
           2: ................
           3: ................
 return -> 0: fedcba9876543210
           1: ................
           2: ................
           3: ................ <--- sfln_put_ix 
              ................
              ................
              ................
              ................
              ................
                               <--- sfln_end_ix 

----------------------------------------------- */


/* SFLg[NSFLŒGAɓo^A̓o^ԍvalue߂ */

static word* store_sfln(token* tp, word* wp) {
	/* SFLo^邽߂̌ŒGA */
	static word*  sfln_word = 0;
	static int sfln_put_ix = 0;
	static int sfln_end_ix = 0;
	word*  vp;
	size_t osiz;
	int    len;
	if (tp == 0) goto ret;
	tp->value  = sfln_put_ix;
	tp->figure = BITSIZ(wp);
	len = ARRLEN(wp);
	if (sfln_put_ix + len >= sfln_end_ix) {
		osiz = sfln_end_ix * sizeof(word);
		sfln_end_ix = size_doubler(sfln_end_ix, 256);
		vp = (word*)new_mem(sfln_end_ix * sizeof(word));
		if (osiz != 0) {
			memcpy(vp,sfln_word,osiz);
			del_mem(sfln_word);
			}
		sfln_word = vp;
		}
	if (sfln_put_ix + len >= sfln_end_ix) {
		sys_error("fail store_sfln");
		}
	memcpy(sfln_word + sfln_put_ix, wp+1, sizeof(word)*len);
	sfln_put_ix += len;
	tp->wpp = &sfln_word;
ret:
	return sfln_word;
	}


ENTRY token* str2sflntok(tMYc char* buf) {
	token  tok;
	token* tp;
	int    set_flg;
	memset(&tok,0,sizeof(token));
	tok.tokren = tok.toksym = symbol_lookup(my->sfllexp,buf);
	tok.id = LEX_SFLN;
	set_flg = 1;
	tp = token_lookup(my->sflnum_tp, &tok, &set_flg);
	if (set_flg) {
		my->sfln_tbl = store_sfln(tp,str2sfln(my->seconds,buf));
		}
	if (tp != 0) tp->wpp = &(my->sfln_tbl);
	return tp;
	}


ENTRY token* resize_sfln(tMYc unsigned int fig,  token* tp) {
	/* ̊֐̂rekmi[p̃obt@ */
	static word* wb = 0;
	static int   wb_siz = 0;
	int          wb_cnt;
	char* sp;
	/* -- */
	int nlen;
	if (fig == tp->figure) return tp;
	nlen = cal_arr_len(fig);
	wb_cnt = nlen + 1;
	if (wb_cnt > wb_siz) {
		/* ԃf[^i[p̃obt@g */
		wb = resize_segmem(tp->acp,wb,wb_siz*sizeof(word),wb_cnt*sizeof(word));
		wb_siz = wb_cnt;
		}
	ARRLEN(wb) = (halfword)nlen;
	BITSIZ(wb) = (halfword)fig;
	word_copy(fig,wb+1,tp->figure,get_sfln_word(tp));
	sp = word2hexstr(BITSIZ(wb), wb+1);
	tp = str2sflntok(MYc sp);
	tp->figure = fig;
	return tp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY token* tell_token_path(FILE* spkfp, token* tp) {
	token* ptp;
	ptp = tp->parent;
	if (ptp != 0) {
		if (tell_token_path(spkfp,ptp) != 0) {
			/* ̏ꏊ̐éA[gł͂ȂB */
			switch(tp->id) {
			case DEF_module:
			case DEF_circuit:
				fprintf(spkfp,"/");
				break;
			default:
				fprintf(spkfp,".");
				}
			}
		}
	fprintf(spkfp,"%s",token_name(tp));
	return ptp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


/* ---

P앶
token  OPR_behavior
       .1

par 앶
token  OPR_behavior  OPR_par  OPR_behavior
       .1            .1          
                              OPR_par  OPR_behavior
                              .2          
                                       OPR_par  OPR_behavior
                                       .3

any 앶
token  OPR_behavior  OPR_any  OPR_if_cond  <expr>
       .1            .1                    OPR_behavior
                                           .1
                              OPR_any  OPR_if_cond  <expr>
                              .2                    OPR_behavior
                                                    .1
                                       OPR_any    OPR_if_cond  <expr>
                                       .3                      OPR_behavior
                                                               .1

if 앶
token  OPR_behavior  OPR_if  <expr>
       .1                    OPR_behavior
                             .1
--- */


static void tell_beh_path(FILE* spkfp, expr* rep, expr* etp) {
	expr* ep;
	expr* beh;
	int   i;
	if (rep == etp) {
		/* ̃gbvɒBĂ */
		return;
		}
	/* Pɑk */
	beh = step_back_behavior(rep);
	tell_beh_path(spkfp, beh, etp);

	switch(rep->opr) {
	case OPR_behavior:
		/* ̒̓t@VeBH */
		if (beh == etp) {
			fprintf(spkfp,".1");
			return;
			}
		/* ̒͏߂H */
		switch(beh->opr) {
		case OPR_if:
		case OPR_if_cond:
			fprintf(spkfp,".1");
			}
		return;
	case OPR_par:
	case OPR_alt:
	case OPR_any:
		for (ep = beh->op1,i = 1 ; ep != 0 ; ep = ep->op2,++i) {
			if (ep == rep) {
				fprintf(spkfp,".%d",i);
				break;
				}
			}
		break;
	/* ͏߂H */
	/* %%%
	case OPR_if:
	case OPR_if_cond:
		fprintf(spkfp,".1");
		break;
	*/
		}
	}


ENTRY void tell_expr_path(FILE* spkfp, int no, expr* rep) {
	fileloc* loc;
	expr*    ep;
	expr*    etp;	/*  token* ŏL҃t@VeBւ̃|C^ */
	expr*    cep = 0;
	/* t@C̋Lqʒu擾 */
	for (ep = rep ; ep != 0 ; ep = step_back_behavior(ep)) {
		switch(ep->opr) {
		case OPR_behavior:
			/* t@Ći`jʒu\ */
			loc = (fileloc*)(ep->op2);
			goto path_dsp;
		case OPR_if_cond:	/* Ώۂ́Aialt ܂ anyj̏ */
		case OPR_if:		/* Ώۂ́Aif̏ */
			cep = ep;
			loc = (fileloc*)(cep->beh->op2);
			goto path_dsp;
			}
		}
	return;
path_dsp:
	fprintf(spkfp,"(%d) ",no);
	/* t@VeB܂ł̃pX\ */
	for (etp = step_back_behavior(ep) ; etp != 0 ; etp = step_back_behavior(etp)) {
		if (etp->opr >= DEF_top && etp->opr <= DEF_end) {
			/* t@VeB𔭌 */
			tell_token_path(spkfp,(token*)etp);
			goto expr_path;
			}
		}
	return;
expr_path:
	/* `Kwԍ\ */
	tell_beh_path(spkfp, rep, etp);	
	fprintf(spkfp,"\n");
	/* t@Cʒu\ */
	fprintf(spkfp,"    (%s -%d)\n    ",symcate_name(loc->file), loc->line);
	/* Ώۂ̎\ */
	if (cep == 0) {
		sflwt_exp_behavior(spkfp, 0, ep);
		}
	else {
		sflwt_opr_expression(spkfp,NO_priority,cep);
		fprintf(spkfp," :\n");
		}
	}


/* ========================================================================= */
/* =====    fBNeBu̒`    @                                 ===== */
/* ========================================================================= */


#undef def_drct
#define def_drct(key) {#key,DRCT_##key},


static key_word drct_key_tbl[] = {
	drct_key
	{"@",DRCT_let  },
	{"{",DRCT_bigin},
	{"}",DRCT_end  },
	{"",0}
	};


static void put_script_err(FILE* cfp, token* tp) {
	if (cfp == NULL || tp->loc.file == 0) return;
	fprintf(cfp,"Script : ");
	source_position(cfp, token_name(tp),&(tp->loc));
	fprintf(cfp,"\n");
	put_source_back(cfp,tp->loc.parent);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY int get_cmd_code(tMYc char* sp) {
	lex*   lexp = my->cmdlexp;
	int    set_flg;
	token  tok;
	token* lxp = &tok;
	token* ltp;
	lxp->id     = LEX_SYM;
	lxp->tokren = lxp->toksym = symbol_lookup(lexp, sp);
	/* seek facility name */
	set_flg = 0;	/* QƂ̂ */
	ltp = token_lookup(my->cmdkey_tp, lxp, &set_flg);
	if (ltp == 0) {
		sprintf(lexp->errbuf,"'%s' no such command",sp);
		cmd_error(lexp,ERR_user);
		}
	return ltp->id;
	}


/* ========================================================================= */
/* =====   R}hL[[h̎擾                                    ===== */
/* ========================================================================= */


ENTRY token* get_command(tMYc token* lxp) {
	lex*   lexp;
	token* ltp;
	int    set_flg;
	footmark("get_command");
	lexp = my->cmdlexp;
	lxp->id = cmd_word(lexp);
	lxp->toksym = lexp->toksym;
	lxp->tokren = lexp->toksym;
	lxp->loc    = lexp->tokloc;

	switch(lxp->id) {
	case LEX_EOF:
		break;
	case LEX_NUM:
		lxp->value = str2num(lexp,lexp->tokbuf);
		break;
	case LEX_SFLN:
		/* %%% SFLƂĂ̓o^sv
		lxp->wpp = str2sfln(my->seconds,lexp->tokbuf);
		*/
		break;
		}
	if (lxp->id == LEX_SYM) {
		set_flg = 0;
		ltp = token_lookup(my->cmdkey_tp, lxp, &set_flg);
		if (ltp != 0) lxp = ltp;
		}
	return lxp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static int is_alone_mod_acp(tMYc token* tp) {
	alloc_ctl* acp = tp->acp;
	component* cp;
	uni_link* lp;
	if (my->declare_tp == 0) goto next1;
	cp = my->declare_tp->comp_tbl;
	if (cp == 0) goto next1;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		if (acp == tp->acp) return 0;
		}
next1:
	if (my->class_tp == 0) goto next2;
	cp = my->class_tp->comp_tbl;
	if (cp == 0) goto next2;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		if (acp == tp->acp) return 0;
		}
next2:
	return 1;
	}


ENTRY void parge_all(tMY) {
	token* tp;
	token  tok;
	component* cp;
	uni_link* lp;
	if (my->declare_tp == 0) goto next1;
	cp = my->declare_tp->comp_tbl;
	if (cp == 0) goto next1;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		if (is_alone_mod_acp(MYc tp)) del_mactl(tp->acp);
		}
next1:
	if (my->class_tp == 0) goto next2;
	cp = my->class_tp->comp_tbl;
	if (cp == 0) goto next2;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		if (is_alone_mod_acp(MYc tp)) del_mactl(tp->acp);
		}
next2:
	memset(&tok,0,sizeof(token));
	tok.figure = 1;
	if (my->declare_tp != 0) {
		tok.tokren = tok.toksym = my->declare_tp->toksym;
		del_mactl(my->declare_tp->acp);
		my->declare_tp = new_token(new_mactl(),SFL_decl,&tok);
		}
	if (my->class_tp != 0) {
		tok.tokren = tok.toksym = my->class_tp->toksym;
		del_mactl(my->class_tp->acp);
		my->class_tp = new_token(new_mactl(),SFL_root,&tok);
		}
	}


/* w肳ꂽEubNŒ`ꂽo[ */

static void delete_acp_member(token* gtp,alloc_ctl* del_acp) {
	component* cp;
	hashtbl*   hp;
	uni_link** lpp;
	int ent_cnt;
	if (gtp == 0 ||  del_acp == 0) return;
	if ((cp = gtp->comp_tbl) == 0) return;
	if ((hp = cp->comphash ) == 0) return;
	ent_cnt = 0;
	for (lpp = &(cp->top) ; *lpp != 0 ;  ) {
		token* tp;
		tp = (*lpp)->ap;
		if (tp->acp == del_acp) {
			/* ̃o[͍폜 */
			delete_hash_entry(hp,tp,tp->toksym->code);
			/* Pl߂ */
			*lpp = (*lpp)->np;
			}
		else {
			/* ̃o[́Ac */
			ent_cnt++;
			/* Pi߂ */
			lpp = &((*lpp)->np);
			}
		}
	cp->count = ent_cnt;
	cp->endp = lpp;
	}



/*****************************************************************************/
/* ========================================================================= */
/* =====   R}hC^[v^[                                    ===== */
/* ========================================================================= */
/*****************************************************************************/


extern int LEX_d_print;
extern int LEX_listen;


/* iPcmdlexw肷jXNvgsC^[v^̎ */

static void script_interpret(tMY) {
	cmd_func* cmd_tbl = my->cmd_tbl;
	lex*   lexp = my->cmdlexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	int    key;
	int    i;
	char*  script;
	footmark("script_interpret");
	my->sfllexp->speakfp = lexp->speakfp;
	/*=== R}hs[v ===*/
	while(lexp->sfp != 0 && lexp->restart == 0) {
		lexp_errclr(lexp);		/* G[FbZ[WEobt@ */
		lexp->skip_nl  = 0;		/* sg[N */
		lexp->skip_spc = 1;		/* 󔒃g[N̓XLbv */
		lexp->prompt   = 1;
		lexp->cmd_tp   = lxp;
		if (lexp->suspend != 0) break;
		/* R}hP擾 */

		tp = get_command(MYc lxp);

		if (token_id(tp) == LEX_EOF) {
			lexp->sfp->eof_cnt = 0;
			goto ret;
			}
		if (token_id(tp) == LEX_listen) {
			/* listenR}hɑ擾 */
			if (lexp->verbose) fprintf(lexp->speakfp,"'listen' ");
			get_cmd_arg(lexp,0);
			if (lexp->argc == 0) goto end;
			goto listen;
			}
		/* ʂȃR}h̏ꍇ̏ */
		switch(token_id(tp)) {
		case LEX_QRY:
			/* '?'R}h */
			token_id(tp) = LEX_d_print;
			break;
		case LEX_NL:
			/* ŝ݂̏ꍇ */
			goto end;
			}
		/* R}hɗ^擾 */
		get_cmd_arg(lexp,lexp->tokbuf);
		/* 擾R}he[uT */
		for (i = 0 ; (key = cmd_tbl[i].key) != 0 ; ++i) {
			if (key == token_id(tp)) {
				/* R}hv̂ŁAs */
				(*(cmd_tbl[i].func))(MY);
				goto end;
				}
			}
	listen:
		/* vR}ĥŁAXNvgƂĎs */
		script = full_file_name(NAME_PATH, lexp->lex_path->name, lexp->args[0]);
		/* ̃XNvǵAs܂ňړĂ */
		move_next_cmd(lexp,LINE_right);
		/* VXNvgJ */
		new_source(lexp,lexp,READ_FILE,script,'$',lexp->argc,lexp->args);
		continue;
end:
		move_next_cmd(lexp,LINE_left);
		}
ret:
	del_entity(my->tokecp,lxp);
	}


/* jmp_buf ŃX^bNHׂȂ悤ɐ݂Tu[` */

static void lex_interpret(tMY) {
	lex* lexp;
	jmp_buf* savep = my->jmpbfp;
	jmp_buf jbuf;
	int rtc;
	footmark("lex_interpret");
	my->jmpbfp = &jbuf;
	rtc = setjmp(jbuf);
	if (rtc == 0) {
		lexp = my->cmdlexp;
		file_restart(lexp->sfp);	/* XNvgt@C̍ĊJ */
		script_interpret(MY);		/* XNvgt@C̎s */
		}
	my->jmpbfp = savep;
	lexp = my->cmdlexp;
	file_suspend(lexp->sfp);	/* XNvgt@C̕ */
	switch(rtc) {
	case 0:
		/* I */
		break;
	case ERR_eof:
		if (my->sfllexp->sfp != 0) {	/* SFL ` */
			/* G[́ASFL\[X̒ł */
			if (my->sfllexp->sflacp != 0) {
				/* module `͏IĂȂ */
				sprintf(my->sfllexp->errbuf,"end of file");
				lex_error(my->sfllexp,ERR_user);
				}
			/* module `͐I */
			close_all_sfp(my->sfllexp);
			move_next_cmd(lexp,LINE_left);
			break;
			}
		/* G[́AR}hXNvg̎s */
		if (lexp->parent == 0) {
			/* NR}hEXNvg̏I */
			longjmp(*(my->jmpbfp),ERR_bye);
			}
		lexp->parent->suspend = 0;
		/* G[R}hEXNvg̏I */
		delete_lex(lexp);
		break;
	default:
		if (lexp->parent != 0) lexp->parent->suspend = 0;
		longjmp(*(my->jmpbfp),rtc);
		}
	}


/* forkĎ}ꂵelexɂăXNvgs֐ */

static void lex_scan(tMYc bag_arr* bagp) {
	/* FċAsȂ̂ŁAȂׂX^bNHׂȂ悤ɁI */
	int i = 0;
	lex* lexp = 0;
	footmark("lex_scan");
	forever {
		/* Fbagp->ixlex_interpret(MY)̎sŕω */
		if (i >= bagp->ix) break;
		if (lexp == (lex*)(bagp->ap[i])) {
			/* lexp͎sς݂Ȃ̂ŁAֈړ */
			++i;
			continue;
			}
		lexp = (lex*)(bagp->ap[i]);
		lex_scan(MYc lexp->child_lexp);
		if (lexp->suspend == 0 && lexp->sfp != 0) {
			my->cmdlexp = lexp;
			lex_interpret(MY);	/* R}hEXNvg̎s */
			if (lexp->restart != 0) {
				lexp->restart = 0;
				longjmp(*(my->jmpbfp),ERR_reset);
				}
			}
		}
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static int gf_verify = 0;


static macro* startup_macro(alloc_ctl* acp,int argc,char **args) {
	symbol*  sybp = new_alloc(acp, sizeof(*sybp));
	symcate* sycp = new_alloc(acp, sizeof(*sycp));
	macro*   macp = new_alloc(acp, sizeof(*macp));
	char* string;
	int i,cnt;
	for (i = cnt = 0 ; i < argc ; ++i) {
		cnt += strlen(args[i]) + 1;
		}
	string = new_alloc(acp,cnt+1+1);
	for (i = cnt = 0 ; i < argc ; ++i) {
		sprintf(string+cnt,"%s ",args[i]);
		cnt += strlen(args[i]) + 1;
		}
	sprintf(string+cnt,"\n");
	sybp->name = "startup";
	sybp->code = 0;
	sycp->sym  = sybp;
	sycp->cate = 0;
	macp->macsym = sybp;
	macp->string = string;


	return macp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static macro* gui_macro(alloc_ctl* acp,size_t buflen) {
	symbol*  sybp = new_alloc(acp, sizeof(*sybp));
	symcate* sycp = new_alloc(acp, sizeof(*sycp));
	macro*   macp = new_alloc(acp, sizeof(*macp));
	char*  string = new_alloc(acp, buflen);
	sybp->name = "gui_command";
	sybp->code = 0;
	sycp->sym  = sybp;
	sycp->cate = 0;
	macp->macsym = sybp;
	macp->string = string;


	string[0] = 0;
	return macp;
	}


ENTRY char* gui_init(global* my,int gui_buflen) {
	lex* lexp;
	source* sfp;
	macro*  gui_mp;
	if (gui_buflen == 0) return 0;
	lexp = my->cmdlexp;
	lexp->sfp = 0;
	lexp->lexloc.file = 0;
	/* Œ̃obt@ʂmۂ */
	if (gui_buflen < 128) gui_buflen = 128;
	gui_mp = gui_macro(my->sysacp,gui_buflen);
	sprintf(gui_mp->string,"%s"," \n");
	/* fthɂeLXgR}hs */
	sfp = new_source(lexp,lexp,READ_GUI,gui_mp,'$',0,0);
	/* ͉̓͐ȂƂw */
	lexp->permanent = 1;
	sfp->permanent = 1;
	return gui_mp->string;
	}


/* Qlp̂fthڑ֐iCUIɕϊĂj */

ENTRY void dummy_gui_2_cui(int len,char* buf) {
	char str[256];
	if (len > 254) len = 254;
	rewind(stdin);
	printf("SFL> ");
	fgets(str,len, stdin);
	/* R}h́AsR[hŏIKvB */
	sprintf(buf,"%s\n",str);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static global* new_global(void) {
	static symbol sym = {"/",0};
	alloc_ctl* acp;
	global* my;
	token   tok;
	footmark("new_global");
	memset(&tok,0,sizeof(tok));
	tok.tokren = tok.toksym = &sym;
	tok.figure = 1;
	acp = new_mactl();
	my = new_alloc(acp,sizeof(global));
	my->sysacp = acp;
	my->jmpbfp = new_alloc(acp,sizeof(jmp_buf));
	my->tokacp = new_alloc(acp,sizeof(alloc_ctl));
	my->tmpacp = 0;
	my->tokecp = new_entctl(my->tokacp,sizeof(token));
	my->rsv_hp = new_hashtbl(acp);
	my->cmdkey_tp = new_token(acp,CMD_key ,&tok);
	my->sflkey_tp = new_token(acp,SFL_key ,&tok);
	my->sflnum_tp = new_token(acp,SFL_sfln,&tok);
	my->child_lexp = new_bag(acp);
	/* ύX\ȃg[N */
	my->declare_tp= new_token(new_mactl(),SFL_decl,&tok);
	my->class_tp  = new_token(new_mactl(),SFL_root,&tok);

	return my;
	}


static int get_reserved(tMY);
extern key_word cmd_key_tbl[];
extern void attach_opr_dict(alloc_ctl* acp);


#if (MULTI_GLOBAL == 0)
	global* my;
#	endif


ENTRY global* interpreter_init(
	int argc,
	char **args,
	char* ipath,
	cmd_func* cmd_tbl,
	setup_parm* setup_tbl[]
) {
	alloc_ctl* acp;
	lex*    sys_lexp;
	lex*    lexp;
	source* sfp;
	macro*  startup_mp;
#	if (MULTI_GLOBAL != 0)
		global* my;
#		endif
	footmark("interpreter_init");
	/* ===== interpreter initialize ===== */
	/* VXȅ */
	my = new_global();
	my->ipath = ipath;
	my->cmd_tbl = cmd_tbl;
	acp = my->sysacp;
	/* t@Cǂݏo */
	if (get_filedef(acp, ipath, setup_tbl) == 0) {;
		printf("Warning : can't read start-up file. (%s)\n",ipath);
		}
	if (gf_verify) {
		/* for debug display */
		put_filedef(setup_tbl);
		exit(0);
		}
	/* === VXeʂlexf[^쐬 === */
	sys_lexp = new_alloc(acp,sizeof(lex));
	sys_lexp->cmnacp   = acp;
	sys_lexp->jmpbfpp  = &(my->jmpbfp);
	sys_lexp->speakfp  = stdout;
	sys_lexp->claimfp  = stderr;
	sys_lexp->symhash  = new_hashtbl(acp);
	sys_lexp->catehash = new_hashtbl(acp);
	sys_lexp->filehash = new_hashtbl(acp);
	sys_lexp->speakfn  = symcate_lookup(sys_lexp,STDout,TYPE_STDOUT);
	sys_lexp->claimfn  = symcate_lookup(sys_lexp,STDerr,TYPE_STDERR);
	sys_lexp->acp      = acp;
	sys_lexp->sflacp   = 0;
	sys_lexp->sflspec  = 2;	/* ZLEx́Aʏ̎Zpɂ */
	sys_lexp->echo_on  = 1;
	lex_init_mode(sys_lexp);
	/* === rek\[X͗plex쐬 === */
	lexp = new_lex(sys_lexp);	/* sfl lex table */
	my->sfllexp = lexp;
	lexp->lex_path = symbol_lookup(lexp,cwd_path(0));
	lexp->permanent = 1;
	switch(sflspec_no) {
	case 1:
	case 2:
		my->sfllexp->sflspec = sflspec_no;
		break;
	default:
		my->sfllexp->sflspec = sflspec_no = 1;
		}
	/* @Ɋւ鎚̓o^ */
	lexp->drct_hp  = teach_key_word(lexp, drct_key_tbl);		/* directive */
	lexp->opr_tblp = teach_word_dict(lexp->acp, char_opr_tbl);	/* char operator */
	teach_key_dict(lexp, my->sflkey_tp, sfl_key_tbl);
	attach_opr_dict(lexp->acp);
	/* === R}h͗plex쐬 === */
	lexp = new_lex(sys_lexp);	/* command lex table */
	my->cmdlexp  = lexp;
	lexp->lex_path = symbol_lookup(lexp,cwd_path(0));
	append_bag_que(my->child_lexp,lexp);
	lexp->drct_hp  = teach_key_word(lexp, drct_key_tbl);		/* directive */
	lexp->opr_tblp = teach_word_dict(lexp->acp, char_opr_tbl);	/* char operator */
	teach_key_dict(lexp, my->cmdkey_tp, cmd_key_tbl);
	Ex_init_instl(my);
	/* \t@Cǂݏo */
	get_reserved(MY);
	/* R}h̓͐I */
	if (argc == 0) {
		/* ʏ̃R\[̓[hŃX^[g */
		int typ;
		if (isatty(fileno(stdin)) != 0) typ = READ_TTY;
		else typ = READ_STDIN;		/* is_sinsrc() */
		sfp = new_source(lexp,lexp,typ,0,'$',0,0);
		/* ͉̓͐ȂƂw */
		lexp->permanent = 1;
		sfp->permanent = 1;
		}
	else {
		/* A[Mgɂ鑦lR}h[hŃX^[g */
		startup_mp = startup_macro(acp,argc,args);
		new_source(lexp,lexp,READ_SUP,startup_mp,'$',0,0);
		}
	return my;
	}



ENTRY int command_interpreter(global* my) {
	lex*  lexp;
	token cmd;
	int   rtc;
	footmark("command_interpreter");
	/* ===== interpreter start ===== */
top:
	if (my->child_lexp == 0 || my->child_lexp->ix == 0) return ERR_bye;	/* no script */
	my->sfllexp->sfp = 0;
	my->sfllexp->lexloc.file = 0;
	lexp = my->cmdlexp;
	rtc = setjmp(*(my->jmpbfp));
	if (rtc == 0) {
		/* R}h̎s */;
		/* ꎞgp̃Ă */
		if (my->tmpacp != 0) del_mactl(my->tmpacp);
		my->tmpacp = new_mactl();
		/* 擪̃R}hXNvgi܂̓R\[́js */
		if (lexp == 0 || lexp->sfp == 0) return ERR_bye;	/* no script */
		lexp->sfp->mbufix = 0;	/* gui macro ̎ŝߓǂݏoʒuZbg */
		lex_scan(MYc my->child_lexp);
		}
	else {
		/* G[R[h lex_scan I */
		flushall();
		/* ߂AωĂiHĵŖZbg */
		move_next_cmd(lexp,LINE_left);
		/* Ɨp̃g[Nobt@ */
		cmd = *((token*)(my->cmdlexp->cmd_tp));	/* Ō̃R}h͕ۊǂĂ */
		parge_allseg(my->tokacp);
		my->tokecp = new_entctl(my->tokacp,sizeof(token));
		}
	all_pop_mactl(my->sfllexp->acp_stk);
	all_pop_mactl(my->cmdlexp->acp_stk);
	/* 擪̃R}hkdw̃p[^ */

/* %%% */
	if (ec_test_mode == 0) lex_init_mode(my->cmdlexp);

	/*=== R}hs ===*/
	switch(rtc) {
	case 0:			/* lex_scan 琳 return  */
	case ERR_reset:	/* reset */
	case ERR_bye:	/* bye command | auto-BYE on command script EOF */
		break;
	default:
		if ((rtc >= ERR_ftl_top && rtc <= ERR_ftl_end) ||
			(rtc >= ERR_sys_top && rtc <= ERR_sys_end) ||
			(rtc >= ERR_usr_top && rtc <= ERR_usr_end) ) {
			/* %%%
			case ERR_fatal:
			case ERR_system:
			case ERR_user:
			*/

			if (lexp->sfp != 0           &&
				is_sinsrc(lexp->sfp) == 0 &&
				my->sfllexp != 0         &&
				my->sfllexp->sfp != 0
			) {
				lex* lexp = my->cmdlexp;
				/* SFL module `͏IĂȂ */
				put_script_err(lexp->claimfp    ,&cmd);
				put_script_err(open_error_file(),&cmd);
				}
			/* --------------------------------------------------
			if (lexp->permanent != 0) {
				fprintf(lexp->claimfp,"primary command error\n");
				return 1;
				}
			-------------------------------------------------- */
			}
			/* %%%
			case ERR_quit:
			*/

/* %%% 
		del_child_lex(my->child_lexp);
*/
		close_all_sfp(my->sfllexp);
		if (my->sfllexp->sflacp != 0) {
			/* SFL̒`ɃG[߁AŒ`o[ */
			delete_acp_member(my->declare_tp,my->sfllexp->sflacp);
			delete_acp_member(my->class_tp  ,my->sfllexp->sflacp);
			/* gpꊇԊ҂ */
			clear_sflacp(my->sfllexp);
			}
		close_filetag(my->sfllexp);

		if (my->sfllexp != 0 && my->sfllexp->errbuf) my->sfllexp->errbuf[0]=0;
		if (my->cmdlexp != 0 && my->cmdlexp->errbuf) my->cmdlexp->errbuf[0]=0;
		serr_buf[0] = 0;

/* %%% */
		if (ec_test_mode) goto top;
		del_child_lex(my->child_lexp);
		}
	clear_sflacp(my->cmdlexp);
	clear_sflacp(my->sfllexp);
	close_error_file();
	return rtc;
	}


/*===========================================================================*/
/*=====   SFL\[Xo͂ɎgpȂp̐ݒ                           =====*/
/*===========================================================================*/


static char* reserved_word = "reserved";


static int get_reserved(tMY) {
	static char* comment = "/#;\r\n";
	static char* delm = " =,\t\r\n";
	lex*     lexp = my->cmdlexp;
	hashtbl* hp   = my->rsv_hp;
	symbol*  sym;
	char*    fname;
	FILE*    rfp;
	char*    rdbuf;
	char*    valname;
	int c;
	int i;
	fname = full_file_name(NAME_FILE, my->ipath,reserved_word);
	rfp = fopen(fname,"rt");
	if (rfp == NULL) goto ret;
	/* sǂݍݗp̍ƃobt@m */
	rdbuf = new_mem(512);
	/* esƂɃZbgAbv */
	i = 0;
	while (fgets(rdbuf,510,rfp) != NULL) {
		/* Ώۂ̕ϐ擾 */
		valname = strtok(rdbuf,delm);
		while(valname != NULL) {
			c = valname[0];
			/* RgsH */
			if (strchr(comment,c) != NULL) break;
			sym = symbol_lookup(lexp,valname);
			sym2val_lookup(hp,sym,(long)++i,1);
			valname = strtok(NULL,delm);
			}
		}
	del_mem(rdbuf);
	fclose(rfp);
ret:
	get_looped_buf(-1);	/* parge looped_buf */
	return 1;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


char* cmd_exec_path;
char* check_keycode(void);
char* ini_ext = "ini";
#define ENV_PATH "PATH"


/* R}ĥpXT */

static char* get_ini_path(char* argv0) {
	enum { blen = 512 };
	char* iname;
	char* pname;
	char* fpath;
	char* env_path;
	bag_arr* bagp;
	int   c,i,j,k,no;
	int   with_path;
	iname = get_looped_buf(blen);
	/* R}h̃pX𒲍 */
	j = k = -1;
	with_path = 0;
	for (i = 0 ; i < blen ; ++i) {
		c = iname[i]= argv0[i];
		switch(c) {
		case 0:
			goto next;
		case fdelm_char:
			/* f~^̏ꏊL */
			j = i;
			/* f~^܂ł̂ŃpXtƔ */
			if (i == 0) with_path = 1;
			break;
		case ':':
			/* hCu܂ł̂ŃpXtƔ(MSDOS only) */
			if (i == 1) with_path = 1;
			break;
		case '.':
			/* gq̏ꏊL */
			k = i;
			}
		}
next:
	if (j < 0) {
		/* R}h̃pXw肪ĂȂ */
		cmd_exec_path = "";
		}
	else {
		cmd_exec_path = strdup(argv0);
		cmd_exec_path[j] = 0;
		}
	if (k > j && k != -1) i = k;		/* Ō̃f~^̌̊gq */
	sprintf(iname+i,".%s",ini_ext);		/* t@C */
	if (with_path) return iname;		/* pXtt@C */
	/* R}hɃpXw肪tĂȂ̂ŁAR}h̊i[ꏊT */
	env_path = getenv(ENV_PATH);		/* R}hTpX擾 */
	if (env_path == NULL) return iname;	/* dȂ̂Ńt@Ĉݓ */
	fpath = get_looped_buf(blen);
	bagp = str_tok_arr(env_path,PATH_DELM);
	if (bagp == 0) return iname;		/* dȂ̂Ńt@Ĉݓ */
	for (no = 0 ; no < bagp->ix ; ++no) {
		pname = bagp->ap[no];
		/* pX̎擾ɐ */
		i = strlen(pname);
		if (i > 2 && pname[i-1] == fdelm_char) pname[i-1] = 0;
		sprintf(fpath,"%s%c%s",pname,fdelm_char,argv0);
		/* %%% DEBUG printf("chk path = %s\n",fpath); */
		if (access(fpath,0) == 0) {
			/* R}h̊i[ꏊƔ */
			cmd_exec_path = strdup(pname);
			sprintf(fpath,"%s%c%s",pname,fdelm_char,iname);
			return fpath;
			}
		}
	del_mactl(bagp->acp);
	return iname;	/* dȂ̂Ńt@Ĉݓ */
	}


static char* authors = 
	"SFL parser:\n"
	"    Copyright (c) Datasight Corp., 1996-1999. All Rights Reserved.\n"
	"    programed by Akira Nakashima\n\n"
	;


ENTRY char* analize_arg(int* argcp, char*** argvp) {
	int    argc = *argcp;
	char** argv = *argvp;
	char** args;
	char*  ipath;
	int    i,j;
	args = (char**)new_mem(sizeof(char*)*argc);
	ipath = 0;
	j = 0;
	for (i = 1 ; i < argc ; ++i) {
		if (argv[i][0] == '-') {
			switch(argv[i][1]) {
#			if defined(CONSOLE)
			case 'k':
				/* L[R[heXg[h */
				check_keycode();
				exit(0);
#			endif defined(CONSOLE)
			case '?':
				if (argv[i][2] == '?') printf("%s",authors);
				else printf("version = %s\n",Version_no);
				exit(0);
			case 'v':
				gf_verify = 1;
				break;
			case 'i':
				if (argv[i][2] == 0) {
					if (++i < argc) ipath = argv[i];
					}
				else ipath = &(argv[i][2]);
				break;
				}
			continue;
			}
		args[j++] = argv[i];
		}
	*argcp = j;
	*argvp = args;
	/* ݒt@C̃pX */
	if (ipath == 0) ipath = get_ini_path(argv[0]);
	/* ipath  looped_bufȂ̂alloc */
	ipath = strdup(ipath);
	return ipath;
	}



/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


setup_parm cmd_ini[] = {
	sup_int(memadr_by_dec),
	sup_str(reserved_word),
	{0,0,0,0},
	};


