/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_lex.c
 *
 * Lexical analyzer functions.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */

#define PS_LEX_C
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_init_lex)
#	define Ex_init_lex(lexp)
#	endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if defined(SYSDBG)
#	define DEBUG 0
#else
#	define DEBUG 0
#	endif


/* ========================================================================= */
/* =====    include file path                                          ===== */
/* ========================================================================= */


static char  filedelm = fdelm_char;


/* ========================================================================= */
/* =====   Error message                                               ===== */
/* ========================================================================= */


ENTRY  int   ec_test_mode   = 0;
ENTRY  int   error_code     = 0;
static char* err_list_file  = "";
static char* err_pos_target = "";
static char* err_pos_fname  = "";
static int   err_pos_line   = 0;
static FILE* errlst_fp      = NULL;
static char* source_editor  = "";


ENTRY answer err_code_cmp(int rtc) {
	if (rtc == error_code) return GOOD;
	return FAIL;
	}


ENTRY FILE* lexp_errfp(lex*lexp) {
	return lexp->claimfp;
	}


ENTRY void lexp_errclr(lex* lexp) {
	if (lexp == 0) return;
	lexp->errbuf[0] = 0;
	}


ENTRY char* lexp_errbuf(lex* lexp) {
	char* buf;
	int i;
	if (lexp == 0) return get_looped_buf(512);
	else buf = lexp->errbuf;
	if (buf[0] == 0) return buf;
	for (i = 0 ; *buf != 0 && i < 256 ; ++i) ++buf;
	if (buf[-1] != '\n') *buf++ = '\n';
	return buf;
	}


ENTRY FILE* open_error_file(void) {
	if (*err_list_file == 0) return NULL;
	if (errlst_fp == NULL) errlst_fp = fopen(err_list_file,"wt");
	return errlst_fp;
	}


ENTRY void close_error_file(void) {
	char* buf;
	char* edit;
	int   acc;
	if (errlst_fp != NULL) {
		fclose(errlst_fp);
		if (err_pos_line != 0) {
			edit = str_tok(source_editor," @-%\t\r\n");
			if (edit == NULL) acc = 1;
			else acc = access(edit,0);		/* GfB^͓o^Ă邩H */
			buf = get_looped_buf(0);
			sprintf(buf,"%s %s %d",source_editor,err_pos_fname,err_pos_line);
			if (acc == 0) child_proc(buf);
			}
		}
	errlst_fp = NULL;
	err_pos_line = 0;
	}


/* ŏɕ\G[t@CL */


ENTRY void mark_err_pos(char* taget, symcate* filc, int line) {
	if (err_pos_line != 0) return;
	if (filc == 0 || filc->cate != READ_FILE) return;
	err_pos_target = taget;
	err_pos_fname  = symcate_name(filc);
	err_pos_line   = line ;
	}


/* ========================================================================= */


ENTRY int source_position(FILE* cfp, char* name, fileloc* locp) {
	symcate*     file;
	unsigned int line;
	if (locp == 0) return 0;
	file = locp->file;
	line = locp->line;
	if (name == 0 || name[0] == 0) name = "";
	fprintf(cfp,"%s (%s -%d)",name,symcate_name(file),line);
	mark_err_pos(name,file,line);
	return 1;
	}


ENTRY void put_source_back(FILE* cfp, fileloc* locp) {
	int i;
	if (cfp == NULL || locp == 0) return;
	fprintf(cfp,"    backtrace as :\n");
	for (i = 1 ; locp != 0 && locp->file != 0 ; ) {
		if 	(locp->file->cate == READ_FILE) {
			fprintf(cfp,"    (%2d)",i);
			source_position(cfp, "",locp);
			fprintf(cfp,"\n");
			++i;
			}
		locp = locp->parent;	/* back link */
		}
	}


ENTRY void error_type(FILE* cfp, int rtc) {
	if (cfp == NULL) return;
	if (rtc >= ERR_sys_top && rtc <= ERR_sys_end) fprintf(cfp,"System ");
	fprintf(cfp,"Error : ");
	}


/* ----- */


static void put_lex_err(FILE* cfp, lex* lexp, int rtc) {
	fileloc* locp = &(lexp->lexloc);	/* G[ʒúA݈ʒugp */
	error_type(cfp,rtc);
	if (source_position(cfp,lexp->tokbuf,locp)) fprintf(cfp," : ");
	fprintf(cfp,"%s.\n" ,lexp->errbuf);
	put_source_back(cfp ,locp);
	}


ENTRY void lex_error(lex* lexp, int rtc) {
	error_code = rtc;
	end_wbuf(lexp);
	put_lex_err(lexp->claimfp    ,lexp,rtc);
	put_lex_err(open_error_file(),lexp,rtc);
	longjmp(**(lexp->jmpbfpp),rtc);
	}

ENTRY void lex_loc_err(lex* lexp, fileloc* locp,int rtc) {
	lexp->lexloc = *locp;
	lex_error(lexp, rtc);
	}


/* ========================================================================= */
/* =====   hash descriptor table                                       ===== */
/* ========================================================================= */


/* nbVe[uEGg̏}[Ni|C^j */

void* hash_del_mp = (void*)&hash_del_mp;


/* VKɃnbVe[u𐶐 */

ENTRY hashtbl* new_hashtbl(alloc_ctl* acp) {
	hashtbl* hp = new_alloc(acp,sizeof(hashtbl));
	hp->acp = acp;
	return hp;
	}


/* nbVe[ũGgg */

ENTRY void expand_hash_tbl(
	hashtbl* hp,					/* nbVe[uւ̃|C^ */
	size_t   init,					/* nbVe[ȕTCY */
	unsigned int (*hcode)(void*)	/* õnbVR[h擾֐ */
) {
	alloc_ctl* acp = hp->acp;
	unsigned int i,j;
	size_t newsiz;
	void** newtbl;
	/* Gĝ݂Q{ɂ */
	newsiz = size_doubler(hp->tblsiz,init);
	newtbl = (void**)new_segmem(acp, newsiz * sizeof(void*));
	/* ݂̃GgVe[u֓o^ */
	for (j = 0 ; j < hp->tblsiz ; ++j) {
		void* q;
		/* ݂̃GgPo */
		q = hp->tblpp[j];
		if (q == 0 || q == hash_del_mp) continue;
		/* ̃GgVe[u֓o^ */
		for (i = hcode(q) ; ; ++i) {
			i %= newsiz;
			if (newtbl[i] != 0) continue;
			newtbl[i] = q;
			break;
			}
		}
	/* ݂̃e[uԋp */
	if (hp->tblpp != 0) del_segmem(acp,hp->tblpp);
	/* Ve[ugp */
	hp->tblsiz = newsiz;
	hp->tblpp = (void**)newtbl;
	}


/* nbVe[uRs[ */


ENTRY hashtbl* dup_hash_table(
	alloc_ctl* acp,
	hashtbl* ohp,						/* nbVe[uւ̃|C^ */
	void* (*dcopy)(alloc_ctl*,void*)	/* õRs[֐ */
) {
	hashtbl* nhp = new_alloc(acp,sizeof(*nhp));
	unsigned int j;
	size_t newsiz;
	void** newtbl;
	newsiz = ohp->tblsiz;
	newtbl = (void**)new_segmem(acp, newsiz * sizeof(void*));
	for (j = 0 ; j < newsiz ; ++j) {
		void* q;
		q = ohp->tblpp[j];
		if (q == 0 || q == hash_del_mp) continue;
		newtbl[j] = dcopy(acp,q);
		}
	nhp->tblsiz = newsiz;
	nhp->tblpp = (void**)newtbl;
	return nhp;
	}


/* nbVe[uNAiGg̓ê̂ɂ́A֗^Ȃj */


ENTRY void clear_hash_table(hashtbl* hp) {
	unsigned int j;
	size_t newsiz;
	newsiz = hp->tblsiz;
	for (j = 0 ; j < newsiz ; ++j) {
		 hp->tblpp[j] = 0;
		}
	}


ENTRY void delete_hash_entry(hashtbl* hp, void* delp, unsigned int ix) {
	unsigned int i;
	void* rp;
	/* ݓo^ĂGgP菜 */
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {
		ix %= hp->tblsiz;
		rp = hp->tblpp[ix];
		if (rp == 0) break;
		if (rp == delp) {
			hp->tblpp[ix] = hash_del_mp;
			hp->tblent--;
			break;
			}
		}
	}


/* ========================================================================= */
/* =====    symbol descriptor table                                    ===== */
/* ========================================================================= */


static symbol* new_symbol(alloc_ctl* acp, char* word, unsigned int code) {
	symbol* dp = new_alloc(acp, sizeof(*dp));
	dp->name = str_dup(acp,word);
	dp->code = code;
	return dp;
	}


static unsigned int symbol_hcode(void* q) {
	return ((symbol*)q)->code;
	}


/* SĂ̕V{if[^jɕϊ */

ENTRY symbol* symbol_lookup(lex* lexp,char *word) {
	hashtbl* hp = lexp->symhash;
	alloc_ctl* acp = hp->acp;
	unsigned int hashcode;			/* hashcode index */
	unsigned int add;
	char* tp;
	char  c;
	unsigned int i,ix;
	if (word == 0) return 0;
	SYMBOL_PA(++(hp->lup_cnt));
	/* ̃nbVR[hvZivZ͓KF񖈂̃R[hUӐ}j */
	hashcode = 0;
	add = (c = *(tp = word)) << 8;
	while (c != '\0') {
		add += c;
		hashcode = (hashcode << 1) ^ c;
		c = *(++tp);
		}
	hashcode ^= (hashcode << 2) ^ (hashcode<< 8) ^ (add << 4) ^ (add << 12);
retry:
	ix = hashcode;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		symbol* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			/* nbVR[hw肷ʒuɂ́A */
			if (lexp->lup_only == 0) {
				/* uĂ邾vŖ΁AV{Ƃēo^ */
				++(hp->tblent);
				hp->tblpp[ix] = new_symbol(acp,word,hashcode);
				}
			return hp->tblpp[ix];
			}
		/* nbVR[hw肷ʒuɁAo^Ă̂ */
		if (p->code == hashcode && strcmp(p->name,word) == 0) return p;
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,100,symbol_hcode);
	goto retry;
	}


ENTRY void symbol_status(hashtbl* hp) {
	printf("symbol table status : siz=%d ent=%d", hp->tblsiz, hp->tblent);
	SYMBOL_PA(printf(" lup=%d try_cnt=%d", hp->lup_cnt, hp->try_cnt));
	printf("\n");
	}


/* ========================================================================= */
/* =====    symbol category descriptor table                           ===== */
/* ========================================================================= */


#undef  def_cate
#define def_cate(s,c) case c: return s;


ENTRY char* symcate_type_name(symcate* sp) {
	int cate;
	if (sp == 0) cate = 0;
	else cate = sp->cate;
	switch(cate) {
	all_cate 
		}
	return "(unknown)";
	}


ENTRY char* symcate_name(symcate* sp) {
	if (sp == 0 || sp->sym == 0) return "(null)";
	return sp->sym->name;
	}


static symcate* new_symcate(alloc_ctl* acp, symbol* sym, int cate) {
	symcate* dp = new_alloc(acp, sizeof(*dp));
	dp->sym = sym;
	dp->cate = cate;
	return dp;
	}

static unsigned int symcate_hcode(void* q) {
	return ((symcate*)q)->sym->code;
	}


ENTRY symcate* symcate_lookup(lex* lexp, symbol* sym, int cate) {
	hashtbl* hp = lexp->catehash;
	alloc_ctl* acp = hp->acp;
	unsigned int i,ix;
	if (sym == 0) return 0;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		symcate* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			if (cate == 0) return 0;
			++(hp->tblent);
			hp->tblpp[ix] = new_symcate(acp,sym,cate);
			return hp->tblpp[ix];
			}
		if (p->sym == sym && p->cate == cate) return p;
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,10,symcate_hcode);
	goto retry;
	}


/* ========================================================================= */
/* =====    symbol to value hash table access                          ===== */
/* ========================================================================= */


static unsigned int sym2val_hcode(void* q) {
	return ((sym_val*)q)->sym->code;
	}


ENTRY sym_val* sym2val_lookup(hashtbl* hp,symbol* sym,long value,int regist) {
	unsigned int i,ix;
	if (sym == 0) return 0;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		sym_val* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			if (regist == 0) return 0;
			++(hp->tblent);
			p = new_alloc(hp->acp,sizeof(sym_val));
			p->sym = sym;
			p->value = value;
			hp->tblpp[ix] = p;
			return p;
			}
		if (p->sym == sym) {
			return p;
			}
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	if (regist == 0) return  0;
	expand_hash_tbl(hp,10,sym2val_hcode);
	goto retry;
	}


ENTRY hashtbl* teach_key_word(lex* lexp, key_word* tbl) {
	alloc_ctl* acp;
	hashtbl*   hp;
	symbol*    sym;
	int i;
	if (tbl == 0) return 0;
	acp = lexp->acp;
	hp = new_hashtbl(acp);
	for (i = 0 ; tbl[i].word[0] != 0 ; ++i) {
		sym = symbol_lookup(lexp,tbl[i].word);
		sym2val_lookup(hp,sym,(long)tbl[i].key,1);
		}
	return hp;
	}





/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY uni_link* new_uni_link(alloc_ctl* acp, void* ap, uni_link* np) {
	uni_link* lp = new_alloc(acp, sizeof(*lp));
	lp->ap = ap;
	lp->np = np;
	return lp;
	}


/* ========================================================================= */
/* =====    Macro word hash table access                               ===== */
/* ========================================================================= */


static unsigned int macro_hcode(void* q) {
	return ((macro*)q)->macsym->code;
	}


static void* macro_dcopy(alloc_ctl* acp,void* q) {
	macro* p;
	/* V}NZP */
	p = new_alloc(acp, sizeof(*p));
	*p = *((macro*)q);
	p->string = str_dup(acp,p->string);
	return (void*)p;
	}


ENTRY macro* macro_lookup(alloc_ctl* acp, hashtbl** hpp, symbol* sym, char* string) {
	hashtbl* hp;
	unsigned int i,ix;
	if (sym == 0) return 0;
	if (*hpp == 0) {
		*hpp = new_hashtbl(acp);
		}
	hp = *hpp;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {/* 1'st time : hp->tblsiz == 0 */
		macro* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			if (string == 0) return 0;		/* QƂ */
			++(hp->tblent);
			/* V}NZP */
			p = new_alloc(acp, sizeof(*p));
			p->macsym = sym;
			p->string = str_dup(acp,string);
			/* V}NZo^ */
			hp->tblpp[ix] = p;
			return p;
			}
		if (p->macsym == sym) {
			/* }N̈vo */
			if (string == 0) {
				/* QƂĂ邾Ȃ̂ŁAe𓚂 */
				if (p->string == 0) return 0;
				return p;
				}
			if (string == hash_del_mp) {
				/* o^̍폜Ȃ̂ŁAe */
				del_segmem(acp, p->string);
				p->string = 0;
				return 0;
				}
			if (p->string != 0) {
				/* ɓo^Ă */
				if (strcmp(p->string,string) == 0) return p;
				return 0;
				}
			/* Vw肵̂Ɠeւ */
			/* del_segmem(acp, p->string); */
			p->string = str_dup(acp,string);
			return p;
			}
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,100,macro_hcode);
	goto retry;
	}


static int macro_comp(q_CONST void* m1, q_CONST void* m2) {
	return str_comp((*(macro**)m1)->macsym->name,(*(macro**)m2)->macsym->name);
	}


ENTRY void tell_macro(lex* lexp, hashtbl* hp, char* defcmd) {
	unsigned int i;
	macro** list;
	macro*  p;
	char*   np;
	int cnt;
	if (hp == 0) return;
	cnt = 0;
	for (i = 0 ; i < hp->tblsiz ; ++i) {
		p = hp->tblpp[i];
		if (p != 0) cnt++;
		}
	if (cnt == 0) return;
	list = (macro**)new_mem(sizeof(macro*)*cnt);
	cnt = 0;
	for (i = 0 ; i < hp->tblsiz ; ++i) {
		p = hp->tblpp[i];
		if (p != 0) {
			if (p->string[0] != 0) list[cnt++] = p;
			}
		}
	qsort((void*)list, cnt, sizeof(macro*), macro_comp);
	for (i = 0 ; i < (uint)cnt ; ++i) {
		p = list[i];
		np = p->macsym->name;
		if (*np == '$') np++;
		fprintf(lexp->speakfp,"%s %s \"%s\"\n",defcmd,np,p->string);
		}
	del_mem(list);
	}


/* ========================================================================= */
/* =====    file name tag                                              ===== */
/* ========================================================================= */


/* gpt@Cʂ邽߂̃^Oixgp̂͑SċLj */


static filetag* new_filetag(alloc_ctl* acp, symcate* filc) {
	filetag* dp = new_alloc(acp, sizeof(*dp));
	dp->file = filc;
	return dp;
	}


/* ========================================================================= */
/* =====    file name hash table access                                ===== */
/* ========================================================================= */


static unsigned int filetag_hcode(void* q) {
	return ((filetag*)q)->file->sym->code;
	}


static filetag* filetag_lookup(lex* lexp,symcate* filc) {
	hashtbl*   hp  = lexp->filehash;
	alloc_ctl* acp = hp->acp;
	unsigned int i,ix;
	if (filc == 0) return 0;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = filc->sym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {	/* 1'st time : hp->tblsiz == 0 */
		filetag* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			++(hp->tblent);
			p = hp->tblpp[ix] = new_filetag(acp,filc);
			return p;
			}
		if (p->file == filc) return p;
		if (i > 10 && hp->tblent > hp->tblsiz/2) break;
		}
	expand_hash_tbl(hp,20,filetag_hcode);
	goto retry;
	}


static void dsp_filetag(lex* lexp) {
	hashtbl*   hp  = lexp->filehash;
	unsigned int i;
	for (i = 0 ; i < hp->tblsiz ; ++i) {	/* 1'st time : hp->tblsiz == 0 */
		filetag* p;
		p = hp->tblpp[i];
		if (p == 0) continue;

/*
	symcate* file;
	int      status;
	int      ref_cnt;
	FILE*    fp;
*/

		printf("%s\n",p->file->sym->name);
		}
	}


/* ========================================================================= */
/* =====  t@C̑dANZX𐧌䂷邽߂̊֐                   ===== */
/* ========================================================================= */


static FILE* fio_log(void) {
	static FILE* outfp = 0;
	if (outfp == 0) outfp = fopen("file_io.log","wt");
	return outfp;
	}


static int is_standard(FILE* fp) {
	if (fp == stdin || fp == stdout || fp == stderr) return 1;
	return 0;
	}


static int file_close(FILE* fp) {
	if (fp == 0) return 0;
	if (is_standard(fp)) return 0;
	if (fclose(fp) == 0) return 1;
	return 0;
	}


ENTRY void close_filetag(lex* lexp) {
	hashtbl* hp = lexp->filehash;
	unsigned int i;
	for (i = 0 ; i < hp->tblsiz ; ++i) {
		filetag* p;
		p = hp->tblpp[i];
		if (p == 0) continue;
		file_close(p->fp);
		p->status = 0;
		p->ref_cnt = 0;
		p->fp = 0;
		}
	}


#include<errno.h>


ENTRY FILE* file_control(
	lex* lexp,
	symcate* filc,		/* 䂷t@C */
	FILE* fp,			/* Ώۂt@Cł΂̃|C^ */
	int mode			/* ړI */
) {
	filetag* ftp;
	char*    ctl;
	char*    fn;
	/* w肳ꂽ̃t@CX^_[ht@CȂÂ܂܃Rs[ */
	if (is_standard(fp) != 0) return fp;
	ftp = filetag_lookup(lexp,filc);
	fn = filc->sym->name;
	switch(mode) {
	case 'r':
		/* ǂ݂Ƃt@ĆAgpȊO̓N[YĂ */
		if (ftp->fp != 0) {
			if (ftp->status == 'w' || ftp->status == 'a') {
				sprintf(lexp->errbuf,"already write (%s)",fn);
				/* %%% */
				lex_error(lexp,ERR_frd_stwt);
				}
			else {
				sprintf(lexp->errbuf,"read file unclosed link (%s)",fn);
				/* %%% */
				lex_error(lexp,ERR_frd_loop);
				}
			}
		ftp->status = 'r';
		fp = fopen(fn,"rb");
		if (fp == NULL) {
			sprintf(lexp->errbuf,"Can't open (%s)",fn);
			lex_error(lexp,ERR_user);
			}
		ftp->ref_cnt = 1;
		break;
	case 'w':
		ctl = "wt";
		goto wopn;
	case 'a':
		ctl = "at";
	wopn:
		if (ftp->fp != 0) {
			if (ftp->status == 'r') {
				sprintf(lexp->errbuf,"already open (%s)",fn);
				lex_error(lexp,ERR_user);
				}
			if (ftp->status != 'w') {
				sprintf(lexp->errbuf,"write file 1 re-open (%s)",fn);
				lex_error(lexp,ERR_user);
				}
			ftp->ref_cnt++;
			return ftp->fp;
			}
		ftp->status = 'w';
		fp = fopen(fn,ctl);
		if (fp == NULL) {
			sprintf(lexp->errbuf,"Can't write (%s)",fn);
			lex_error(lexp,ERR_user);
			}
		ftp->ref_cnt = 1;
		break;
	case 'c':
		/* ̃t@Cifpj́AKw肷邱 */
		if (fp == 0) return 0;
		if (ftp->ref_cnt > 0) {
			if (--(ftp->ref_cnt) == 0) {
				if (file_close(ftp->fp) == 0) {
					sprintf(lexp->errbuf,"Can't close (%s)",fn);
					lex_error(lexp,ERR_user);
					}
				ftp->status = 0;
				ftp->fp = fp = 0;
				}
			}
		break;
		}
	ftp->fp = fp;
	return fp;
	}


/* ========================================================================= */
/* =====   file path control                                           ===== */
/* ========================================================================= */


static char* replace_filedelm(char* fn) {
	char* buf = get_looped_buf(MAXPATHLEN);
	char delm2,c;
	int i;
	switch(filedelm) {
	case '/':
		delm2 = '\\';
		break;
	case '\\':
		delm2 = '/';
		break;
	default:
		return fn;
		}
	for (i = 0 ; i < MAXPATHLEN-1 ; ++i) {
		if ((c = fn[i]) == 0) break;
		if (c == delm2) c = filedelm;
		buf[i] = c;
		}
	buf[i] = 0;
	return buf;
	}


/* JgpX̎擾A܂́AJgpX \ -> \\ ϊA */


ENTRY char* cwd_path(char* cp) {
	char* path = get_looped_buf(MAXPATHLEN);
	char c;
	int i;
	if (cp == 0) {
		/* JgpX̎擾 */
		cp = getwd(path);
		if (cp == NULL) return "";
		cp = replace_filedelm(cp);
		}
	else {
		/* JgpX \ -> \\ ϊA MS-DOS(chdir)p */
		cp = replace_filedelm(cp);
		if (filedelm == '\\') {
			for (i = 0 ; i < MAXPATHLEN-2 ; ++i) {
				if ((c = *cp++) == 0) break;
				path[i] = c;
				if (c == '\\') path[++i] = '\\';
				}
			path[i] = 0;
			return path;
			}
		}
	return cp;
	}


ENTRY void file_suspend(source* sfp) {
	if (sfp == 0) return;
	sfp->s_loc = sfp->lexp->lexloc;
	if (is_file(sfp) == 0) return;
	if (sfp->suspend) return;
	if (sfp->fp == NULL) return;
	sfp->readloc = ftell(sfp->fp);
	sfp->fp = file_control(sfp->lexp, sfp->loc.file, sfp->fp, 'c');
	/* close ̎́Astdin̉\̂Ŏw     ^^^^^^^     */
	sfp->suspend = 1;
	}


ENTRY void file_restart(source* sfp) {
	if (sfp == 0) return;
	sfp->lexp->lexloc  = sfp->s_loc;
	if (is_file(sfp) == 0) return;
	if (sfp->suspend == 0) return;
	sfp->suspend = 0;
	sfp->fp = file_control(sfp->lexp, sfp->loc.file, sfp->fp, 'r');
	/* OƓ́istdinjopen̂Ŏw     ^^^^^^^     */
	fseek(sfp->fp,sfp->readloc,0);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY fileloc* new_fileloc(alloc_ctl* acp, fileloc* locp) {
	fileloc* lp = new_alloc(acp,sizeof(*lp));
	*lp = *locp;
	return lp;
	}


/* ========================================================================= */
/* =====   source file descriptor table                                ===== */
/* ========================================================================= */


ENTRY source* new_source(
	lex*   lexp,	/* ̃\[XĂяo cmdlexp */
	lex*   lnkp,	/* ̃\[X͂߂̊ sfllexp */
	int    typ,		/* ̃\[X̎ */
	void*  srcp,	/* ̃\[X̎wq */
	char   mackey,	/* }N̐擪w */
	int    argc,	/* ̃\[X̃A[Mg̐ */
	char** args		/* ̃\[X̃A[Mg */
) {
	enum{ ungsiz = 100 };
	alloc_ctl* acp;
	char*   fn;
	macro*  mp;
	int     len;
	char*   buf;
	symbol* sym;
	source* sfp;

	/* ̃\[X̉͗pɃGA蓖Ă */
	acp = new_mactl();
	/* ̃\[X̊ǗGA蓖Ă */
	sfp = new_alloc(acp,sizeof(*sfp));
	sfp->acp = acp;
	sfp->lexp = lnkp;
	sfp->blkecp = new_entctl(acp,sizeof(drct_blk));
	switch(typ) {
	case READ_FILE:
		fn = (char*)srcp;
		len = strlen(fn) + 1;
		buf = get_looped_buf(len);
		memcpy(buf,srcp,len);
		buf = replace_filedelm(buf);
		sym = symbol_lookup(lexp,buf);
		sfp->loc.file = symcate_lookup(lexp,sym,typ);
		sfp->fp = file_control(lexp, sfp->loc.file, 0, 'r');
		/*        Kt@CȂ̂łOw       ^^^     */
		if (sfp->fp != NULL) break;
		sprintf(lexp->errbuf,"Can't open (%s)",fn);
		del_mactl(sfp->acp);
		lex_error(lexp,ERR_user);
		break;
	case READ_TTY:
	case READ_STDIN:
		/* console type source */
		sfp->loc.file = symcate_lookup(lexp,STDin,typ);
		sfp->fp = stdin;
		break;
	case READ_MACRO:
	case READ_TPL:
	case READ_GUI:
	case READ_SUP:
		/* }ŇĂяo */
		mp = (macro*)srcp;
		if (mp->inuse != 0) {
			sprintf(lexp->errbuf,"looped macro (%s)",mp->macsym->name);
			del_mactl(sfp->acp);
			lex_error(lexp,ERR_user);
			}
		mp->inuse   = 1;
		sfp->macp   = mp;
		sfp->loc.file = symcate_lookup(lexp,mp->macsym,typ);
		sfp->string = mp->string;
		sfp->mbufix = 0;
		break;
	default:
		sprintf(lexp->errbuf,"illegal file (typ=%d)",typ);
		del_mactl(sfp->acp);
		lex_error(lexp,ERR_user);
		}
	/* \[Xt@CɕtĂ}No^ */
	if (args != 0) {
		char buf[16];
		int  i;
		for (i = 0 ; i < argc ; ++i) {
			sprintf(buf,"%c%d",mackey,i);
			sym = symbol_lookup(lnkp,buf);
			macro_lookup(acp,&(sfp->machash),sym,args[i]);
			}
		sprintf(buf,"%d",argc);
		sym = symbol_lookup(lnkp,"ARGC");
		mp = macro_lookup(acp,&(sfp->machash),sym,buf);
		mp->machash = sfp->machash;
		}
	sfp->ungbuf = new_alloc(acp, sizeof(int)*ungsiz);
	sfp->ungbsz = ungsiz;
	sfp->ungbix = 0;
	sfp->ungword = new_bag(acp);
	/* file link */
	file_suspend(lnkp->sfp);
	sfp->rfp  = lnkp->sfp;
	lnkp->sfp = sfp;
	if (lnkp->sflacp == 0) lnkp->sflacp = new_mactl();
	if (lnkp->lexloc.file != 0) {
		sfp->loc.parent = new_fileloc(lnkp->sflacp,&(lnkp->lexloc));
		}
	sfp->loc.line   = 1;
	lnkp->lexloc = sfp->loc;
	return sfp;
	}


static void del_source(source *sfp) {
	if (sfp == 0) return;
	if (sfp->permanent) return;
	if (is_macsrc(sfp)) {	
		/* release macro */
		sfp->macp->inuse = 0;	/* }Nf[^͍̂̂Ďgp */
		}
	if (sfp->fp != 0 && is_sinsrc(sfp) == 0) {
		sfp->fp = file_control(sfp->lexp, sfp->loc.file, sfp->fp, 'c');
		/* close ̎́Astdin̉\̂Ŏw     ^^^^^^^     */
		}
	del_mactl(sfp->acp);
	}


ENTRY int is_sinsrc(source* sfp) {
	if (sfp == 0) return 0;
	switch(sfp->loc.file->cate) {
	case READ_STDIN:
	case READ_TTY  :
		return 1;
		}
	return 0;
	}


ENTRY int is_tty(source* sfp) {
	if (sfp == 0) return 0;
	switch(sfp->loc.file->cate) {
	case READ_TTY  :
		return 1;
		}
	return 0;
	}


ENTRY int is_file(source* sfp) {
	if (sfp == 0 || sfp->tpl_tap != 0) return 0;
	switch(sfp->loc.file->cate) {
	case READ_FILE  :
		return 1;
		}
	return 0;
	}


ENTRY int is_macsrc(source* sfp) {
	if (sfp == 0) return 0;
	switch(sfp->loc.file->cate) {
	case READ_MACRO:
	case READ_TPL:
	case READ_EVAL :
	case READ_GUI  :
	case READ_SUP  :
		return 1;
		}
	return 0;
	}


ENTRY int is_template(source* sfp) {
	if (sfp == 0) return 0;
	if (sfp->tpl_tap != 0) return 1;
	return 0;
	}


ENTRY int is_eval(source* sfp) {
	if (sfp == 0) return 0;
	switch(sfp->loc.file->cate) {
	case READ_EVAL  :
		return 1;
		}
	return 0;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static char* sfl_lib_dir = "/usr/par/sfl_lib.dir";


/* ===== include file descriptor table ===== */


static char* trim_pathname(char* fname) {
	char* iname;
	int i;
	i = strlen(fname);
	iname = get_looped_buf(i);
	sprintf(iname,"%s",fname);
	for (--i ; i >= 0 ; --i) {
		if (iname[i] == filedelm) break;
		}
	iname[i] = 0;
	return iname;
	}


ENTRY char* full_file_name(int ptype, char* fpath, char* fname) {
	char* iname;
	int   plen;
	int   flen;
	int   i;
	fname = replace_filedelm(fname);
	plen  = (fpath != 0) ? strlen(fpath) : 0;
	flen  = strlen(fname);
	iname = get_looped_buf(plen + flen + 2);
	if ( (fname[0] == filedelm) ||			/* [g̐΃pXw */
		 (fpath == 0)           ||			/* pXw肳ĂȂ */
		 (flen > 1 && fname[1] == ':') ) {	/* t@CɃhCu܂ł */
		sprintf(iname,"%s",fname);
		}
	else {
		/* pXהi܂Ȃjɏ悹 */
		sprintf(iname,"%s",fpath);
		/* pXo */
		if (ptype == NAME_PATH) {
			/* fpath ̓pX݂̂AŌɃf~^ꍇ́A */
			i = plen;
			if (i > 0 && iname[i-1] == filedelm) --i;
			}
		else {
			/* fpath ̓pXtt@CȂ̂ŁAŌ̃t@C */
			for (i = plen-1 ; i >= 0 ; --i) {
				if (iname[i] == filedelm) break;
				}
			}
		/* opXƃt@C */
		if (i >= 0) {
			/* pX̂ŁApXtt@Cł */
			sprintf(&iname[i],"%c%s",filedelm,fname);
			}
		else {
			/* pXȂ̂ŁAt@Cŉ䖝 */
			sprintf(iname,"%s",fname);
			}
		}
	return iname;
	}


ENTRY source* new_include(
	lex*  lexp,
	int   sel_dir,
	char* fname,
	char   mackey,
	int    argc,
	char** args
) {
	char* iname;
	char* pname;
	source* ifp;
	source* sfp;
	int   i;
	sfp = lexp->sfp;
	if (sel_dir == '<' || sfp == 0) {
		bag_arr* bagp;
		/* sfl_lib_dirɕ̃pXo^̂ŕ񒲂ׂ */
		ifp = 0;
		iname = fname;		/* G[΍ */
		bagp = str_tok_arr(sfl_lib_dir,PATH_DELM);
		if (bagp != 0) {
			int no;
			for (no = 0 ; no < bagp->ix ; ++no) {
				pname = bagp->ap[no];
				/* pX̎擾ɐ */
				i = strlen(pname);
				if (i > 2 && pname[i-1] == fdelm_char) pname[i-1] = 0;
				iname = full_file_name(NAME_PATH, pname, fname);
				if (access(iname,0) != 0) {
					if (no < bagp->ix -1) continue;
					}
				ifp = new_source(lexp,lexp,READ_FILE,iname,mackey,argc,args);
				if (ifp != 0) break;
				}
			del_mactl(bagp->acp);
			}
		}
	else {
		iname = full_file_name(NAME_FILE, symcate_name(sfp->loc.file), fname);
		ifp = new_source(lexp,lexp,READ_FILE,iname,mackey,argc,args);
		}
	if (ifp == 0) {
		sprintf(lexp->errbuf,"include file missing (%s)",iname);
		lex_error(lexp,ERR_user);
		}
	return ifp;
	}


ENTRY void del_include(source* ifp) {
	source* rfp;
	lex* lexp;
	if (ifp == 0) return;
	if (ifp->permanent) return;
	rfp = ifp->rfp;
	lexp = ifp->lexp;
	if (lexp == 0) {
		del_source(ifp);
		return;
		}
	lexp->sfp = rfp;
	del_source(ifp);
	file_restart(rfp);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


/* ===== lexical analyzer descriptor table ===== */


ENTRY void lex_init_mode(lex* lexp) {
	lexp->newline    = 1;
	lexp->meta_off   = 0;
	lexp->eof_ng     = 0;
	lexp->in_drct    = 0;
	lexp->macro_ctl  = MAC_SYM;
	lexp->save_dol   = 0;
	lexp->prefix     = 0;
	lexp->skip_spc   = 1;
	lexp->skip_nl    = 1;
	lexp->skip_chr   = 1;
	lexp->lup_only   = 0;
	lexp->cmdlast    = 0;	/* R}hs̍ŏIo^ */
	lexp->tplhash    = 0;
	if (lexp->sfp == 0) {
		memset(&(lexp->tokloc),0,sizeof(lexp->tokloc));
		lexp->lexloc = lexp->tokloc;
		}
	}


ENTRY lex* new_lex(lex* p_lexp) {
	alloc_ctl* acp;
	lex* lexp;
	/* ̃\[X̉͗pɃGA蓖Ă */
	acp = new_mactl();
	/* ̃\[X̊ǗGA蓖Ă */
	lexp = new_alloc(acp,sizeof(*lexp));
	*lexp = *p_lexp;
	lexp->sfp = 0;
	lex_init_mode(lexp);
	if (p_lexp->machash != 0) {		/* }N`e[u */
		lexp->machash = dup_hash_table(acp,p_lexp->machash,macro_dcopy);
		}
	lexp->acp = acp;
	lexp->sflacp = 0;
	lexp->tbufsz = 0;	/* tokenobt@̃TCY */
	lexp->tbufix = 0;	/* tokenobt@|C^ */
	lexp->tokbuf = 0;	/* token͎Ɏgptokenobt@ */
	lexp->cmd_tp = 0;	/* R}h̉̓g[N */
	lexp->consor = 0;	/* R\[͈pȂ */
	lexp->argl = 0;
	lexp->argc = 0;
	lexp->args = 0;
	lexp->a_ix = 0;
	lexp->child_lexp = new_bag(acp);
	lexp->acp_stk    = new_bag(acp);
	Ex_init_lex(lexp);
	return lexp;
	}


ENTRY void close_all_sfp(lex* lexp) {
	source* sfp;
	source* rfp;
	filetag* ftp;
	if (lexp == 0) return;
	for (sfp = lexp->sfp ; sfp != 0 ; sfp = rfp) {
		rfp = sfp->rfp;
		if (sfp->permanent) {
			sfp->ungbix = 0;
			lexp->sfp = sfp;
			sfp->rfp = 0;
			sfp->ungbix = 0;
			sfp->ungword->ix = 0;
			lexp->lexloc = sfp->loc;
			return;	/* W͂c */
			}
		ftp = filetag_lookup(lexp,sfp->loc.file);
		if (ftp->ref_cnt > 1) ftp->ref_cnt = 1;
		del_source(sfp);
		}
	/* SĂ source 폜 */
	lexp->sfp = 0;
	lex_init_mode(lexp);
	}


/* static void f_Del_word_dict(word_dict* rdp); */


	void del_child_lex(bag_arr* bagp);



ENTRY void clear_sflacp(lex* lexp) {
	if (lexp->sflacp == 0) return;
	del_mactl(lexp->sflacp);
	lexp->sflacp = 0;
	}


ENTRY void delete_lex(lex* lexp) {
	if (lexp == 0) return;
	del_child_lex(lexp->child_lexp);
	close_all_sfp(lexp);
	if (lexp->permanent != 0) {
		lexp->suspend = 0;	/* G[̔ɃR\[𓮂 */
		return;
		}
	lexp->speakfp = file_control(lexp, lexp->speakfn, lexp->speakfp, 'c');
	/* close ̎́Astdin̉\̂Ŏw      ^^^^^^^^^^^^^     */
	lexp->claimfp = file_control(lexp, lexp->claimfn, lexp->claimfp, 'c');
	/* close ̎́Astdin̉\̂Ŏw      ^^^^^^^^^^^^^     */

	/* lexNO */
	if (lexp->parent != 0) {
		remove_bag_que(lexp->parent->child_lexp,lexp,cmp_void_ptr);
		}
	all_pop_mactl(lexp->acp_stk);
	clear_sflacp(lexp);
	/* lexp̃GAԋp */
	del_mactl(lexp->acp);
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY void del_child_lex(bag_arr* bagp) {
	lex* lexp = 0;
	int i = 0;
	for(;;) {
		if (i >= bagp->ix) break;
		if (lexp == (lex*)(bagp->ap[i])) {
			++i;
			continue;
			}
		lexp = (lex*)(bagp->ap[i]);
		delete_lex(lexp);
		}
	}


ENTRY lex* fork_child(lex* lexp) {
	lex* nlexp;
	nlexp = new_lex(lexp);

	nlexp->drct_hp  = lexp->drct_hp;		/* fBNeBu̎ */
	nlexp->opr_tblp = lexp->opr_tblp;		/* Iy[VL̎ */
	/* bZ[Wo͐ */
	nlexp->speakfn  = lexp->speakfn ;
	nlexp->speakfp  = file_control(lexp, lexp->speakfn, lexp->speakfp, 'a');
	/*@@@ eƓ̂gp̂ŁAKw肷 ^^^^^^^^^^^^^     */
	/* G[bZ[Wo͐ */
	nlexp->claimfn  = lexp->claimfn ;
	nlexp->claimfp  = file_control(lexp, lexp->claimfn, lexp->claimfp, 'a');
	/*@@@ eƓ̂gp̂ŁAKw肷 ^^^^^^^^^^^^^     */
	nlexp->parent = lexp;
	nlexp->lex_path = symbol_lookup(nlexp,trim_pathname(symcate_name(nlexp->lexloc.file)));
	/* V lex ̍쐬̂ŁAeɓo^ */
	append_bag_que(lexp->child_lexp,nlexp);
	return nlexp;
	}


/* ========================================================================= */
/* =====   Get word from the source file                               ===== */
/* ========================================================================= */


static void dsp_prompt(lex* lexp) {
	if (lexp->prompt && lexp->cmdlast != ';' && is_tty(lexp->sfp)) {
		printf("SFL> ");
		lexp->prompt = 0;
		}
	}


	extern char* block_name(drct_blk* blkp);


ENTRY void source_chain_back(lex* lexp) {
	source* sfp = lexp->sfp;
	drct_blk* blkp;
	if (sfp == 0 || sfp->rfp == 0) {
		longjmp(**(lexp->jmpbfpp),ERR_eof);
		}
	blkp = sfp->drctblkp;
	if (blkp == 0) goto ret;
	switch (blkp->within) {
	case BLK_grand :
	case BLK_if    :
	case BLK_else  :
		break;
	default:
		/* ubN̉ߒł */
		sprintf(lexp->errbuf,"still in '%s' block id=%d",block_name(blkp),blkp->id_no);
		lex_error(lexp,ERR_user);
		}
ret:
	del_include(sfp);
	dsp_prompt(lexp);
	}


#if defined(CONSOLE)
	static int ungcons_buf[16];
	static int ungcons_ix = 0;
#	endif defined(CONSOLE)


static void unget_c(int c,source* sfp) {
#	if defined(CONSOLE)
	if (is_tty(sfp)) {
		if (ungcons_ix >= 16) {
			sprintf(sfp->lexp->errbuf,"unget_c buffer full");
			lex_error(sfp->lexp,ERR_system);
			}
		ungcons_buf[ungcons_ix++] = c;
		}
	else 
#	endif defined(CONSOLE)
	ungetc(c,sfp->fp);
	}


extern char* get_cmdline(void**);


static int get_c(source* sfp) {
#	if defined(CONSOLE)
	static char* sp = 0;
	int c;
	if (is_tty(sfp)) {
		if (ungcons_ix > 0) return ungcons_buf[--ungcons_ix];
		if (sp == 0) sp = get_cmdline(&(sfp->lexp->consor));
		c = *sp++;
		if (c == '\n' || c == 0) {
			c = '\n';
			sp = 0;
			}
		return c;
		}
#	endif defined(CONSOLE)
	return getc(sfp->fp);
	}


static void expand_unget_buf(lex* lexp) {
	source* sfp  = lexp->sfp;
	size_t bufsiz= size_doubler(sfp->ungbsz,100);
	sfp->ungbuf  = (int*)resize_segmem(
		sfp->acp,sfp->ungbuf,
		sfp->ungbsz * sizeof(int),
		bufsiz * sizeof(int)
		);
	sfp->ungbsz  = bufsiz;
	}


#define mac_un_nl(lexp,c) if((c)=='\n'){\
	lexp->newline=0;if(lexp->lexloc.line>0)--(lexp->lexloc.line);\
	}


#define mac_un_c(lexp,c) {\
	if (lexp->sfp->ungbix >= lexp->sfp->ungbsz) expand_unget_buf(lexp);\
	lexp->sfp->ungbuf[lexp->sfp->ungbix++]=(c);\
	}


#define mac_un_inp(lexp,c) {\
	mac_un_nl(lexp,c)\
	mac_un_c(lexp,c);\
	}

static void expand_token_buf(lex* lexp) {
	size_t bufsiz = size_doubler(lexp->tbufsz,100);
	lexp->tokbuf  = (char*)resize_segmem(lexp->acp,lexp->tokbuf,lexp->tbufsz,bufsiz);
	lexp->tbufsz  = bufsiz;
	}

#define mac_setwbuf(lexp,c) {\
	if (lexp->tbufix >= lexp->tbufsz) expand_token_buf(lexp);\
	lexp->tokbuf[lexp->tbufix++] = (char)(c);\
	}

#define mac_endwbuf(lexp) {\
	if (lexp->tbufix >= lexp->tbufsz) expand_token_buf(lexp);\
	lexp->tokbuf[lexp->tbufix] = (char)(0);\
	}


ENTRY void uninp(lex* lexp,int c) mac_un_inp(lexp,c)
ENTRY void set_wbuf(lex* lexp,int c) mac_setwbuf(lexp,c)
ENTRY void end_wbuf(lex* lexp) mac_endwbuf(lexp)


static void unget_char(lex *lexp, int c) {
	word_loc word;
	mac_un_nl(lexp,c);
	word.code  = c;
	word.wordp = 0;
	word.loc = lexp->lexloc;
	push_value_in_bag(lexp->sfp->ungword, &word, sizeof(word));
	}


ENTRY void unget_word(lex *lexp, int tc, char* wordp, fileloc* locp) {
	source* sfp = lexp->sfp;
	word_loc word;
	int i;
	if (tc == LEX_STR) {
		/* PȂ镶ȂAƂĕԋp */
		for (i = strlen(wordp) - 1 ; i >= 0 ; --i) {
			unget_char(lexp,wordp[i]);
			}
		return;
		}
	/* ԋp΁AɊi[ */
	for (i = 0 ; i < sfp->ungbix ; ++i) {
		unget_char(lexp, sfp->ungbuf[i]);
		}
	sfp->ungbix = 0;
	if (tc == LEX_EOF) {
		word.code  = EOF;
		word.wordp = 0;
		}
	else {
		word.code  = tc;
		word.wordp = wordp;
		}
	word.loc   = *locp;
	push_value_in_bag(sfp->ungword, &word, sizeof(word));
	}


static macro* macro_source(lex* lexp) {
	symbol* sym;
	macro*  mac;
	source* sfp;
	source* ifp;
	drct_blk* blkp;
	int     save_mac_ctl;
	int     ix;
	if ((ix = lexp->mac_ix) == lexp->tbufix) return 0;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	sfp = lexp->sfp;
	lexp->tokbuf[lexp->tbufix] = 0;
	sym = symbol_lookup(lexp,&(lexp->tokbuf[ix]));
	mac = 0;

	/* ev[ggp̃ev[ǧ */
	if (lexp->tplhash != 0) {
		mac = macro_lookup(sfp->acp,&(lexp->tplhash),sym,0);
		if (mac != 0) {
			if (mac->string[0] == 0) {
				/* ́A܂o^ĂȂiev[g̓o^j */
				mac = 0;
				ix = lexp->tbufix;
				goto ret;
				}
			/* o^Ă */
			ifp = new_source(lexp,lexp,READ_MACRO,mac,'$',0,0);
			if (ifp == 0) {
				sprintf(lexp->errbuf,"macro missing (%s)",sym->name);
				lex_error(lexp,ERR_user);
				}
			goto ret;
			}
		}

	/* fBNeBuϐ̌ */
	if (seek_drct_value(lexp,sym,&blkp,&mac) != 0) goto read;

	/* }NEA[Mgi|ǰ */
	if (sfp->machash != 0) {
		mac = macro_lookup(sfp->acp,&(sfp->machash),sym,0);
		}
	if (mac == 0) {
		source* ffp;
		/* t@CEA[Mgi|ǰ */
		if (is_file(sfp) != 0) goto env;
		for (ffp = sfp->rfp ; ffp != 0 ; ffp = ffp->rfp) {
			if (is_file(ffp) == 0) continue;
			if (ffp->machash != 0) {
				mac = macro_lookup(ffp->acp,&(ffp->machash),sym,0);
				}
			break;
			}
		}
	if (mac == 0) goto env;
read:
	ifp = new_source(lexp,lexp,READ_MACRO,mac,'$',0,0);
	if (ifp == 0) {
		sprintf(lexp->errbuf,"macro missing (%s)",sym->name);
		lex_error(lexp,ERR_user);
		}
	ifp->machash = mac->machash;
	goto ret;
env:
	/* }Ň */
	if (lexp->machash != 0) {
		mac = macro_lookup(lexp->acp,&(lexp->machash),sym,0);
		}
	if (mac != 0) {		/* macro evaluate */
		uni_link* arg = 0;
		uni_link* p;
		alloc_ctl* acp;
		acp = new_push_mactl(lexp->acp_stk);
		if (mac->arg != 0) {
			/* t}N */
			macro_real_arg(lexp, &arg, '(', ')',acp);
			/* ̃}N\[X͂邽߂ɂ́@sfp->machash Kv */
			}
		ifp = new_source(lexp,lexp,READ_MACRO,mac,'$',0,0);
		if (ifp == 0) {
			sprintf(lexp->errbuf,"macro missing (%s)",sym->name);
			lex_error(lexp,ERR_user);
			}
		/* Ǝ̑Ήi}N``Łj */
		for (p = mac->arg ; p != 0 && arg != 0 ; p = p->np, arg = arg->np) {
			symbol* sym;
			macro* mp;
			sym = p->ap;
			mp = macro_lookup(ifp->acp, &(ifp->machash), sym, ((symbol*)(arg->ap))->name );
			mp->machash = sfp->machash;
			}
		del_pop_mactl(lexp->acp_stk);
		if (p != 0 || arg != 0) {
			/* Ǝ̐vĂȂ */
			sprintf(lexp->errbuf,"macro argument mismatch (%s)",mac->macsym->name);
			lex_error(lexp,ERR_user);
			}
		}
	else {
		/* }No^ĂȂ̂ŁA}N̂̂g */
		ix = lexp->tbufix;
		}
ret:
	lexp->tbufix = ix;
	lexp->macro_ctl = save_mac_ctl;
	return mac;
	}


/* ---------- */


static void unget_raw(lex* lexp,int c) {
	if (c == '\n') lexp->sfp->loc.line--;
	lexp->sfp->rawung = c;
	}



/* RgXLbv */

static void skip_comment(source* sfp) {
	int nest = 0;
	int c;
	for(;;) {
		c = get_c(sfp);
	chk:
		if (c == EOF) break;
		if (c < 0) {
			get_c(sfp);			/* QoCgR[ĥQoCg */
			continue;
			}
		switch(c) {
		case '/':
			c = get_c(sfp);
			if (c == '*') {
				++nest;
				break;
				}
			goto chk;
		case '*':
			c = get_c(sfp);
			if (c == '/') {
				if (nest-- == 0) {
					goto ret;
					}
				break;
				}
			goto chk;
		case '\n':
			sfp->loc.line++;
			break;
			}
		}
ret:
	sfp->restart = 1;
	}



static int get_raw_char(lex* lexp) {
	source* sfp = lexp->sfp;
	int c,c2;
	/* \[Xǂ */
	if (sfp->rawung) {
		c = sfp->rawung;
		sfp->rawung = 0;
		goto ret;
		}
	if (sfp->tpl_tap != 0) {
		/* ̃\[X̓ev[gł */
		c = sfp->tpl_tap(lexp);
		goto ret;
		}
	/* ̃\[XɂāA߂Ẳӏ̓ǂݍ */
	if (sfp->restart) {
		/* unget-buffer ̕AȂAǂݍ݈ʒu𕜌 */
		sfp->restart = 0;
		lexp->lexloc = sfp->loc;
		}
	if (sfp->fp != 0) { /* get from the file */
	re_get_f:
		/* ̃\[X̓t@Cł */
		switch(c = get_c(sfp)) {
		case '\\':
			switch(c2 = get_c(sfp)) {
			case '\n':
				++(sfp->loc.line);
				goto re_get_f;
			default:
				unget_c(c2,sfp);
				}
			break;
		case '\r':
			goto re_get_f;
		case '/':
			c2 = get_c(sfp);
			if (c2 != '*') {
				unget_c(c2,sfp);
				break;
				}
			skip_comment(sfp);
			goto re_get_f;
		case EOF:
			break;
		case 'Z' - '@':
			c = EOF;
			}
		}
	else { /* get from the macro string */
	re_get_m:
		/* ̃\[X̓}Nł */
		c = sfp->string[sfp->mbufix];
		switch(c) {
		case 0:
			c = EOF;
			break;
		case '\r':
			sfp->mbufix++;
			goto re_get_m;
		default:
			sfp->mbufix++;
			}
		}
ret:
	if (c == '\n') sfp->loc.line++;
	return c;
	}


#define is_alp_num(c) (\
	(c >= 'A' && c <= 'Z') ||\
	(c >= 'a' && c <= 'z') ||\
	(c >= '0' && c <= '9') )


static int is_word_head(int c) {
	return (is_alp_num(c) || c == '$' || c == '_' || c < 0);
	}


static int put_cooked_word(lex* lexp,int ix) {
	char* macbuf = lexp->tokbuf;
	int i;
	for (i = lexp->tbufix - 1 ; i > ix ; --i) {
		mac_un_c(lexp,macbuf[i]);
		}
	lexp->tbufix = ix;
	return (int)macbuf[ix];
	}


/*
get_cooked_char()֐ł́A'$'APɂ鍇P𐶐邽߂
؂蕶ƂĎgpĂB
'$'ŋ؂ꂽṔAꂼꂪ}NϊꂽŘAAP̒P
ɂȂB
At@Cp[^ƂẲAu'$'tv̏ꍇ́AOL̋؂
Ƃ͈ӖƂȂB
*/


static int get_cooked_char(lex* lexp) {
	macro* mac;
	int mac_ix;
	int prefix;
	int ix;
	int i;
	int c;
	int c0;		/* 擪 */
	int c00;	/* 擪ԋpKvꍇɎgp */
top:
	c00 = c0 = c = get_raw_char(lexp);
	if (c == EOF) return c;
	/* P̐擪ǂ肷 */
	if ( !(is_word_head(c))) {
		/* Pł͖̂ŁA̕Qbg */
		lexp->prefix = 0;	/* AsP͂Ȃ */
		return c;
		}
	/* 擪'$'H */
	if (c == '$') {
		/* ̕擾 */
		c = get_raw_char(lexp);
		if (c == EOF) return c0;
		if (lexp->prefix == 0 && (c >= '0' && c <= '9')) {
			/*
			PƂ́u'$'tvłB
			̏ꍇA擪'$'́APf[^̒Ɋ܂߂B
			*/
			unget_raw(lexp,c);
			c = c0;
			/*
			c0'$'͒PƂĎgp̂ŁAc0ƂĂQdԋpȂ悤ɁA
			擪'$'̕ԋpeXgpc00pӂĂB
			*/
			c00 = ' ';		/* ԋpȂƂĂ */
			}
		else if ( !(is_word_head(c))) {
			/* Pł͖̂ŁA̕ԂāA'$'Qbg */
			unget_raw(lexp,c);
			return c0;
			}
		/*
		PƂ́u'$'tvȊÓA̕擾܂܂łB
		܂A擪'$'́AȌŏP̕ɉĂȂB
		*/
		}
	prefix = lexp->prefix;	/* AsPꂪH */
	lexp->prefix = 1;		/* AsPꂪ */
	mac_ix = lexp->mac_ix;
	ix = lexp->mac_ix = lexp->tbufix;
	/* PƔFłő啶ǂݍ */
	mac_setwbuf(lexp,c);
	if (c < 0) {	/* QoCgΉ */
		c = get_raw_char(lexp);
		mac_setwbuf(lexp,c);
		}
	for(;;) {
		c = get_raw_char(lexp);
		if (c == EOF) break;
		if ( !(is_alp_num(c) || c == '_' || c < 0) ) {
			unget_raw(lexp,c);
			break;
			}
		mac_setwbuf(lexp,c);
		if (c < 0) {	/* QoCgΉ */
			c = get_raw_char(lexp);
			mac_setwbuf(lexp,c);
			}
		}
	switch(lexp->macro_ctl) {
	case MAC_NG:
		/* P̃}NῗȂ */
		goto no_mac;
	case MAC_DOL:
		/* '$'t̃V{̃}Nϊ̂ݍs */
		if (c0 != '$') goto no_mac;
		}
	/* V{̃}Nϊs */
	c = lexp->tokbuf[ix];
	if (c >= '0' && c <= '9') {
		/* ̒P͐lȂ̂ŁA}NῗȂ */
		goto no_mac;
		}
	mac = macro_source(lexp);
	lexp->mac_ix = mac_ix;
	if (mac != 0) {
		lexp->tbufix = ix;
		lexp->prefix = prefix;
		goto top;	/* V{̃}Nϊsꂽ */
		}
	/* }Nł͂Ȃ̂ŁÃV{𕶎ƂĎgp */
	if (c0 == '$') {
		/* u'$'tvǂׂ */
		for (i = ix ; i < lexp->tbufix ; ++i) {
			c = lexp->tokbuf[i];
			if ((c >= '0' && c <= '9') || c == '$') continue;
			goto no_mac;
			}
		/* `ĂȂu'$'tvnullƂ */
		lexp->tbufix = ix;
		goto top;
		}
no_mac:
	c = put_cooked_word(lexp,ix);
	if (c00 == '$' && lexp->save_dol) {
		/* 擪'$'𕜌 */
		mac_un_c(lexp,c);
		c = c0;
		}
	return c;
	}



ENTRY void clear_source(source* sfp) {
	/* ̃\[X̃AQbgobt@ɕȂA */
	sfp->ungbix = 0;
	/* ̃\[X̃AQbg[hɕȂA */
	while (sfp->ungword->ix > 0) {
		pop_value_from_bag(sfp->ungword);
		}
	sfp->rawung = 0;
	}



ENTRY int input(lex* lexp) {
	source* sfp;
	int c;
top:
	sfp = lexp->sfp;
	if (sfp->ungbix) {
		/* ̃\[X̃AQbgobt@ɕȂAg */
		if (--(sfp->ungbix) == 0) sfp->restart = 1;
		c = sfp->ungbuf[sfp->ungbix];
		}
	else if (sfp->ungword->ix) {
		word_loc* wlocp;
		char* sp;
		if (sfp->ungword->ix == 1) sfp->restart = 1;
		/* ̃\[X̃AQbg[hɕȂAg */
		wlocp = (word_loc*)pop_value_from_bag(sfp->ungword);
		sp = wlocp->wordp;	/* [h̕ */
		lexp->lexloc = wlocp->loc;
		if (sp == 0) {
			/* ۂɂ͂P̂ݓo^Ă */
			/* AQbgAQbg[hɉ񂳂ꂽ̂Ȃ̂ŁA
			   '\n'ς݂łB*/
			c = wlocp->code;
			goto c_chk;
			}
		else {
			int i,len;
			/* [h̕PÂ̕ɂăAQbgobt@ɕԂ */
			/* sfl_word()璼ڃAQbg[hɉ񂳂ꂽ̂Ȃ̂ŁA
			   '\n'ĂȂBuninp()gB*/
			switch(wlocp->code) {
			case LEX_SQT: c = '\''; break;
			case LEX_WQT: c = '"' ; break;
			default     : c = 0   ; break;
				}
			if (c != 0) uninp(lexp,c);
			len = strlen(sp);
			for(i = len - 1 ; i >= 0 ; --i) {
				uninp(lexp,sp[i]);
				}
			if (c != 0) uninp(lexp,c);
			}
		goto top;
		}
	else {
		c = get_cooked_char(lexp);
		}
c_chk:
	if (c == '\n') {
		lexp->newline = 1;
		++(lexp->lexloc.line);
		}
	else {
		lexp->newline = 0;
		if (c == EOF) {
			if (sfp->rfp != 0) {
				source_chain_back(lexp);
				goto top;
				}
			if (lexp->eof_ng != 0) {
				lexp->tbufix += sprintf(&(lexp->tokbuf[lexp->tbufix]),"<EOF>");
				sprintf(lexp_errbuf(lexp),"unexpected EOF");
				lex_error(lexp,ERR_user);
				}
			if (sfp->eof_cnt++ > 20) {
				lexp->tbufix += sprintf(&(lexp->tokbuf[lexp->tbufix]),"<EOF>");
				sprintf(lexp_errbuf(lexp),"terminate");
				lex_error(lexp,ERR_user);
				}
			}
		}
	return c;
	}


/*
P̂݃}NWJŃQbgB
ɑPꂪ}No^Ă΁AV}NE\[XJĂijB
*/

ENTRY int input_mac_enb(lex* lexp) {
	int c;
	int save_mac = lexp->macro_ctl;
	lexp->macro_ctl = MAC_SYM;
	c = input(lexp);
	lexp->macro_ctl = save_mac;
	return c;
	}


/* --------- */


ENTRY void skip_line(lex* lexp) {
	int save_mac_ctl;
	if (lexp->newline) return;
	save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	while(input(lexp) != '\n') ;
	lexp->macro_ctl = save_mac_ctl;
	}


ENTRY void skip_block(char left, char right, lex* lexp) {
	int block_cnt = 0;
	int c;
	int save_mac_ctl = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	for(;;) {
		c = input(lexp);
		if (c == left) ++block_cnt;
		else if (c == right) {
			if (block_cnt-- == 0) break;
			}
		}
	lexp->macro_ctl = save_mac_ctl;
	}


/* ========================================================================= */
/* =====    ǂ݂ƂɊւTu[`                           ===== */
/* ========================================================================= */


ENTRY int skip_space_char(lex* lexp) {
	int c;
	lexp->lead_delim = 0;
	for(;;) {
		c = input(lexp);
		if (c != ' ' && c != '\t') break;
		lexp->lead_delim = 1;
		}
	return c;
	}


ENTRY void get_space_char(lex* lexp) {
	int c;
	for(;;) {
		c = input(lexp);
		switch(c) {
		case ' ':
		case '\t':
			mac_setwbuf(lexp,c);
			break;
		default:
			mac_un_inp(lexp,c);
			goto ret;
			}
		}
ret:
	mac_endwbuf(lexp);
	}


static int charactor_code(lex* lexp) {
	int c;
	int d;
	switch(c = input(lexp)) {
	case 't' : c = '\t'; break;
	case 'r' : c = '\r'; break;
	case 'n' : c = '\n'; break;
	case '\\': c = '\\'; break;
	case '\'': c = '\''; break;
	case '\"': c = '\"'; break;
	default :
		if      (c >= '0' && c <= '9') d = c - '0';
		else if (c >= 'a' && c <= 'f') d = c - 'a' + 10;
		else if (c >= 'A' && c <= 'F') d = c - 'A' + 10;
		else break;
		c = input(lexp);
		if      (c >= '0' && c <= '9') d = (d << 4) + c - '0';
		else if (c >= 'a' && c <= 'f') d = (d << 4) + c - 'a' + 10;
		else if (c >= 'A' && c <= 'F') d = (d << 4) + c - 'A' + 10;
		else mac_un_inp(lexp,c);
		c = d;
		}
	return c;
	}


static void get_charcode(lex* lexp) {
	int c;
	switch(c = input(lexp)) {
	case '\\':
		c = charactor_code(lexp);
		}
	mac_setwbuf(lexp,c);
	switch(c = input(lexp)) {
	case '\'':
		break;
	case EOF :
	default:
		sprintf(lexp->errbuf,"'\\'' expected");
		lex_error(lexp,ERR_user);
		}
	}


/* ݂̂ō\ꂽoB*/


ENTRY void num_str(lex* lexp) {
	int c;
	for(;;) {
		c = input(lexp);
		if ( ((c >= '0' && c <= '9') || (c == '_')) && (c != EOF) ) {
			mac_setwbuf(lexp,c);
			continue;
			}
		mac_un_inp(lexp,c);
		break;
		}
	mac_endwbuf(lexp);
	}


/* Epyѐ݂̂ō\ꂽoB*/


ENTRY void asz_str(lex* lexp) {
	int c;
	for(;;) {
		c = input(lexp);
		if ( ((c >= 'a' && c <= 'z') ||
			  (c >= 'A' && c <= 'Z') ||
			  (c >= '0' && c <= '9') ||
			  (c == '_') || (c < 0)   ) && (c != EOF) ) {
			 if (c < 0) {	/* 2 byte code */
				mac_setwbuf(lexp,c);
				c = input(lexp);
				}
			mac_setwbuf(lexp,c);
			continue;
			}
		mac_un_inp(lexp,c);
		break;
		}
	mac_endwbuf(lexp);
	}


ENTRY int symbol_str(lex* lexp, int c, int* tokp) {
	if ( !((c >= 'a' && c <= 'z') ||
		   (c >= 'A' && c <= 'Z') ||
		   (c == '_') || (c < 0)    )  || (c == EOF) ) return 0;
	*tokp = LEX_SYM;
	if (c < 0) {	/* 2 byte code */
		c = input(lexp);
		mac_setwbuf(lexp,c);
		}
	asz_str(lexp);
	return 1;
	}



static int number_word(lex* lexp, int c, int* tokp) {
	if (c < '0' || c > '9') return 0;
	*tokp = LEX_NUM;
	for(;;) {
		c = input(lexp);
		if (c == '_') continue;
		if ((c >= 'a' && c <= 'f') ||
			(c >= 'A' && c <= 'F') ||
			(c == 'o' || c == 'O') ||
			(c == 'x' || c == 'X') ) {
			*tokp = LEX_SFLN;
			mac_setwbuf(lexp,c);
			continue;
			}
		else if (c >= '0' && c <= '9') {
			mac_setwbuf(lexp,c);
			continue;
			}
		mac_un_inp(lexp,c);
		break;
		}
	mac_endwbuf(lexp);
	return 1;
	}



static int operation_keyword(lex *lexp, int c, word_dict* dictp) {
	word_dict* p;
	word_dict* q;
	int tok = 0;
	for (p = dictp ; ; p = q) {
		if ((q = word_dict_step_lookup(p,c)) == 0) break;
		if (q->np == 0) {
			/* ̐ɂ͌₪Ȃ̂łŏIB */
			tok = word_dict_goal(q);
			if (tok != NO_GOAL) {
				mac_endwbuf(lexp);
				goto ret;
				}
			}
		c = input(lexp);
		mac_setwbuf(lexp,c);
		}
	mac_endwbuf(lexp);	/* ǂݍ񂾈ʒu܂łPƂĕ */
	for(;;) {
		c = lexp->tokbuf[--(lexp->tbufix)];
		mac_un_inp(lexp,c);
		if (p == dictp) break;
		tok = word_dict_goal(p);
		if (tok != NO_GOAL) {
			/* S[܂ł̕ŃJbg */
			mac_endwbuf(lexp);
			goto ret;
			}
		p = word_dict_parent(p);
		}
ret:
	/* FS[Ȃꍇ́Aǂݍ񂾈ʒu܂ł𕶎ƂĂ */
	return tok;
	}



/* GXP[vϊt̕ */


static int input_with_esc(lex* lexp, int* cp) {
	int c;
	int d;
	int code;
	switch(d = input(lexp)) {
	case 'a' : c = 0x07; break;
	case 'b' : c = 0x08; break;
	case 'e' : c = 0x1b; break;
	case 'f' : c = 0x0c; break;
	case 'n' : c = '\n'; break;
	case 'r' : c = '\r'; break;
	case 't' : c = '\t'; break;
	case 'v' : c = 0x0b; break;
	case 'x' :
		/* PUiϊ */
		code = 0;
		while ((d = input(lexp)) != 0) {
			if      (d>='0' && d<='9') code = code * 16 + d - '0';
			else if (d>='A' && d<='F') code = code * 16 + d - 'A' + 10;
			else if (d>='a' && d<='f') code = code * 16 + d - 'a' + 10;
			else break;
			}
		mac_un_inp(lexp,d);
		c = code;
		break;
	default:
		if (d >= '@' && d <= 'Z') {
			c = d - '@';
			break;
			}
		if (!(d >= '0' && d <= '7')) return d;
		/* Wiϊ */
		code = d - '0';
		while ((d = input(lexp)) != 0) {
			if (d>='0' && d<='7') code = code * 8 + d - '0';
			else break;
			}
		mac_un_inp(lexp,d);
		c = code;
		}
	*cp = c;
	return 0;		/* convert char done */
	}


/* NI[gȂ̏ꍇ */


static int no_quote(lex* lexp) {
	int c,d;
	for(;;) {
		c = input(lexp);
		switch(c) {
		case EOF:
		case '#':
		case ';':
		case ' ':
		case '\t':
		case '\n':
			mac_un_inp(lexp,c);
			goto ret;
		case '\\':
			/* GXP[v̏ꍇ */
			d = input_with_esc(lexp,&c);
			if (d == 0) break;
			switch(d) {
			case '_': continue;
			case '#':
			case ';':
			case ' ':
			case '\t':
			case '$':
				c = d;
				break;
			case '\n':
				c = ' ';
				break;
			case '\\':
				break;
			default:
				mac_un_inp(lexp,d);
				break;
				}
			break;
			}
		mac_setwbuf(lexp,c);
		}
ret:
	mac_endwbuf(lexp);
	return 1;	/* OK */
	}


/* hNI[g̏ꍇ@i܂́@@̏ꍇj */


static void double_quote(lex* lexp, int endchar) {
	int c,d;
	int save_mac = lexp->macro_ctl;
	lexp->macro_ctl = MAC_DOL;
	for(;;) {
		c = input(lexp);
		if (c == endchar) goto ret;		/* '"' */
 		switch(c) {
		case EOF:
			mac_un_inp(lexp,c);
		case '\n':
			c = ' ';
			break;
		case '$':
			input_mac_enb(lexp);
			break;
		case '\\':
			/* GXP[v̏ꍇ */
			d = input_with_esc(lexp,&c);
			if (d == 0) break;
			switch(d) {
			case '_': continue;
			case '"':
			case '\n':
			case '$':
				c = d;
				break;
			default:
				mac_un_inp(lexp,d);
				break;
				}
			break;
			}
		mac_setwbuf(lexp,c);
		}
ret:
	mac_endwbuf(lexp);
	lexp->macro_ctl = save_mac;
	}


/* fNI[g̏ꍇ */


static void single_quote(lex* lexp) {
	int c,d;
	for(;;) {
		c = input(lexp);
 		switch(c) {
		case EOF:
			mac_un_inp(lexp,c);
		case '\'':
			goto ret;
		case '\n':
			c = ' ';
			break;
		case '\\':
			/* GXP[v̏ꍇ */
			d = input_with_esc(lexp,&c);
			if (d == 0) break;
			switch(d) {
			case '_': continue;
			case '\'':
			case '\n':
				c = d;
				break;
			default:
				mac_un_inp(lexp,d);
				break;
				}
			break;
			}
		mac_setwbuf(lexp,c);
		}
ret:
	mac_endwbuf(lexp);
	}


ENTRY void get_string(lex* lexp, int quote) {
	int c;
top:
	switch(quote) {
	case 0:
		/* 󔒂܂ł̘A؂o */
		lexp->tbufix = 0;
		c = skip_space_char(lexp);
		if (c == '"' || c == '\'') {
			quote = c;	/* ؂oύX */
			goto top;
			}
		if (c == '\\') {
			c = input(lexp);
			if (c == '\n') goto top;
			mac_un_inp(lexp,c);
			c = '\\';
			}
		mac_un_inp(lexp,c);
		if (no_quote(lexp) == 0) goto top;
		break;
	case 1:
		/* ݂̕obt@̌ɑ */
		no_quote(lexp);
		break;
	case '"':
		double_quote(lexp,'"');
		break;
	case '<':
		double_quote(lexp,'>');
		break;
	case '\'':
		single_quote(lexp);
		}
	}


/* ========================================================================= */
/* =====    rek\[XɊւ鎚                                   ===== */
/* ========================================================================= */


char META_direct = '%';

/* %%% */
int dsp_sfl_word = 0;


ENTRY int sfl_word(lex *lexp) {
	int tok;
	int c;
	lexp->lead_delim = 0;
top:
	lexp->tokloc = lexp->lexloc;
	lexp->tbufix = 0;
	lexp->toksym = 0;
	lexp->mac_ix = 0;
	c = input(lexp);
	mac_setwbuf(lexp,c);
	/* 擪ɂAʂȏKvǂ𔻒肷 */
	if (c == EOF) {						/* Check : X^[gt@C̏I */
		lexp->tbufix = sprintf(lexp->tokbuf,"<EOF>");
		tok = LEX_EOF;
		goto ret;
		}
	else if (lexp->meta_off == 0) {
		if (sfl_directive(lexp,META_direct,c) == GOOD) goto top;
		lexp->tbufix = 0;
		lexp->mac_ix = 0;
		mac_setwbuf(lexp,c);
		}
	/* 擪ɂAP̎擾@Iʂ */
	if (c == ' ' || c == '\t') {		/* Check : space char */
		tok = LEX_SPC;
		get_space_char(lexp);
		}
	else if (symbol_str(lexp, c, &tok)) {	/* Check : symbol */
		if (lexp->tokbuf[0] == '_' && lexp->in_record == 0) {
			/* ̃V{̐擪'_'͕sƂ */
			mac_endwbuf(lexp);
			sprintf(lexp->errbuf,"illegal 1'st char (%s)",lexp->tokbuf);
			lex_error(lexp,ERR_user);
			}
		}
	else if (number_word(lexp, c, &tok)) {	/* Check : number */
		;
		}
	else if (c == '\n') {					/* Check : newline */
		tok = LEX_NL;
		}
	else if (c == '\'' && lexp->skip_chr == 0) {	/* Check : char code */
		tok = LEX_CHR;
		get_charcode(lexp);
		}
	else if (c == '"') {					/* Check : strings */
		tok = LEX_WQT;
		lexp->tbufix = 0;
		get_string(lexp, c);
		}
	else if (c == '\'' ) {					/* Check : strings */
		tok = LEX_SQT;
		lexp->tbufix = 0;
		get_string(lexp, c);
		}
	else {									/* Check : operation keyword */
		mac_endwbuf(lexp);
		tok = operation_keyword(lexp, c, lexp->opr_tblp);
		if (tok == 0) {
			/* ݎgpĂIy[VEe[uɓo^ĂȂLłB*/
			/* P͂ĂȂԂȂ̂ŁAIɂP擾 */
			tok = c = input(lexp);
			mac_setwbuf(lexp,c);
			}
		}
ret:
	mac_endwbuf(lexp);
	/* 擾V{o^iSĂ̓̕V{o^j */
	lexp->toksym = symbol_lookup(lexp,lexp->tokbuf);
	if ((lexp->skip_spc && (tok == LEX_SPC)) ||
	    (lexp->skip_nl  && (tok == LEX_NL )) ){
		/* 󔒕ij͔ĵŎ̒P擾 */
		lexp->lead_delim = 1;	/* s󔒂ƂL^Ă */
		goto top;
		}
	/* %%% */
	if (dsp_sfl_word) {
		printf("!!!  SFL_WORD = %s, tok = %d(%c), file=%s, line=%d\n", lexp->tokbuf,tok,tok,lexp->lexloc.file->sym->name,lexp->lexloc.line);
		}
	return tok;
	}


ENTRY void char_assert(lex* lexp, int tc) {
	sfl_word(lexp);
	if (lexp->tokbuf[0] == tc) return;
	sprintf(lexp_errbuf(lexp),"'%c' expected",tc);
	lex_error(lexp,ERR_user);
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====    R}hC^v^Ɋւ鎚                           ===== */
/* ========================================================================= */
/*****************************************************************************/


ENTRY void move_next_cmd(lex* lexp,int pos) {
	int c;
	lexp->cmdlast = '\n';
	if (is_tty(lexp->sfp)) pos = LINE_left;
	for(;;) {
		c = input(lexp);
	next_chk:
		switch(c) {
		case ';':
			lexp->cmdlast = c;
			return;
		case EOF:
			mac_un_inp(lexp,c);
			lexp->cmdlast = '\n';
			return;
		case '\n':
			if (pos == LINE_left) {
				/* ̍sׂĂǂݍށi̍s̏Iׁj */
				lexp->cmdlast = '\n';
				}
			else {
				/* s̎OŎ~܂iG[Asԍ擾ׁ̈j */
				mac_un_inp(lexp,c);
				lexp->cmdlast = ';';
				}
			return;
		case '#':
			skip_line(lexp);
			return;
			}
		}
	}


static char* cmd_arg_word(lex* lexp) {
	lexp->tbufix = 0;
	get_string(lexp, 0);
	return lexp->tokbuf;
	}


/* ڂ̈(sp)lexp->tokbuf̈tokenāAargzɊi[ */


ENTRY void get_cmd_arg(lex* lexp, char* sp) {
	int i;
	for (i = 0 ; ; ++i) {
		if (sp == 0) {	/* w肳ĂȂꍇA𓾂 */
			sp = cmd_arg_word(lexp);
			/* w肪I */
			if (*sp == 0) break;
			}
		if (i >= lexp->argl) {	/* ̊i[CfFNXt */
			/* ̊i[CfFNX{ɂ */
			lexp->argl = size_doubler(lexp->argl,10);
			/* ̊i[z̊i[ꏊ */
			lexp->args = (char**)resize_segmem(lexp->acp,lexp->args,
						 sizeof(char*)*i, sizeof(char*)*lexp->argl);
			/* i[z[i]ԖڂɊi[o镶񐔂̊i[ꏊ */
			lexp->a_ix = (size_t*)resize_segmem(lexp->acp,lexp->a_ix,
						 sizeof(size_t)*i, sizeof(size_t)*lexp->argl);
			}
		for(;;) {
			size_t o_siz;
			size_t n_siz;
			char*  ap;
			char*  bp;
			int    j;
			ap = sp;
			bp = lexp->args[i];
			for (j = lexp->a_ix[i] ; j > 1 ; --j) {
				if ((*bp++ = *ap++) == 0) goto next;
				}
			/* i[z[i]Ԗڂ̊i[ꏊȂ̂Ŋg */
			o_siz = sizeof(char) * lexp->a_ix[i];
			lexp->a_ix[i] = size_doubler(lexp->a_ix[i],128);
			n_siz = sizeof(char) * lexp->a_ix[i];
			/* args[i] := [i]Ԗڂ̊i[ꏊ */
			lexp->args[i] = (char*)resize_segmem(lexp->acp,lexp->args[i], o_siz, n_siz);
			}
next:
		/* (sp)̊i[͏I */
		sp = 0;
		}
	lexp->argc = i;
	if (lexp->verbose) {
		for (i = 0 ; i < lexp->argc ; ++i) {
			fprintf(lexp->speakfp,"'%s' ",lexp->args[i]);
			}
		fprintf(lexp->speakfp,"\n");
		}
	}


/* A[MgiԖڕotokbufɐݒ */

ENTRY char* cmd_arg_line(lex* lexp, int i) {
	int   c;
	char* sp;
	lexp->tbufix = 0;
	if (i >= lexp->argc) goto ret;
	for(;;) {
		sp = lexp->args[i];
		while ((c = *sp++) != 0) {
			mac_setwbuf(lexp,c);
			}
		if (++i >= lexp->argc) break;
		mac_setwbuf(lexp,' ');
		}
ret:
	mac_endwbuf(lexp);
	return lexp->tokbuf;
	}


ENTRY int cmd_word(lex *lexp) {
	int tok;
	int c;
	lexp->lead_delim = 0;
top:
	lexp->tokloc = lexp->lexloc;
	dsp_prompt(lexp);
	lexp->cmdlast= 0;	/* R}hs̍ŏIo^ */
	lexp->tbufix = 0;
	lexp->toksym = 0;
	c = input(lexp);
	mac_setwbuf(lexp,c);
	if (c == EOF) {					/* Check : X^[gt@C̏I */
		if (lexp->sfp->permanent == 0) {
			longjmp(**(lexp->jmpbfpp),ERR_eof);
			}
		lexp->tbufix = sprintf(lexp->tokbuf,"<EOF>");
		tok = LEX_EOF;
		goto ret;
		}
	if (c == ' ' || c == '\t') {	/* Check : space char */
		tok = LEX_SPC;
		get_space_char(lexp);
		goto ret;
		}
	if (c == '#') {					/* Check : comment */
		skip_line(lexp);
		c = '\n';
		mac_un_inp(lexp,c);
		goto top;
		}
	else if (c == '\n') {			/* Check : newline */
		tok = LEX_NL;
		mac_un_inp(lexp,c);
		}
	else if (c == ';') {
		tok = LEX_NL;
		mac_un_inp(lexp,c);
		}
	else if (c == '?') {
		tok = LEX_QRY;
		lexp->toksym = symbol_lookup(lexp,"?");
		}
	else if (c == '"') {	/* Check : strings */
		tok = LEX_WQT;
		lexp->tbufix = 0;
		get_string(lexp,c);
		}
	else if (c == '\'' ) {	/* Check : strings */
		tok = LEX_SQT;
		lexp->tbufix = 0;
		get_string(lexp,c);
		}
	else {
		/* heap a word */
		tok = LEX_SYM;
		get_string(lexp, 1);
		lexp->toksym = symbol_lookup(lexp,lexp->tokbuf);
		}
ret:
	mac_endwbuf(lexp);
	if ((lexp->skip_spc && (tok == LEX_SPC)) ||
	    (lexp->skip_nl  && (tok == LEX_NL )) ){
		lexp->lead_delim = 1;
		goto top;
		}
	lexp->prompt = 0;
	return tok;
	}


ENTRY int cmd_pure_word(lex* lexp) {
	int id;
	int save_mac = lexp->macro_ctl;
	lexp->macro_ctl = MAC_NG;
	id = cmd_word(lexp);
	lexp->macro_ctl = save_mac;
	return id;
	}


/* ========================================================================= */
/* =====   kdw̏e[u                                      ===== */
/* ========================================================================= */

int max_blk_repeat = 1000;

setup_parm lex_ini[] = {
	sup_str(sfl_lib_dir),
	sup_str(err_list_file),
	sup_str(source_editor),
	sup_int(max_blk_repeat),
	{0,0,0,0},
	};

