/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_lex.h
 *
 * Lexical analyzer functions.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_LEX_H)
#define PS_LEX_H


#if defined(EXTRA)
#	define Ex_lex
#	include "extra.h"
#	endif


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_lex_lex)
#	define Ex_lex_lex 
#	define Ex_new_lex(lexp)
#	endif


struct s_source;
struct s_lex;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#define SYMBOL_PA(s) s


typedef struct s_hashtbl {
	alloc_ctl* acp;
	unsigned int tblent;
	size_t tblsiz;
	void** tblpp;
	SYMBOL_PA(unsigned long lup_cnt);
	SYMBOL_PA(unsigned long try_cnt);
	} hashtbl;


ENTRY void* hash_del_mp;
hashtbl* new_hashtbl(alloc_ctl* acp);
void expand_hash_tbl(hashtbl* hp,size_t init,unsigned int (*hcode)(void*));
hashtbl* dup_hash_table(alloc_ctl*,hashtbl*,void* (*dcode)(alloc_ctl*,void*));
void clear_hash_table(hashtbl* hp);
void delete_hash_entry(hashtbl* hp, void* vp, unsigned int ix);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_symbol {
	char *name;
	unsigned int code;
	} symbol;


/* Wo͂̃V{f[^ */

#if defined(PS_LEX_C)
	static symbol _STDin  = {"stdin" ,0};
	static symbol _STDout = {"stdout",0};
	static symbol _STDerr = {"stderr",0};
	static symbol _STDnul = {"null"  ,0};
	symbol* STDin  = &_STDin ;
	symbol* STDout = &_STDout;
	symbol* STDerr = &_STDerr;
	symbol* STDnul = &_STDnul;
#else
	extern symbol* STDin;
	extern symbol* STDout;
	extern symbol* STDerr;
	extern symbol* STDnul;
#	endif


symbol*  symbol_lookup(struct s_lex* lexp,char *word);
void symbol_status(hashtbl* hp);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	symbol* sym;
	int     cate;
	} symcate;


/*
enum {
	PATH_TYPE  = 0x0001,
	FILE_TYPE  = 0x0002,
	MACRO_TYPE = 0x0004,
	EVAL_TYPE  = 0x0008,
	TTY_TYPE   = 0x0010,
	STDIN_TYPE = 0x0020,
	STDOUT_TYPE= 0x0040,
	STDERR_TYPE= 0x0080,
	NULL_TYPE  = 0x8000,
	};
*/


enum {
	NAME_PATH  = 1,
	NAME_FILE,
	};


#define all_cate \
	def_cate("file    " , READ_FILE   )\
	def_cate("template" , READ_TPL    )\
	def_cate("macro   " , READ_MACRO  )\
	def_cate("gui-cmd " , READ_GUI    )\
	def_cate("start-up" , READ_SUP    )\
	def_cate("eval    " , READ_EVAL   )\
	def_cate("console " , READ_TTY    )\
	def_cate("stdin   " , READ_STDIN  )\
	def_cate("stdout  " , TYPE_STDOUT )\
	def_cate("stderr  " , TYPE_STDERR )\
	def_cate("(null)  " , TYPE_NULL   )\


#define def_cate(s,c) c,
enum {
	CATE_top = 1,
	all_cate 
	};


char* symcate_name(symcate* sp);
char* symcate_type_name(symcate* sp);
symcate* symcate_lookup(struct s_lex* lexp, symbol* sym, int cate);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	symbol* sym;
	long    value;
	} sym_val;


sym_val* sym2val_lookup(hashtbl* hp,symbol* sym,long value,int regist);
hashtbl* teach_key_word(struct s_lex* lexp, key_word* ktp);


/* ========================================================================= */
/* =====  `ꂽꏊ߂̐Έʒu                       ===== */
/* ========================================================================= */


typedef struct s_file_loc {
	struct s_file_loc* parent;
	symcate*     file;
	unsigned int line;
	} fileloc;


fileloc* new_fileloc(alloc_ctl* acp,fileloc* parent);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct {
	int   code;
	char* wordp;
	fileloc loc;
	} word_loc;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_uni_link {
	void* ap;
	struct s_uni_link* np;
	} uni_link;


uni_link* new_uni_link(alloc_ctl* acp, void* ap, uni_link* np);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_macro {
	symbol*  macsym;
	char*    string;
	int      inuse;
	uni_link* arg;		/* t}N̏ꍇ̉Xg */
	hashtbl*  machash;	/* ̃}N\[X͂邽߂ɕKvȃ}N\ */
	} macro;


macro* macro_lookup(alloc_ctl* acp, hashtbl** hpp, symbol* sym, char* string);
void  tell_macro(struct s_lex* lexp, hashtbl* hp, char* defcmd);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_filetag {
	symcate* file;
	int      status;
	int      ref_cnt;
	FILE*    fp;
	} filetag;


void close_filetag(struct s_lex* lexp);
FILE* file_control(struct s_lex* lexp, symcate* filc, FILE* fp, int mode);

char* cwd_path(char* cp);
void file_suspend(struct s_source* sfp);
void file_restart(struct s_source* sfp);
void loc_file_line(struct s_lex* lexp, symcate** fp, int* lp);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


	struct s_drct_blk;


typedef struct s_source {
	alloc_ctl* acp;
	int        permanent;		/* N[YȂiR\[j */
	int        suspend;			/* qXNvg̎s */
	long       readloc;			/* qXNvǧĂяoʒu(ftell) */
	FILE*      fp;				/*  */
	fileloc    loc;				/* ̃\[Xt@Ćí݂jkdwʒu */
	fileloc    s_loc;			/* TXyĥkdwʒu */
	/* }N^Cṽ\[X̏ꍇ */
	macro*     macp;			/* s̃}N */
	char*      string;			/* }N̒`e */
	int        mbufix;			/* }N̓ǂݏoʒu */
	/* unget char buf */
	int        rawung;
	/* unget buffer */
	int*       ungbuf;
	int        ungbsz;
	int        ungbix;
	int        restart;
	int        eof_cnt;
	/* unget word stack */
	bag_arr*   ungword;
	int      (*tpl_tap)(struct s_lex*);
	void*      envp;			/* template tap ̂߂̊ */
	hashtbl* machash;			/* EXNvg@}N`e[u */
	entity_ctl* blkecp;
	struct s_drct_blk* drctblkp;	/* ݂̃fBNeBuubN */
	struct s_lex* lexp;
	struct s_source*  rfp;		/* back link */
	} source;



source* new_source(struct s_lex* lexp,struct s_lex* lnkp,int typ,void* srcp,char mackey,int argc,char** args);

int is_sinsrc(source* sfp);
int is_tty(source* sfp);
int is_file(source* sfp);
int is_macsrc(source* sfp);
int is_template(source* sfp);
int is_eval(source* sfp);



/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_lex {
/* === VXeʃo === */
	alloc_ctl* cmnacp;
	jmp_buf**  jmpbfpp;
	hashtbl*   symhash;		/* V{̃j[No^ */
	hashtbl*   catehash;	/* JeS̃j[No^ */
	hashtbl*   filehash;	/* t@C̃j[No^ */
/* === lexO[vʃo === */
	hashtbl*   drct_hp;		/* fBNeBu̎ */
	word_dict* opr_tblp;	/* Iy[VL̎ */
	int        meta_off;	/* METAL𖳌ɂ */
	int        sflspec;
/* === lexpo === */
	int      permanent;
	int      suspend;
	int      restart;
	symbol*  lex_path;
	fileloc  lexloc;		/* ݂̂kdwʒu */
	int      newline;		/* Oɓǂݍ񂾕nl */
	int      prompt;		/* ̓vvg\ */
	int      verbose;
	int      echo_on;
	hashtbl* machash;		/* }N`e[u */
	hashtbl* tplhash;		/* ev[g`e[u */
	/* bZ[W */
	FILE*    speakfp;		/* bZ[Wo͐ */
	symcate* speakfn;		/* bZ[Wo͐ */
	FILE*    claimfp;		/* G[bZ[Wo͐ */
	symcate* claimfn;		/* G[bZ[Wo͐ */
	char     errbuf[512];	/* G[bZ[W */
/* === lexʃo === */
	alloc_ctl* acp;
	alloc_ctl* sflacp;
	struct s_lex* parent;
	bag_arr*  child_lexp;
	bag_arr*  acp_stk;		/* ƗpɊmۂacp̕ۊǏꏊ */
	void*    consor;		/* R\[͗ */
	source*  sfp;
	int      in_drct;		/* fBNfBȕ */
	int      in_record;		/* \[X̋L^ */
	int      eof_ng;		/* EOF́AG[Ƃ */
	int      macro_ctl;		/* }NQƐ */
	int      save_dol;		/* '$'ۑS */
	int      prefix;		/* sPꂪ邩 */
	int      skip_spc;		/* 󔒃g[N𖳎 */
	int      skip_nl;		/* sg[N𖳎 */
	int      skip_chr;		/* ɂ鐔lw͂Ȃ */
	int      lup_only;		/* V{e[u͎QƂ̂ */
	int      cmdlast;		/* R}hs̍Ō̕i[ */
	int      lead_delim;	/* lex؂owordɐs؂蕶 */
	/* token strings buffer */
	int      tbufsz;		/* obt@tokbuf̃TCY */
	int      tbufix;		/* ̊̕i[ʒu */
	int      mac_ix;		/* }N̐擪ʒu */
	char*    tokbuf;		/* lex؂oword̕obt@ */
	symbol*  toksym;		/* lex؂owordsymbolɕϊ */
	fileloc tokloc;			/* toksym̂kdwʒu */
	/* script command interpreter */
	void*    cmd_tp;
	int      argl;
	int      argc;
	char**   args;
	size_t*  a_ix;
	/* extra members */
	Ex_lex_lex
	} lex;


char* full_file_name(int sysinc, char* fpath, char* fname);
source* new_include(lex* lexp,int sel_dir,char* fname,char mackey,int argc,char** args);
void del_include(source* ifp);

ENTRY lex* (*lex_init_extra)(lex* lexp);
void lex_init_mode(lex* lexp);
lex* new_lex(lex* lexp);
void close_all_sfp(lex* lexp);
void clear_sflacp(lex* lexp);
void delete_lex(lex* lexp);
void del_child_lex(bag_arr* bagp);
lex* fork_child(lex* lexp);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY void source_chain_back(lex* lexp);
void uninp(lex* lexp,int c);
void set_wbuf(lex* lexp,int c);
void end_wbuf(lex* lexp);

void unget_word(lex *lexp, int tc, char* wordp, fileloc* locp);
void clear_source(source* sfp);
int  input(lex* lexp);
int  input_mac_enb(lex* lexp);
void skip_line(lex* lexp);
void skip_block(char left, char right, lex* lexp);

int skip_space_char(lex* lexp);
void get_space_char(lex* lexp);
void num_str(lex* lexp);
void asz_str(lex* lexp);
int  symbol_str(lex* lexp, int c, int* tokp);
void get_string(lex* lexp, int quote);


/* ========================================================================= */
/* =====   Error message                                               ===== */
/* ========================================================================= */


#define all_ecode \
	def_err(eof     )\
	def_err(bye     )\
	def_err(quit    )\
	def_err(reset   )\
\
	def_err(ftl_top )\
	def_err(fatal   )\
	def_err(ftl_end )\
\
	def_err(sys_top )\
	def_err(system  )\
	def_err(sys_end )\
\
	def_err(usr_top )\
	def_err(user    )\
	def_err(frd_stwt)\
	def_err(frd_loop)\
	def_err(usr_end )\


#define def_err(code) ERR_##code,
enum {
	/* CMD error */
	ERR_top = 1,
	all_ecode
	};


ENTRY  int   ec_test_mode;
ENTRY  int   error_code;
ENTRY answer err_code_cmp(int rtc);

FILE* lexp_errfp(lex*);
void  lexp_errclr(lex*);
char* lexp_errbuf(lex*);

FILE* open_error_file(void);
void close_error_file(void);
void mark_err_pos(char* taget, symcate* filc, int line);
int source_position(FILE* cfp, char* name, fileloc* locp);
void error_type(FILE* cfp, int rtc);
void put_source_back(FILE* cfp, fileloc* locp);
void lex_error(lex* lexp, int rtc);
void lex_loc_err(lex* lexp, fileloc* locp,int rtc);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


enum {
	/* LEX token code */
	LEX_EOF = 0,
	LEX_NL  = 128,
	LEX_SPC,
	LEX_CHR,
	LEX_STR,
	LEX_SQT,
	LEX_WQT,
	LEX_NUM,
	LEX_QRY,
	LEX_opr,
	LEX_SYM = 256,
	LEX_SFLN,
	LEX_ARG,
	LEX_void,
	LEX_end,
	};


enum {
	LINE_left,
	LINE_right,
	};



int   sfl_word(lex*);
void  char_assert(lex* lexp, int tc);
void  move_next_cmd(lex* lexp, int pos);
void  get_cmd_arg(lex* lexp, char* sp);
char* cmd_arg_line(lex* lexp, int no);
int   cmd_word(lex*);
int   cmd_pure_word(lex* lexp);


/* ========================================================================= */
/* =====    rekfBNeBu@                                 ===== */
/* ========================================================================= */


typedef struct s_drct_blk {
	int      id_no;
	int      repeat;
	int      within;
	fileloc  loc;
	long     restart;	/* ̃ubN̍ĊJʒu */
	long     body;		/* for ubN̖{̈ʒu */
	long     test;		/* for ubN̏ʒu */
	hashtbl* lblhash;	/* ̃ubNŒ`ꂽx\ */
	hashtbl* machash;	/* ̃ubNŒ`ꂽϐ\ */
	source*  sfp;		/* ̃ubN`ꂽ\[X */
	struct s_drct_blk* parent;
	} drct_blk;


/* fBNeBuL[[h ::= */
#define drct_key \
	def_drct(i)\
	def_drct(d)\
	def_drct(u)\
	def_drct(if)\
	def_drct(else)\
	def_drct(while)\
	def_drct(for)\
	def_drct(do)\
	def_drct(continue)\
	def_drct(break)\
	def_drct(goto)\
	def_drct(set)\
	def_drct(echo)\


#undef def_drct
#define def_drct(key) DRCT_##key,
enum {
	DRCT_eof = 0,
	DRCT_let,
	DRCT_bigin,
	DRCT_end,
	drct_key
	};


/* ubNEfBNeBu ::= */
#define blk_key \
	def_blk(grand)\
	def_blk(bigin)\
	def_blk(if)\
	def_blk(else)\
	def_blk(while)\
	def_blk(for)\
	def_blk(do)\


#undef def_blk
#define def_blk(key) BLK_##key,
enum {
	blk_key
	};


enum {
	MAC_NG  = 0,
	MAC_DOL,
	MAC_SYM,
	};


ENTRY answer is_number_opr(lex* lexp,int end);
ENTRY char META_direct;
ENTRY int get_eval_arg(lex* lexp,alloc_ctl* acp,int control_num_spec,int r_angle,char** spp);
ENTRY int macro_argument(lex* lexp, uni_link** lpp, int left, int right);
ENTRY int macro_real_arg(lex* lexp, uni_link** lpp, int left, int right, alloc_ctl* acp);
ENTRY source* seek_drct_value(lex* lexp,symbol* sym,drct_blk** blkpp,macro** macp);
ENTRY answer sfl_directive(lex* lexp, int drct_char, int c);



ENTRY long get_number(lex* lexp,int opr_spec);
ENTRY long get_mono_number(lex* lexp,int opr_spec);


#undef  ENTRY
#define ENTRY 


#endif PS_LEX_H

