/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_misc.c
 *
 * miscellaneous basic functions.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#include "ps_selec.h"
#include "ps_misc.h"


ENTRY void foot_mark(char* name) {
	printf("%s() : \n",name);
	fflush(stdout);
	}


/* ========================================================================= */
/* =====   Error message by misc function                              ===== */
/* ========================================================================= */


FILE* serr_efp = NULL;
char  serr_buf[512] = "";


ENTRY void dsp_error(char* msg) {
	fprintf(serr_efp,"System Error : %s",serr_buf);
	if (msg != 0) fprintf(serr_efp," %s",msg);
	fprintf(serr_efp,".\n");
	serr_buf[0] = 0;
	}


ENTRY void sys_error(char* msg) {
	dsp_error(msg);
	fprintf(serr_efp,"Can't recover by misc control. Sorry byebye.\n");
	exit(1);
	}


ENTRY void indent(FILE* spkfp, int indlvl) {
	while(indlvl-- > 0) fprintf(spkfp,"    ");
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


int alloc_dsplay = 0;
unsigned long aloc_sum = 0;


ENTRY void* new_mem(size_t siz) {
	static char buf[80];
	void* vp;
	if (siz == 0) sys_error("Allocate Memory size = 0");
	if (alloc_dsplay) {
		printf("new_mem : aloc_sum = %8lu, ",aloc_sum);
		printf("allocate memory size = %u\r\n",siz);
		}
	vp = malloc(siz + sizeof(size_t));
	if (vp == 0) {
		sprintf(buf,"No more heap-memory req-siz=%u (total=%lu)",siz,aloc_sum);
		sys_error(buf);
		}
	aloc_sum += siz;
	*((size_t*)vp) = siz;
	return (void*)(((size_t*)vp) + 1);
	}


ENTRY void del_mem(void* vp) {
	size_t siz;
	if (vp == 0) return;
	vp = (void*)(((size_t*)vp) - 1);
	siz = *(size_t*)vp;
	aloc_sum -= siz;
	free(vp);
	}


ENTRY void* resize_mem(void* vp, size_t o_siz, size_t n_siz) {
	void* np;
	np = (void*)new_mem(n_siz);
	memset(np,0,n_siz);
	if (vp != 0 && o_siz != 0) {
		memcpy(np,vp,o_siz);
		del_mem(vp);
		}
	return np;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static int work_set_cnt = 16;			/* ʂɎgpobt@̃Zbg */
       int work_buf_len = MAXPATHLEN;	/* ʂɎgpobt@̑傫 */


/*
 ʂɎgpz^e|obt@Eԋp̕KvȂ
 ߎgpɒ
 */


ENTRY char* get_looped_buf(int siz) {
	static char** msg_bufpp  = 0;
	static int    msg_set_ix;
	static int    msg_set_cnt;
	static int    msg_buf_len;
	int i;
	if (msg_bufpp == 0) {
		if (work_set_cnt <  16) work_set_cnt =  32;
		if (work_buf_len < MAXPATHLEN) work_buf_len = MAXPATHLEN;
		if (work_buf_len < 512) work_buf_len = 512;
		msg_set_cnt = work_set_cnt;
		msg_buf_len = work_buf_len;
		msg_bufpp = (char**)new_mem(msg_set_cnt * sizeof(char*));
		for (i = 0 ; i < msg_set_cnt ; ++i) {
			msg_bufpp[i] = (char*)new_mem(msg_buf_len+2);
			}
		msg_set_ix = 0;
		}
	if (siz < 0) {
		/* parge looped buf */
		if (msg_bufpp != 0) {
			for (i = 0 ; i < msg_set_cnt ; ++i) {
				del_mem(msg_bufpp[i]);
				}
			del_mem(msg_bufpp);
			msg_bufpp = 0;
			}
		return 0;
		}
	if (siz > msg_buf_len) {
		sprintf(serr_buf,"get_looped_buf(): length over size=%d",siz);
		sys_error(0);
		}
	i = (msg_set_ix + 1) % msg_set_cnt;
	return msg_bufpp[msg_set_ix = i];
	}


/* ========================================================================= */
/* =====   bdkkǗ                                          ===== */
/* ========================================================================= */


#define MASS_MAX ((size_t)1024*2)
size_t mass_max = MASS_MAX;


ENTRY void* new_segmem(alloc_ctl* acp, size_t c_siz) {
	char*  sp;
	/* Vȃ̊蓖 */
	sp = new_mem(c_siz + sizeof(void*));
	*((void**)sp) = acp->link_p;
	acp->link_p = (void*)sp;
	sp += sizeof(void*);
	memset(sp,0,c_siz);
	return (void*)sp;
	}


ENTRY void del_segmem(alloc_ctl* acp, void* sp) {
	void** spp;
	if (sp == 0) return;
	/* t̃|C^Đ */
	sp = ((char*)sp) - sizeof(void*);
	/* 肳ꂽXgOĕԋp*/
	for (spp = &(acp->link_p) ; *spp != 0 ; spp = (void**)*spp) {
		if (*spp == sp) {
			*spp = *((void**)sp);
			del_mem(sp);
			return;
			}
		}
	sprintf(serr_buf,"");
	sys_error("ret_mem not found");
	}


ENTRY void* resize_segmem(alloc_ctl* acp, void* vp, size_t o_siz, size_t n_siz) {
	void* np = (void*)new_segmem(acp,n_siz);
	if (vp != 0 && o_siz != 0) {
		memcpy(np,vp,o_siz);
		del_segmem(acp, vp);
		}
	return np;
	}


ENTRY void* new_alloc(alloc_ctl* acp, size_t c_siz) {
	enum { alignment = sizeof(int)};
	size_t n;
	void*  sp;
	n = (c_siz + alignment - 1) / alignment;
	c_siz = n * alignment;
	if (acp->buf_ix + c_siz >= acp->buf_end) {
		/* cĂȂ */
		acp->buf_end = (mass_max >= c_siz) ? mass_max : c_siz;
		acp->buf_ix  = 0;
		/* Vȃ̊蓖 */
		acp->buf_ptr = (char*)new_segmem(acp, acp->buf_end);
		}
	sp = (void*)(acp->buf_ptr);
	acp->buf_ptr += c_siz;
	acp->buf_ix  += c_siz;
	return sp;
	}


ENTRY void parge_allseg(alloc_ctl* acp) {
	void* sp;
	void* np;
	if (acp == 0) return;
	for (sp = acp->link_p ; sp != 0 ; sp = np) {
		np = *((void**)sp);
		del_mem(sp);
		}
	memset(acp,0,sizeof(*acp));
	}


ENTRY alloc_ctl* new_mactl(void) {
	alloc_ctl* np = new_mem(sizeof(*np));
	memset(np,0,sizeof(*np));
	return np;
	}


ENTRY void del_mactl(alloc_ctl* acp) {
	if (acp == 0) return;
	parge_allseg(acp);
	del_mem(acp);
	}


ENTRY entity_ctl* new_entctl(alloc_ctl* acp, size_t siz) {
	entity_ctl* ecp = new_alloc(acp, sizeof(*ecp));
	ecp->acp = acp;
	ecp->siz = siz;
	ecp->yard_p = 0;
	return ecp;
	}


ENTRY void* new_entity(entity_ctl* ecp) {
	void* sp = ecp->yard_p;
	if (sp != 0) ecp->yard_p = *((void **)sp);
	else sp = new_alloc(ecp->acp, ecp->siz);
	memset(sp,0,ecp->siz);
	return sp;
	}


ENTRY void del_entity(entity_ctl* ecp, void *sp) {
	if (sp == 0) return;
	*((void**)sp) = ecp->yard_p;
	ecp->yard_p = sp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY char* str_dup(alloc_ctl* acp, char* word) {
	if (word == 0) return 0;
	return strcpy((char*)new_segmem(acp,strlen(word)+1),word);
	}


/* ̕ύXȂstrtok()  */


ENTRY char* str_tok(char* str, char* delm) {
	static char* buf = 0;
	static int   len = 0;
	int i;
	if (str == NULL) return strtok(NULL,delm);
	i = strlen(str) + 1;
	if (len < i) {
		len = i;
		if (len < 100) len = 100;
		if (buf != 0) del_mem(buf);
		buf = new_mem(len);
		}
	memcpy(buf,str,i);
	return strtok(buf,delm);
	}


/* ̃g[N؂oĔzɊi[ */


ENTRY bag_arr* str_tok_arr(char* str,char* delm) {
	alloc_ctl* acp;
	bag_arr* bagp;
	char* tok;
	if (str == 0 || str[0] == 0) return 0;
	acp = new_mactl();
	bagp = new_bag(acp);
	tok = str_tok(str,delm);
	while(tok != NULL) {
		append_bag_que(bagp,str_dup(acp,tok));
		tok = str_tok(NULL,delm);
		}
	return bagp;
	}


/* [̋󔒕 */


ENTRY int cut_tail_space(char* sp) {
	int i,j,c;
	for (i = 0, j = -1 ; (c = sp[i]) != 0 ; ++i) {
		if (c != ' ' && c != '\t') 	j = i;
		}
	sp[++j] = 0;
	return j;
	}



/* ========================================================================= */
/* =====    Word dictionary access                                     ===== */
/* ========================================================================= */


/* ====== word_dict structure =========================================
    define data as:
    code : charactor code
    goal : key code
    rp: parent pointer
    bp: brother pointer
    np: next charactor pointer

     *---> [root]
     |     :code = 0
     |     :goal = NO_GOAL
     |     :rp = 0
     |  *- :bp:
     |  |  :np = 0
     |  |
     |  |
     |  *->:code = top char (example 'a')
     |     :goal = for "a"
     |<--- :rp  
     |  *- :bp  
     |  |  :np --->:code = 2'nd char (example '1')
     |  |  ^       :goal = for "a1"
     |  |  |<----- :rp  
     |  |  |    *- :bp  
     |  |  |    |  :np --->:code = 3'rd char (example 'A')
     |  |  |    |  ^       :goal = for "a1A"
     |  |  |    |  |<----- :rp
     |  |  |    |  |    *- :bp
     |  |  |    |  |    |  :np = 0 : end
     |  |  |    |  |    |
     |  |  |    |  |    *->:code = 3'rd char (example 'B')
     |  |  |    |  |       :goal = for "a1B"
     |  |  |    |  *------ :rp
     |  |  |    |          :bp = 0 : end
     |  |  |    |          :np = 0 : end
     |  |  |    |        
     |  |  |    |
     |  |  |    *->:code = 2'nd char (example '2')
     |  |  |       :goal = for "a2"
     |  |  *------ :rp  
     |  |          :bp = 0 : end
     |  |          :np --->:code = 3'rd char (example 'A')
     |  |          ^       :goal = for "a2A"
     |  |          |<----- :rp
     |  |          |    *- :bp
     |  |          |    |  :np = 0 : end
     |  |          |    |
     |  |          |    *->:code = 3'rd char (example 'B')
     |  |          |       :goal = for "a2B"
     |  |          *------ :rp
     |  |                  :bp = 0 : end
     |  |                  :np = 0 : end
     |  |        
     |  |
     |  *->:code = top char (example 'b')
     |     :goal = for "b"
     *---- :rp  
           :bp = 0 : end
           :np --->:code = 2'nd char (example '1')
           ^       :goal = for "b1"
           *------ :rp  
                   :bp = 0 : end
                   |np --->:code = 3'rd char (example 'A')
                   ^       :goal = for "b1A"
                   *------ :rp
                           :bp = 0 : end
                           :np = 0 : end
====== word_dict structure ========================================= */


static word_dict* new_word_dict(alloc_ctl* acp) {
	word_dict* rdp = new_alloc(acp, sizeof(*rdp));
	rdp->code = 0;
	rdp->goal = NO_GOAL;
	rdp->rp = 0;
	rdp->bp = 0;
	rdp->np = 0;
	return rdp;
	}


ENTRY word_dict* teach_word_dict(alloc_ctl* acp, key_word* kw) {
	word_dict* rdp = new_word_dict(acp);
	while(kw->key) {
		word_dict_record(acp,rdp,kw->word,kw->key);
		++kw;
		}
	return rdp;
	}


/* 񒆂̃GXP[v𕶎R[hɕϊ */

static int strcnv_hexcode(char* buf, char* sp) {
	char* dp = buf;
	int c,d;
	int quote;
	quote = 0;
	switch(*sp) {
	case 0  : return 0;
	case '"': quote = '"'; sp++;
		}
	forever {
		c = *sp++;
	next:
		if (c == 0) break;
		if (c == '\\') {
			/* GXP[v */
			switch(c = *sp++) {
			case '_' : continue;		/* Ő؂ */
			case '\r': continue;		/* Ő؂ */
			case '\n': *dp++ = ' ' ; continue;
			case '"' : *dp++ = '"' ; continue;
			case '\'': *dp++ = '\''; continue;
			case '\\': *dp++ = '\\'; continue;
			case '?' : *dp++ = '?' ; continue;
			case 'a' : *dp++ = 0x07; continue;
			case 'b' : *dp++ = 0x08; continue;
			case 'e' : *dp++ = 0x1b; continue;
			case 'f' : *dp++ = 0x0c; continue;
			case 'n' : *dp++ = '\n'; continue;
			case 'r' : *dp++ = '\r'; continue;
			case 't' : *dp++ = '\t'; continue;
			case 'v' : *dp++ = 0x0b; continue;
			case 'x' :
				/* PUiϊ */
				d = 0;
				while ((c = *sp++) != 0) {
					if      (c>='0' && c<='9') d = d * 16 + c - '0';
					else if (c>='A' && c<='F') d = d * 16 + c - 'A' + 10;
					else if (c>='a' && c<='f') d = d * 16 + c - 'a' + 10;
					else break;
					}
				*dp++ = (char)d;
				break;
			default:
				if (c >= '@' && c <= 'Z') {
					*dp++ = (char)(c - '@');
					continue;
					}
				if (!(c >= '0' && c <= '7')) {
					*dp++ = (char)'\\';
					break;
					}
				/* Wiϊ */
				d = c - '0';
				while ((c = *sp++) != 0) {
					if (c>='0' && c<='7') d = d * 8 + c - '0';
					else break;
					}
				*dp++ = (char)d;
				}
			goto next;
			}
		else if (c == '"' && c == quote) break;
		*dp++ = (char)c;
		}
	*dp = 0;
	return (int)(dp - buf);
	}


ENTRY int word_dict_record(alloc_ctl* acp, word_dict* here, char* defdata, int key) {
	word_dict *p, *q, **pp;
	char* wp;
	int wlen;
	int w;
	if (defdata == 0) sys_error("word dictionary (null word)");
	wp = get_looped_buf(512);
	/* GXP[vwR[hɕϊ */
	wlen = strcnv_hexcode(wp,defdata);
	while (wlen-- > 0) {
		w = *wp;				/* this node char in the word */
		for (pp = &(here->np), p = *pp ; p != 0 ; pp = &(p->bp), p = *pp) {
			if (p->code == w) goto next;
			if (p->code >  w) break;
			}
		if (key == NO_GOAL || acp == 0) return NO_GOAL;	/* o^ĂȂ */
		q = new_word_dict(acp);
		(*pp) = q;
		q->code = w;
		q->rp = here;
		q->bp = p;
		p = q;
	next:
		if (wlen == 0) {
			if (key != NO_GOAL) {
				if (p->goal != NO_GOAL && (p->goal != key)) {
					sys_error("duplicate key");
					}
				p->goal = key;
				}
			return p->goal;
			}
		here = p;
		++wp;
		}
	return NO_GOAL;
	}


ENTRY word_dict* word_dict_step_lookup(word_dict* here, int w) {
	word_dict *p;
	if (w == EOF) return 0;
	for (p = here->np; p != 0; p = p->bp) {
		if (p->code == w) return p;
		if (p->code >  w) break;
		}
	return 0;
	}


static word_dict* seek_goal_under(word_dict* dictp, int goal) {
	word_dict* dp;
	word_dict* np;
	for(dp = dictp ; dp != 0 ; dp = dp->bp) {
		if (dp->goal == goal) return dp;
		np = seek_goal_under(dp->np, goal);
		if (np != 0) return np;
		}
	return 0;
	}


static word_dict* seek_dict_goal(word_dict* dictp, int goal) {
	word_dict* dp;
	word_dict* rp;
	if (dictp == 0) return 0;
	/* ̎qT */
	dp = seek_goal_under(dictp->np, goal);
	if (dp != 0) return dp;
	/* ̒T */
	dp = seek_goal_under(dictp->bp, goal);
	if (dp != 0) return dp;
	/* ̐eɖ߂ */
	rp = dictp->rp;
	if (rp == 0) return 0;
	/* ̏fT */
	return seek_goal_under(rp->bp, goal);
	}


static char* get_dict_word(word_dict* dictp, char* buf) {
	if (dictp->rp != 0) buf = get_dict_word(dictp->rp, buf);
	*buf++ = (char)(dictp->code);
	return buf;
	}


/* ========================================================================= */
/* =====        GXP[vfR[hȂP           ===== */
/* ========================================================================= */


static int ungetche_buf[128];
static int ungetche_ix = 0;


ENTRY void unget_ch(int c) {
	ungetche_buf[ungetche_ix++] = c;
	}


ENTRY int is_jchar(int c) {
	return ((c & 0x80) != 0);
	}


#if defined(CONSOR)

ENTRY int inp_ch(word_dict* dictp) {
	word_dict* p;
	word_dict* q;
	int c,c2;
	for (p = dictp ; ; p = q) {
		c = get_ch();
		if ((c & 0xff00) != 0) break;
		if ((q = word_dict_step_lookup(p,c)) == 0) break;
		if (word_dict_goal(q) != NO_GOAL) {			/* goal */
			ungetche_ix = 0;
			return word_dict_goal(q);
			}
		}
	forever {
		unget_ch(c);
		if (p == dictp) break;
		c = word_dict_code(p);
		p = word_dict_parent(p);
		}
	c = get_ch();
	/* asc || func code */
	if (!is_jchar(c) || (c & 0xff00) == 0xff00) return c;
	c2 = get_ch();
	return ((c << 8) | (c2 & 0xff));
	}

#endif (CONSOR)


/* ========================================================================= */
/* =====    \[ĝ߂̕ri̐l͗Drj       ===== */
/* ========================================================================= */


static int num_comp(char* s1, char* s2);


ENTRY int str_comp(char* s1, char* s2) {
	int c;
	int l1;
	int l2;
	char *p;
	/* ̏I`FbN */
	if (*s1 == 0) {
		if (*s2 == 0) return 0;
		return -1;
		}
	if (*s2 == 0) return 1;
	/* s1,s2 Ƃ̏IłȂ */
	for (l1 = 0, p = s1 ; (c = *p++) != 0 ; ++l1) {
		if (c >= '0' && c <= '9') break;
		}
	for (l2 = 0, p = s2 ; (c = *p++) != 0 ; ++l2) {
		if (c >= '0' && c <= '9') break;
		}
	if (l1 != 0) {	/* s1 ͕Ŏn܂ */
		if (l2 != 0) {	/* s2 ͕Ŏn܂ */
			while(l1 > 0 && l2 > 0) {
				c = *s1++ - *s2++;
				if (c != 0) return c;
				--l1;
				--l2;
				}
			if (l1 == 0 && l2 != 0) return -1;
			if (l1 != 0 && l2 == 0) return  1;
			return num_comp(s1,s2);
			}
		/* s2 ͐lŎn܂ */
		return 1;
		}
	/* s1 ͐lŎn܂ */
	if (l2 != 0) {	/* s2 ͕Ŏn܂ */
		return 1;
		}
	/* s1,s2 ƂlŎn܂ */
	return num_comp(s1,s2);
	}


static int num_comp(char* s1, char* s2) {
	int c;
	int l1;
	int l2;
	char *p;
	/* ̏I`FbN */
	if (*s1 == 0) {
		if (*s2 == 0) return 0;
		return -1;
		}
	if (*s2 == 0) return 1;
	/* s1,s2 Ƃ̏IłȂ */
	for (l1 = 0, p = s1 ; (c = *p++) != 0 ; ++l1) {
		if (c < '0' || c > '9') break;
		}
	for (l2 = 0, p = s2 ; (c = *p++) != 0 ; ++l2) {
		if (c < '0' || c > '9') break;
		}
	if (l1 != 0) {	/* s1 ͐lŎn܂ */
		if (l2 != 0) {	/* s2 ͐lŎn܂ */
			if (l1 < l2) return -1;
			if (l1 > l2) return  1;
			while (l1-- > 0) {
				c = *s1++ - *s2++;
				if (c != 0) return c;
				}
			return str_comp(s1,s2);
			}
		/* s2 ͕Ŏn܂ */
		return -1;
		}
	/* s1 ͕Ŏn܂ */
	if (l2 != 0) {	/* s2 ͐lŎn܂ */
		return 1;
		}
	/* s1,s2 ƂŎn܂ */
	return str_comp(s1,s2);
	}


/* ========================================================================= */
/* =====    ChJ[hr                             ===== */
/* ========================================================================= */


ENTRY int wildcmp(
	char* s1,		/* "*","?" ̃ChJ[h܂ŗǂ */
	char* s2,
	int  tolower	/* 啶E̋ʂȂ */
) {
	char c1;
	char c2;
	while (*s1 != 0) {
		switch(c1 = *s1++) {
		case '*':
			while (*s2 != 0) {
				if (wildcmp(s1,s2,tolower) == 0) goto match;
				++s2;
				}
			break;
		case '?':
			if (*s2 == 0) return 1;	/* miss */
			++s2;
			break;
		default:
			c2 = *s2++;
			if (tolower) {
				if (c1 >= 'A' && c1 <= 'Z') c1 += (char)('a' - 'A');
				if (c2 >= 'A' && c2 <= 'Z') c2 += (char)('a' - 'A');
				}
			if (c2 == 0 || c1 != c2) return 1;
			break;
			}
		}
	if (*s2 != 0) return 1;	/* miss */
match:
	return 0;		/* match */
	}


/* ========================================================================= */
/* =====    QoCgR[hn̕r@@@@@@@@@@@@       ===== */
/* ========================================================================= */


ENTRY int jstr_cmp(
	int* s1,	/* QoCgR[h */
	int* s2		/* QoCgR[h */
) {
	int c1;
	int c2;
	while (*s1 != 0) {
		c1 = *s1++;
		c2 = *s2++;
		if (c2 == 0) return 1;
		if (c1 != c2) return (c1 - c2);
		}
	if (*s2 == 0) return 0;
	return -1;
	}


ENTRY int jwildcmp(
	int* s1,		/* "*",("?") ̃ChJ[h܂ŗǂ */
	int* s2,		/* QoCgR[h */
	int  tolower	/* 啶E̋ʂȂ */
) {
	int c1;
	int c2;
	while (*s1 != 0) {
		switch(c1 = *s1++) {
		case '*':
			while (*s2 != 0) {
				if (jwildcmp(s1,s2,tolower) == 0) goto match;
				++s2;
				}
			break;
		case '?':
			if (*s2 == 0) return 1;	/* miss */
			++s2;
			break;
		default:
			c2 = *s2++;
			if (tolower) {
				if (c1 >= 'A' && c1 <= 'Z') c1 += 'a' - 'A';
				if (c2 >= 'A' && c2 <= 'Z') c2 += 'a' - 'A';
				}
			if (c2 == 0 || c1 != c2) return 1;
			break;
			}
		}
	if (*s2 != 0) return 1;	/* miss */
match:
	return 0;		/* match */
	}


ENTRY int sjwildcmp(
	char* s1,		/* "*","?" ̃ChJ[h܂ŗǂ */
	int*  s2,		/* QoCgR[h */
	int  tolower	/* 啶E̋ʂȂ */
) {
	int c1;
	int c2;
	while (*s1 != 0) {
		switch(c1 = *s1++) {
		case '*':
			while (*s2 != 0) {
				if (sjwildcmp(s1,s2,tolower) == 0) goto match;
				++s2;
				}
			break;
		case '?':
			if (*s2 == 0) return 1;	/* miss */
			++s2;
			break;
		default:
			c2 = *s2++;
			if (tolower) {
				if (c1 >= 'A' && c1 <= 'Z') c1 += 'a' - 'A';
				if (c2 >= 'A' && c2 <= 'Z') c2 += 'a' - 'A';
				}
			if (c2 == 0 || c1 != c2) return 1;
			break;
			}
		}
	if (*s2 != 0) return 1;	/* miss */
match:
	return 0;		/* match */
	}


/* ========================================================================= */
/* =====   zgXg\                                      ===== */
/* ========================================================================= */


#define MAXSIZ ((size_t)(-3)/sizeof(int*))


ENTRY size_t size_doubler(size_t siz, size_t init) {
	size_t newsiz = init;
	if (siz == MAXSIZ) sys_error("size_doubler exceed");
	else if (siz >= MAXSIZ/2) newsiz = MAXSIZ;
	else if (siz != 0) newsiz = siz * 2;
	return newsiz;
	}


ENTRY bag_arr* new_bag(alloc_ctl* acp) {
	bag_arr* bagp = new_alloc(acp,sizeof(*bagp));
	bagp->acp = acp;
	return bagp;
	}


ENTRY void append_bag_que(bag_arr* bagp, void* vp) {
	alloc_ctl* acp = bagp->acp;
	if (bagp->ix == bagp->len) {
		bagp->len = size_doubler(bagp->len,10);
		bagp->ap = (void**)resize_segmem(acp,bagp->ap,
					 sizeof(void*)*bagp->ix, sizeof(void*)*bagp->len);
		}
	bagp->ap[bagp->ix++] = (void*)vp;
	}


ENTRY void append_bagpp_que(alloc_ctl* acp, bag_arr** bagpp, void* vp) {
	bag_arr* bagp;
	if (*bagpp == 0) *bagpp = new_bag(acp);
	bagp = *bagpp;
	if (bagp->ix == bagp->len) {
		bagp->len = size_doubler(bagp->len,10);
		bagp->ap = (void**)resize_segmem(acp,bagp->ap,
					 sizeof(void*)*bagp->ix, sizeof(void*)*bagp->len);
		}
	bagp->ap[bagp->ix++] = (void*)vp;
	}


ENTRY void push_value_in_bag(bag_arr* bagp, void* vp, size_t siz) {
	void* np;
	if (bagp->ix == bagp->len) {
		/* CfFNXE|C^[z񂪈tȂ̂Ŋg */
		append_bag_que(bagp, 0);
		/* s̋f[^ */
		bagp->ix--;
		}
	np = bagp->ap[bagp->ix];
	if (np == 0) {
		/* l̊i[̂ΊmۂĂ */
		np = bagp->ap[bagp->ix] = new_alloc(bagp->acp,siz);
		}
	memcpy(np,vp,siz);
	bagp->ix++;
	}


ENTRY void* pop_value_from_bag(bag_arr* bagp) {
	if (bagp->ix == 0) return 0;
	return bagp->ap[--(bagp->ix)];
	}


ENTRY alloc_ctl* new_push_mactl(bag_arr* bagp) {
	alloc_ctl* acp;
	acp = new_mactl();
	push_value_in_bag(bagp, &acp, sizeof(acp));
	return acp;
	}


ENTRY void del_pop_mactl(bag_arr* bagp) {
	alloc_ctl* acp;
	acp = *(alloc_ctl**)pop_value_from_bag(bagp);
	del_mactl(acp);
	}


ENTRY void all_pop_mactl(bag_arr* bagp) {
	alloc_ctl** acpp;
	while((acpp = (alloc_ctl**)pop_value_from_bag(bagp)) != 0) del_mactl(*acpp);
	}



ENTRY int cmp_void_ptr(void* v1, void* v2) {
	if (v1 == v2) return 0;
	return 1;
	}


ENTRY void* remove_bag_que(bag_arr* bagp, void* vp, int (*cmp)(void*,void*)) {
	void* dp;
	int i;
	for (i = 0 ; i < bagp->ix ; ++i) {
		if (cmp(bagp->ap[i],vp) == 0) goto del;
		}
	return 0;
del:
	dp = bagp->ap[i];
	for (  ; i < bagp->ix-1 ; ++i) {
		bagp->ap[i] = bagp->ap[i+1];
		}
	bagp->ix--;
	return dp;
	}


ENTRY void parge_bag_que(bag_arr* bagp, void (*del)(void*)) {
	int i;
	for (i = 0 ; i < bagp->ix ; ++i) {
		if (del != 0) del(bagp->ap[i]);
		}
	bagp->ix = 0;
	}


ENTRY char** args_dup(alloc_ctl* acp, int argc, char** argv) {
	int i;
	char** args;
	if (argc == 0 || argv == 0) return 0;
	/* R}hvf̃Rs[ */
	args = (char**)new_segmem(acp,sizeof(char*)*argc);
	for(i = 0 ; i < argc ; ++i) {
		args[i] = str_dup(acp,argv[i]);
		}
	return args;
	}


/*===========================================================================*/
/*=====   t@C̊gqύX                                  =====*/
/*===========================================================================*/


ENTRY char* another_ext_file_name(char* fn,char* ext) {
	char* buf  = get_looped_buf(0);
	char* path = get_looped_buf(0);
	int i,len;
	len  = strlen(fn);
	sprintf(path,"%s",fn);
	for(i = len-1 ; i >= 0 ; --i) {
		switch(fn[i]) {
		case '.':
			path[i] = 0;
			goto set;
		case ':':
		case '\\':
		case '/':
			goto set;
			}
		}
set:
	sprintf(buf,"%s%s",path,ext);
	return buf;
	}


/*===========================================================================*/
/*=====   Np[^t@C瓾                              =====*/
/*===========================================================================*/


ENTRY void put_char_visible(int c, FILE* wfp) {
	static int hexon = 0;
	if (c == EOF) {
		hexon = 0;
		return;
		}
	/* OPUi\̏ꍇA؂L} */
	if (hexon != 0) {
		if ((c >= '0' && c <= '9') ||
			(c >= 'A' && c <= 'F') ||
			(c >= 'a' && c <= 'f') ) fprintf(wfp,"\\_");
		}
	hexon = 0;
	switch(c) {
	case '\t':	fprintf(wfp,"\\t"); return;
	case '\r':	fprintf(wfp,"\\r"); return;
	case '\n':	fprintf(wfp,"\\n"); return;
	case '\x1b':fprintf(wfp,"\\e"); return;
		}
	if (c >= '@' - '@' && c <= 'Z' - '@') {
		putchar('\\');
		putchar(c+'@');
		return;
		}
	if (c >= ' ' && c <= '~') {
		putchar(c);
		return;
		}
	fprintf(wfp,"\\x%02x",c&0xff);
	hexon = 1;
	}


/* t@CǂŁAeϐ̏lݒ肷 */


ENTRY int get_filedef(alloc_ctl* acp, char* fname, setup_parm* setup_tbl[]) {
	static char* comment = "/#;\r\n";
	static char* delm = " =,\t\r\n";
	setup_parm*  prm;
	FILE* rfp;
	char* rdbuf;
	char* valname;
	char* defdata;
	word_dict* dictp;
	char* sp;
	int   c;
	int   tbl_no,tbl_len;
	int   i,j;
	int   line_no;
	int   rtc;
	rfp = fopen(fname,"rt");
	if (rfp == NULL) return 0;
	/* setupe[ǔ𐔂 */
	for (tbl_len = 0 ; (prm = setup_tbl[tbl_len]) != 0 ; ++tbl_len);
	tbl_no = 0;
	/* sǂݍݗp̍ƃobt@m */
	rdbuf = new_mem(512);
	/* esƂɃZbgAbv */
	line_no = 0;
	while (fgets(rdbuf,510,rfp) != NULL) {
		++line_no;
		/* Ώۂ̕ϐ擾 */
		valname = strtok(rdbuf,delm);
		if (valname == NULL) continue;
		c = valname[0];
		/* RgsH */
		if (strchr(comment,c) != NULL) continue;
		/* ϐH */
		if (!(c == '_' || (c >= 'A' && c <= 'Z') || (c >= 'a' && c <= 'z') )) {
			fprintf(serr_efp,"(%s -%d) ",fname,line_no);
			fprintf(serr_efp,"%s : token required.\n",valname);
			continue;
			}
		/* l̎擾 */
		defdata = strtok(NULL,delm);
		if (defdata == NULL) {
			fprintf(serr_efp,"(%s -%d) ",fname,line_no);
			fprintf(serr_efp,"%s : value required.\n",valname);
			continue;
			}
		/* w肳ꂽϐsetupe[uT */
	seek:
		for (j = 0 ; j < tbl_len ; ++j) {
			/* e[uTn߂inYj */
			prm = setup_tbl[tbl_no];
			for (i = 0 ; prm->name != 0 ; ++i,++prm) {
				/* w肳ꂽϐ̓o^邩H */
				if (strcmp(valname, prm->name) == 0) goto set;
				}
			/* tbl_no Ԗڂ̃e[uɂ͖̂ŁAT */
			tbl_no = (tbl_no + 1) % tbl_len;
			}
		/* Ssetupe[uTAw肳ꂽϐ͂Ȃ */
		fprintf(serr_efp,"(%s -%d) ",fname,line_no);
		fprintf(serr_efp,"%s : unknown token.\n",valname);
		continue;
		/* w肳ꂽϐ^ɂĒlZbg */
	set:
		if (strcmp(prm->type,"%s") == 0) {
			/* f[^ */
			/* GXP[vwR[hɕϊ */
			*(char**)(prm->valp) = sp = (char*)new_mem(strlen(defdata)+1);
			strcnv_hexcode(sp,defdata);
			rtc = 1;
			}
		else if (strcmp(prm->type,"%w") == 0) {
			/* [hf[^ */
			/* \߁AG[o^Ă */
			sprintf(serr_buf,"(%s -%d) %s = %s : ",
					fname,line_no, valname, defdata);
			/* |C^擾 */
			dictp = *(word_dict**)(prm->valp);
			if (dictp == 0) {
				dictp = new_word_dict(acp);
				*(word_dict**)(prm->valp) = dictp;
				}
			word_dict_record(acp,dictp,defdata,prm->code);
			/* G[̏ */
			serr_buf[0] = 0;
			/* d`̏ꍇɑΏ */
			defdata = strtok(NULL,delm);
			if (defdata != NULL) {
				/* d`Ă邩H */
				if (strchr(comment,defdata[0]) == NULL) goto seek;
				}
			rtc = 1;
			}
		else {
			rtc = sscanf(defdata, prm->type, prm->valp);
			}
		if (rtc != 1) {
			fprintf(serr_efp,"(%s -%d) ",fname,line_no);
			fprintf(serr_efp,"%s : value fail.\n",valname);
			}
		}
	del_mem(rdbuf);
	fclose(rfp);
	get_looped_buf(-1);	/* parge looped_buf */
	return 1;
	}


/* łeϐ̌ݒl\ */


ENTRY void put_filedef(setup_parm* setup_tbl[]) {
	setup_parm* prm;
	word_dict* dictp;
	FILE* wfp = stdout;
	char* typ;
	char* buf;
	char* sp;
	char* ep;
	int   c,i,j;
	for (j = 0 ; ; ++j) {
		if ((prm = setup_tbl[j]) == 0) break;
		for (i = 0 ; prm->name != 0 ; ++i, ++prm) {
			typ = prm->type;
			if (strcmp(typ,"%d") == 0) {
				fprintf(wfp,"%s = %d\n",prm->name,*(int*)(prm->valp));
				}
			else if (strcmp(typ,"%ld")== 0) {
				fprintf(wfp,"%s = %ld\n",prm->name,*(long*)(prm->valp));
				}
			else if (strcmp(typ,"%s") == 0) {
				sp = *(char**)(prm->valp);
				fprintf(wfp,"%s = \"",prm->name);
				put_char_visible(EOF,wfp);
				while((c = *sp++) != 0) {
					put_char_visible(c&0xff,wfp);
					}
				fprintf(wfp,"\"\n");
				}
			else if (strcmp(typ,"%w") == 0) {
				dictp = *(word_dict**)(prm->valp);
				fprintf(wfp,"%s ",prm->name);
				c = '=';
				buf = get_looped_buf(0);
				forever {
					/* S[tɁA`T */
					dictp = seek_dict_goal(dictp,prm->code);
					if (dictp == 0) break;
					/* `obt@Ɋi[i\x00Ăj */
					ep = get_dict_word(dictp,buf);
					fprintf(wfp,"%c \"",c);
					sp = buf + 1;	/* 擪̓[g̃k */
					put_char_visible(EOF,wfp);	/* wLTL */
					while(sp != ep) {
						put_char_visible(*sp++&0xff,wfp);
						}
					fprintf(wfp,"\"");
					c = ',';
					}
				fprintf(wfp,"\n");
				}
			else fprintf(wfp,"unknown type\n");
			}
		fprintf(wfp,"\n");
		}
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====   VXeق̋z                                          ===== */
/* ========================================================================= */
/*****************************************************************************/


/* ========================================================================= */
/* =====        Cu֐                                         ===== */
/* ========================================================================= */


#	if (COMPILER == c_TC2)

	static char* opendir_path = NULL;
	DIR* opendir(char* path) {
		static struct ffblk entry;
		opendir_path = path;
		if (findfirst(path,&entry,FA_DIREC) == 0) return &entry;
		return NULL;
		}
	struct dirent* readdir(DIR* dirp) {
		char buf[256];
		if (opendir_path != NULL) {
			sprintf(buf,"%s%c*.*",opendir_path,fdelm_char);
			opendir_path = NULL;
			if (findfirst(buf,dirp,0) == 0) return dirp;
			}
		else {
			if (findnext(dirp) == 0) return dirp;
			}
		return NULL;
		}
	void closedir(DIR* dirp) {
		dirp->d_name[0] = 0;
		}

#	endif


#if defined(CONSOR)

/* ========================================================================= */
/* =====        W͂̃^Cv                                   ===== */
/* ========================================================================= */

#if (DOS == s_UNIX)

#include <sys/ioctl.h>
#include <sgtty.h>

/* BSD 4.3 */
/* GCC mode AXL[oŋǁ@gtmhw@b@vO~Oh p.76 */
/* Ohmsha g@tmhw@b۸ݸޓh p.150 */

ENTRY int isatty(int ifno) {
	struct sgttyb tbuf;
	return (ioctl(ifno,TIOCGETP,&tbuf) == 0);
	}

#endif (DOS == s_UNIX)


/* ========================================================================= */
/* =====        R\[̂P                             ===== */
/* ========================================================================= */


/* ==== MSDOS SYSTEM ===== */


#if (DOS == s_MSDOS)

ENTRY int get_ch(void) {
	union REGS ireg;
	union REGS oreg;
	if (ungetche_ix != 0) return ungetche_buf[--ungetche_ix];
	ireg.h.ah = 7;
	intdos(&ireg, &oreg);
	return oreg.h.al;
	}

#endif (DOS == s_MSDOS)


/* ==== Windows95 SYSTEM ===== */


#if (DOS == s_W95)

ENTRY int get_ch(void) {
	if (ungetche_ix != 0) return ungetche_buf[--ungetche_ix];
	return getch();
	}

#endif (DOS == s_W95)


/* ==== UNIX SYSTEM BSD 4.3 ===== */


#if (DOS == s_UNIX)

#include <sys/ioctl.h>
#include <sgtty.h>


enum {
	CIO_raw,
	CIO_noecho,
	CIO_cooked,
	};


/* GCC mode AXL[oŋǁ@tmhw@b@vO~O p.76 */
/* Ohmsha g@tmhw@b۸ݸޓh p.150 */


static int cio_cooked_mode = CIO_cooked;
ENTRY void raw_console(void) {
	int ifno;
	struct sgttyb tbuf;
	if (cio_cooked_mode == CIO_raw) return;
	cio_cooked_mode = CIO_raw;
	ifno = fileno(stdin);
	ioctl(ifno,TIOCGETP,&tbuf);
	tbuf.sg_flags |= RAW;
	ioctl(ifno,TIOCSETP,&tbuf);
	}
ENTRY void noecho_console(void) {
	int ifno;
	struct sgttyb tbuf;
	if (cio_cooked_mode == CIO_noecho) return;
	cio_cooked_mode = CIO_noecho;
	ifno = fileno(stdin);
	ioctl(ifno,TIOCGETP,&tbuf);
	tbuf.sg_flags &= ~ECHO;
	tbuf.sg_flags |= CBREAK;
	ioctl(ifno,TIOCSETP,&tbuf);
	}
ENTRY void cooked_console(void) {
	int ifno;
	struct sgttyb tbuf;
	if (cio_cooked_mode == CIO_cooked) return;
	cio_cooked_mode = CIO_cooked;
	ifno = fileno(stdin);
	ioctl(ifno,TIOCGETP,&tbuf);
	tbuf.sg_flags &= ~RAW;
	tbuf.sg_flags &= ~CBREAK;
	tbuf.sg_flags |= ECHO;
	ioctl(ifno,TIOCSETP,&tbuf);
	}
ENTRY int get_ch(void) {
	int c;
	if (ungetche_ix != 0) return ungetche_buf[--ungetche_ix];
	if (cio_cooked_mode == 0) raw_console();
	c = getchar();
	return c;
	}

#endif (DOS == s_UNIX)

#endif defined(CONSOR)


/* ========================================================================= */
/* =====        qvZY̋N                                       ===== */
/* ========================================================================= */


ENTRY void child_proc(char* arg) {
	char* shell = "";
#if (DOS == s_MSDOS)
	shell = getenv(SHELL);
#else
	if (arg == 0 || arg[0] == 0) shell = getenv(SHELL);
#	endif
	if (shell == NULL) {
		sprintf(serr_buf,"environment variable '%s' missing",SHELL);
		dsp_error(0);
		return;
		}
	if (arg == 0 || arg[0] == 0) system(shell);
	else {
#	if (DOS == s_MSDOS || DOS == s_W95)
		char* buf = get_looped_buf(0);
		sprintf(buf,"%s /c %s",shell,arg);
		system(buf);
#	else
		system(arg);
#		endif
		}
	}


/* ========================================================================= */
/* =====   lhrb̏e[u                                    ===== */
/* ========================================================================= */


setup_parm misc_ini[] = {
	sup_int(work_set_cnt),
	sup_int(work_buf_len),
	{0,0,0,0},
	};








