/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_misc.h
 *
 * miscellaneous basic functions.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_MISC_H)
#define PS_MISC_H


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


/* ========================================================================= */
/* =====     alias                                                     ===== */
/* ========================================================================= */


ENTRY int alloc_dsplay;
#define forever for(;;)
#define zero_clear(mp) memset(mp,0,sizeof(*mp))


typedef enum {
	FAIL = 0,
	GOOD = 1,
	} answer;


/*===========================================================================*/
/*=====                  VXeLǂݏo                         =====*/
/*===========================================================================*/


typedef struct {
	char*	name;
	void*	valp;
	char*	type;
	int		code;
	} setup_parm;


#define sup_int(val)  {#val,&val,"%d" ,0}
#define sup_long(val) {#val,&val,"%ld",0}
#define sup_str(val)  {#val,&val,"%s" ,0}


enum {
	DEF_sup = 0x0001,
	DEF_rsv = 0x0002,
	};


/* ========================================================================= */
/* =====   bdkkǗ                                          ===== */
/* ========================================================================= */


typedef struct {
	void*  link_p;		/* cell_ctlŎgp̃EXg */
	char*  buf_ptr;		/* ̋󂫈ʒu|C^ */
	size_t buf_end;		/* ̃TCY */
	size_t buf_ix;		/* ̋󂫈ʒuCfFNX */
	} alloc_ctl;


typedef struct {
	alloc_ctl* acp;
	size_t     siz;		/* 蓖Ăstruct̃TCY */
	void*      yard_p;	/* Ԋ҂ꂽentitỹXgbN */
	} entity_ctl;


ENTRY void*  new_alloc(alloc_ctl* acp, size_t c_siz);
ENTRY void   parge_allseg(alloc_ctl* acp);
ENTRY void*  new_segmem(alloc_ctl* acp, size_t c_siz);
ENTRY void   del_segmem(alloc_ctl* acp, void* sp);
ENTRY void*  resize_segmem(alloc_ctl* acp, void* vp, size_t o_siz, size_t n_siz);
ENTRY entity_ctl* new_entctl(alloc_ctl* acp, size_t siz);
ENTRY void*  new_entity(entity_ctl* ecp);
ENTRY void   del_entity(entity_ctl* ecp, void *sp);
ENTRY alloc_ctl* new_mactl(void);
ENTRY void   del_mactl(alloc_ctl* acp);


/* ========================================================================= */
/* =====     bag                                                       ===== */
/* ========================================================================= */


typedef struct s_bag_arr {
	int    len;
	int    ix;
	void** ap;
	alloc_ctl* acp;
	} bag_arr;


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_key_word {
	char *word;
	int   key;
	} key_word;


#define NO_GOAL -1


typedef struct s_word_dict {
	int code;
	int goal;
	struct s_word_dict* rp;
	struct s_word_dict* bp;
	struct s_word_dict* np;
	} word_dict;


#define word_dict_code(p)   ((p)->code)
#define word_dict_goal(p)   ((p)->goal)
#define word_dict_parent(p) ((p)->rp)


ENTRY word_dict* teach_word_dict(alloc_ctl* acp, key_word* kw);
ENTRY int word_dict_record(alloc_ctl*acp, word_dict* here, char* defdata, int key);
ENTRY word_dict* word_dict_step_lookup(word_dict* here, int w);


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


enum {
	KSQ_esc_code = 0x001b,
	KSQ_csi_code = 0xff01,
	KSQ_ins_mode,
	KSQ_nl_code ,
	KSQ_ent_code,

	KSQ_rub_char,
	KSQ_del_char,
	KSQ_lf_char ,
	KSQ_rt_char ,
	KSQ_up_line ,
	KSQ_dw_line ,

	KSQ_bs_word ,
	KSQ_del_word,
	KSQ_lf_word ,
	KSQ_rt_word ,

	KSQ_lf_lhead,
	KSQ_rt_ltail,

	KSQ_del_l_lf,
	KSQ_del_l_rt,
	KSQ_del_line,
	};


ENTRY void unget_ch(int c);
ENTRY int  get_ch(void);
ENTRY int  inp_ch(word_dict* q);


/* ========================================================================= */
/* =====   ps_misc.c                                                   ===== */
/* ========================================================================= */


#if (foot_on > 0)
#	define footmark(n) foot_mark(n)
#else
#	define footmark(n)
#	endif


ENTRY void  indent(FILE* spkfp, int indlvl);
ENTRY FILE* serr_efp;
ENTRY char  serr_buf[];
ENTRY void  dsp_error(char* msg);
ENTRY void  sys_error(char* msg);
ENTRY unsigned long aloc_sum;
ENTRY void* new_mem(size_t siz);
ENTRY void  del_mem(void* p);
ENTRY void* resize_mem(void* vp, size_t o_siz, size_t n_siz);
ENTRY char* str_dup(alloc_ctl* acp, char* word);
ENTRY char* str_tok(char* str, char* delm);
ENTRY bag_arr* str_tok_arr(char* str, char* delm);
ENTRY int cut_tail_space(char* sp);
ENTRY char* another_ext_file_name(char* fn,char* ext);
ENTRY void  put_char_visible(int c, FILE* wfp);
ENTRY int   get_filedef(alloc_ctl* acp, char* fname, setup_parm* setup_tbl[]);
ENTRY void  put_filedef(setup_parm* setup_tbl[]);
ENTRY int   work_buf_len;			/* ʂɎgpobt@̑傫 */
ENTRY int   non_work_buf;			/* work buf ֎~[h */
ENTRY char* get_looped_buf(int siz);
ENTRY int   str_comp(char* s1, char* s2);
ENTRY int   jstr_cmp(int* s1, int* s2);
ENTRY int   wildcmp(char* s1, char* s2, int tolower);
ENTRY int   jwildcmp(int* s1, int* s2, int tolower);
ENTRY int   sjwildcmp(char* s1, int* s2, int tolower);
ENTRY size_t size_doubler(size_t siz, size_t init);
ENTRY bag_arr* new_bag(alloc_ctl* acp);
ENTRY void  append_bag_que(bag_arr* bagp, void* vp);
ENTRY void  push_value_in_bag(bag_arr* bagp, void* vp, size_t siz);
ENTRY void* pop_value_from_bag(bag_arr* bagp);
ENTRY alloc_ctl* new_push_mactl(bag_arr* bagp);
ENTRY void  del_pop_mactl(bag_arr* bagp);
ENTRY void  all_pop_mactl(bag_arr* bagp);
ENTRY int   cmp_void_ptr(void* v1, void* v2);
ENTRY void* remove_bag_que(bag_arr* bagp, void* vp, int (*cmp)(void*,void*));
ENTRY void  parge_bag_que(bag_arr* bagp, void (*del)(void*));
ENTRY char** args_dup(alloc_ctl* acp, int argc, char** argv);
ENTRY void  foot_mark(char* name);
ENTRY void  child_proc(char* arg);


/* ========================================================================= */
/* =====   VXeق̋z                                          ===== */
/* ========================================================================= */


#if (COMPILER == c_TC2)
#	include<dir.h>
#	include<dos.h>
	typedef struct ffblk DIR;
#	define dirent ffblk
#	define d_name ff_name
	DIR* opendir(char* path);
	struct dirent* readdir(DIR* dirp);
	void closedir(DIR* dirp);

#else
#	include<dirent.h>

#	endif


#if (DOS == s_MSDOS)

#	define raw_console()
#	define noecho_console()
#	define cooked_console()

#	if (COMPILER == c_GCC)
#		define fdelm_char '/'
#	else
#		define fdelm_char '\\'
#		endif (COMPILER == c_GCC)
#	define CONST 
#	define SHELL   "COMSPEC"
#	define dir_cmd "dir"
#	define PATH_DELM " \t();\r\n"


#elif (DOS == s_W95)

#	define raw_console()
#	define noecho_console()
#	define cooked_console()
#	define fdelm_char '\\'
#	if !defined(CONST) 
#		define CONST 
#		endif
#	define SHELL   "COMSPEC"
#	define dir_cmd "dir"
#	define PATH_DELM " \t();\r\n"


#elif (DOS == s_UNIX)
	int isatty(int ifno);
	void raw_console(void);
	void noecho_console(void);
	void cooked_console(void);
#	define fdelm_char '/'
#	define CONST   const
#	define SHELL   "shell"
#	define dir_cmd "ls"
#	define PATH_DELM " \t():\r\n"


#else
	int isatty(int ifno);
	void raw_console(void);
	void noecho_console(void);
	void cooked_console(void);
#	define fdelm_char '/'
#	define CONST   const
#	define SHELL   "shell"
#	define dir_cmd "ls"
#	define PATH_DELM " \t():\r\n"

#	endif


#undef  ENTRY
#define ENTRY 


#endif PS_MISC_H

