/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_selec.h
 *
 * system selectors.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_SELEC_H)  
#define PS_SELEC_H


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


/****************************************************************************/
/* ======================================================================== */
/* =====                 SYSTEM  CONTROL  SELECTORS                   ===== */
/* ======================================================================== */
/****************************************************************************/


#define PARSER


#if defined(BC2) || defined(TC)
#	define TC2 
#	endif


#if defined(TC2) 
#	define MSDOS
#	define PC98

#elif defined(DJGCC)
#	define PC98
#	define GCC

#elif defined(FREEBSD)
#	define UNIX
#	define SUN4
#	define GCC

#elif defined(LINUX)
#	define UNIX
#	define SUN4
#	define GCC

#else 
#	define W95
#	define DOSV
#	define BC5

#endif


/*
#define CONSOLE
*/


/* ======================================================================== */
/* =====                  PRODUCT  SELECT                             ===== */
/* ======================================================================== */


#if defined(PARSER)
#	define P_PARSER 

#elif defined(SFLSML)
#	define EXTRA
#	define P_PARSER
#	endif


/* ======================================================================== */
/* =====                  TARGET  MACHINE  SELECT                     ===== */
/* ======================================================================== */


#define m_PC98   1
#define m_DOSV   2
#define m_DOMAIN 3
#define m_SUN4   4
#define m_PS530  5


#if defined(PC98)
#	define MACHINE m_PC98

#elif defined(DOSV)
#	define MACHINE m_DOSV

#elif defined(DOMAIN)
#	define MACHINE m_DOMAIN

#elif defined(SUN4)
#	define MACHINE m_SUN4

#elif defined(PS530)
#	define MACHINE m_PS530

#	endif


/* ======================================================================== */
/* =====                  TARGET  DOS SELECT                          ===== */
/* ======================================================================== */


#define s_MSDOS 1
#define s_W95   2
#define s_UNIX  3


#if defined(MSDOS)
#	define DOS s_MSDOS

#elif defined(W95)
#	define DOS s_W95

#elif defined(UNIX)
#	define DOS s_UNIX
#	endif


/* ======================================================================== */
/* =====                  COMPILER  SELECT                            ===== */
/* ======================================================================== */


#define c_TC2 1
#define c_BC2 2
#define c_BC5 3
#define c_GCC 4


#if defined(TC2)
#	define COMPILER c_TC2

#elif defined(BC2)
#	define COMPILER c_BC2

#elif defined(BC5)
#	define COMPILER c_BC5

#elif defined(GCC)
#	define COMPILER c_GCC

#	endif


/* ======================================================================== */
/* =====               SYSTEM  INCLUDE  SELECTORS                     ===== */
/* ======================================================================== */


#include <stdio.h>
#include <stdlib.h>
#include <setjmp.h>
#include <signal.h>
#include <time.h>
#include <ctype.h>



#if (DOS == s_UNIX)
#	define MKDIR_777 ,0777

#elif (COMPILER == c_GCC)
#	define MKDIR_777 ,0777

#else
#	define MKDIR_777 

#	endif



#if (MACHINE == m_PC98)

#	if (COMPILER == c_TC2)

		/* INCLUDE FILES SELECTORS */
#			include <process.h>
#			include <conio.h>
#			include <string.h>
#			include <mem.h>
#			include <dos.h>
#			include <io.h>
#			include <dir.h>

		/* TYPE & FUNCTIONS  SELECTORS */
			typedef unsigned char  uchar;
			typedef unsigned int   uint;
			typedef unsigned short ushort;
			typedef unsigned long  ulong;
#			define INT_SIZE   2
#			define MAXPATHLEN 1024
#			define getwd(path) getcwd(path,MAXPATHLEN)

#	elif (COMPILER == c_GCC)

		/* INCLUDE FILES SELECTORS */
#			include <sys/types.h>
#			include <sys/times.h>
#			include <string.h>
#			include <dos.h>
#			include <io.h>
#			include <dir.h> 
#			include <std.h> 

		/* TYPE & FUNCTIONS  SELECTORS */
			typedef unsigned char  uchar;
			typedef unsigned int   uint;
			typedef unsigned short ushort;
			typedef unsigned long  ulong;
#			define INT_SIZE   4
#			define MAXPATHLEN 1024

#		endif 

#	define time_s   time
#	define time_s_t time_t



#elif (MACHINE == m_DOSV)

#	if (COMPILER == c_BC5)

		/* INCLUDE FILES SELECTORS */
#			include <sys/types.h>
#			include <process.h>
#			include <conio.h>
#			include <string.h>
#			include <dos.h>
#			include <io.h>
#			include <dir.h>

		/* TYPE & FUNCTIONS  SELECTORS */
			typedef unsigned char  uchar;
			typedef unsigned int   uint;
			typedef unsigned short ushort;
			typedef unsigned long  ulong;
#			define INT_SIZE   4
#			define MAXPATHLEN 1024
#			define getwd(path) getcwd(path,MAXPATHLEN)

#		endif

#	define time_s   time
#	define time_s_t time_t


#elif (MACHINE == m_DOMAIN)

	/* INCLUDE FILES SELECTORS */
#		include <sys/types.h>
#		include <sys/times.h>
#		include <strings.h>

	/* TYPE & FUNCTIONS  SELECTORS */
		typedef unsigned char  uchar;
		typedef unsigned int   uint;
		typedef unsigned long  ulong;
#		define INT_SIZE   4

#	define  time_s      times
	typedef struct tms  time_s_t;



#elif (MACHINE == m_SUN4)

	/* INCLUDE FILES SELECTORS */
#		include <sys/types.h>
#		include <sys/times.h>
#		include <strings.h>
#		include <unistd.h>

	/* TYPE & FUNCTIONS  SELECTORS */
#       if !defined(LINUX)
		typedef unsigned char  uchar;
		typedef unsigned long  ulong;
#       endif
		char *malloc();
		char *realloc();
#		define INT_SIZE   4
#		define MAXPATHLEN 1024
#		define getwd(path) getcwd(path,MAXPATHLEN)

#	define  time_s      times
	typedef struct tms  time_s_t;



#elif (MACHINE == m_PS530)

	/* INCLUDE FILES SELECTORS */
#		include <sys/types.h>
#		include <sys/times.h>
#		include <strings.h>

	/* TYPE & FUNCTIONS  SELECTORS */
		char *malloc();
		char *realloc();
#		define INT_SIZE   4

#	define  time_s      times
	typedef struct tms  time_s_t;


#endif	/* end of MACHINE */




#if !defined(CLK_TCK)
#	if defined(HZ)
#		define CLK_TCK HZ
#	else 
#		define CLK_TCK 1
#		endif
#	endif


#if !defined(q_CONST)
#	define q_CONST const
#	endif


#if !defined(flushall)
#define flushall();
#endif


/* ======================================================================== */
/* =====               NUMERIC  SELECTORS                             ===== */
/* ======================================================================== */


enum {
	LITTLE_ENDIAN_ = 1,
	BIG_ENDIAN_       ,
	};


#if (MACHINE == m_PC98)
#	define _ENDIAN_ LITTLE_ENDIAN_

#elif (MACHINE == m_DOSV)
#	define _ENDIAN_ LITTLE_ENDIAN_

#elif (MACHINE == m_DOMAIN)
#	define _ENDIAN_ BIG_ENDIAN_

#elif (MACHINE == m_SUN4)
#	define _ENDIAN_ BIG_ENDIAN_

#elif (MACHINE == m_PS530)
#	define _ENDIAN_ BIG_ENDIAN_

#endif



/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#undef  ENTRY
#define ENTRY 


#endif PS_SELEC_H


















