/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_tdef.h
 *
 * SFL syntax define & description structure define.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_TDEF_H)
#define PS_TDEF_H


#define MULTI_GLOBAL 1


#if defined(EXTRA)
#	define Ex_tdef
#	include "extra.h"
#	endif


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#if !defined(Ex_tdef_global)
#	define Ex_tdef_global 
#endif


/*****************************************************************************/
/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
/*****************************************************************************/


struct s_cmd_func;


typedef struct s_global {
	jmp_buf* jmpbfp;
	FILE*    errfp;
	char*    ipath;
	lex*     cmdlexp;
	token*   cmdkey_tp;
	lex*     sfllexp;
	token*   sflkey_tp;
	token*   sflnum_tp;
	token*   declare_tp;
	token*   class_tp;

	/* memory control */
	alloc_ctl*  sysacp;
	alloc_ctl*  tmpacp;
	alloc_ctl*  behacp;
	alloc_ctl*  tokacp;
	entity_ctl* tokecp;

    /* sflread work */
	token*   define_tp;
	token*   module_tp;
	token*   stage_tp;
	token*   segment_tp;
	token*   stgseg_tp;
	token*   state_tp;
	word*    sfln_tbl;
	int      cond_cnt;
	bag_arr* c_condp;

    /* command mode */
	struct s_cmd_func* cmd_tbl;
	int      seconds; 	/* seconds݊[hw */
	void*    rsv_hp;
	unsigned int max_figure;
	bag_arr*  child_lexp;

	/* extra members */
	Ex_tdef_global
	} global;


enum {
	SFL_top = LEX_end,
	SFL_meta,
	SFL_key,
	SFL_sfln,
	SFL_opr,
	SFL_decl,
	SFL_root,
	SFL_end,
	CMD_key,
	CMD_elm,
	};


#if (MULTI_GLOBAL > 0)
#	define tMYc global* my, 
#	define tMY  global* my  
#	define  MYc my, 
#	define  MY  my 
#else 
#	define tMYc 
#	define tMY  void 
#	define  MYc 
#	define  MY  
	extern global* my;
#	endif


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


typedef struct s_cmd_func {
	int key;
	void (*func)(tMY);
	} cmd_func;


/*****************************************************************************/
/* ========================================================================= */
/* =====   V{                                                  ===== */
/* ========================================================================= */
/*****************************************************************************/


/* V{ ::= O||萔|L[[h|\ */


/* L[[h ::= */
#define sfl_key \
	def_key(module)\
	def_key(circuit)\
	def_key(declare)\
	def_key(input)\
	def_key(output)\
	def_key(bidirect)\
	def_key(instrin)\
	def_key(instrout)\
	def_key(instrself)\
	def_key(sel)\
	def_key(bus)\
	def_key(sel_v)\
	def_key(bus_v)\
	def_key(reg)\
	def_key(reg_ws)\
	def_key(reg_wr)\
	def_key(mem)\
	def_key(instr_arg)\
	def_key(stage_name)\
	def_key(task)\
	beh_key(instruct)\
	beh_key(stage)\
	def_key(state_name)\
	def_key(segment_name)\
	beh_key(first_state)\
	beh_key(state)\
	beh_key(segment)\
	opr_key(par)\
	opr_key(alt)\
	opr_key(any)\
	opr_key(if)\
	opr_key(else)\
	opr_key(goto)\
	opr_key(call)\
	opr_key(return)\
	opr_key(generate)\
	opr_key(relay)\
	opr_key(finish)\
	beh_key(first)


#undef def_key
#undef beh_key
#undef opr_key
#define def_key(key) KEY_##key,
#define beh_key(key) KEY_##key,
#define opr_key(key) KEY_##key,
enum {
	KEY_top = 512,
	sfl_key
	/* old type SFL stntax */
	KEY_cir_class,
	KEY_sub_class,
	KEY_end
	};


#undef def_key
#undef beh_key
#undef opr_key
#define def_key(key) DEF_##key,
#define beh_key(key) 
#define opr_key(key) 
enum {
	DEF_top = KEY_end,
	sfl_key
	DEF_submod,
	DEF_autosub,
	DEF_vector,
	TPL_module,
	TPL_circuit,
	TPL_declare,
	DEF_end
	};


/* \ ::= */
#define all_rev \
	rev_word(p_reset)\
	rev_word(m_clock)\
	rev_word(s_clock)\
	rev_word(b_clock)\
	rev_word(VDD)\
	rev_word(VSS)\
	rev_word(scan_in)\
	rev_word(scan_out)\
	rev_word(scan_enb)\
	rev_word(scan_clock)\
	rev_word(t_adrs_)\
/*  rev_word(t_adrs_) */


/*
|L[[h ::= 
|	{ } ; , ( ) . : [ ] := = == | @ & || + > < >> << ^ /| /@ /& / \ # 
|L ::= !"#$%&'()*+,-./:;<=>?@[\]^`{|}~ 
|󔒕 ::= uN(space) | ^u(tab) | (newline)
*/


#define all_stropr \
	str_opr(sym_opr)\
	str_opr(active)\
	str_opr(memory)\
	str_opr(mem_rd)\
	str_opr(mem_wt)\
	str_opr(void)\
	str_opr(sfln)\
	str_opr(value)\
	str_opr(if_cond)\
	str_opr(exp_link)\
	str_opr(bracket)\
	str_opr(rel_task)\
	str_opr(ret_stat)\
	str_opr(ret_void)\
	str_opr(behavior)\
	str_opr(branch)\
	str_opr(any_true)\
	str_opr(any_false)\
	str_opr(any_deny)\
	str_opr(inactive)\
	str_opr(taskgen)\
	str_opr(jobstop)\
	str_opr(0expand)\


#undef  def_key
#undef  beh_key
#undef  opr_key
#define def_key(key) 
#define beh_key(key) 
#define opr_key(key) OPR_##key,
#define str_opr(key) OPR_##key,


enum {
	OPR_KEY = LEX_opr,

	OPR_directive,
	OPR_parent,
	OPR_eq_reg,
	OPR_eq_term,

	OPR_cmp_eq,
	OPR_cmp_ne,
	OPR_cmp_gt,
	OPR_cmp_ge,
	OPR_cmp_lt,
	OPR_cmp_le,

	OPR_or,
	OPR_xor,
	OPR_and,
	OPR_partial,

	OPR_lognot,
	OPR_incre,
	OPR_decre,
	OPR_plus,
	OPR_minus,
	OPR_multi,
	OPR_divide,
	OPR_residue,

	OPR_catinate,
	OPR_logand,
	OPR_sft_r,
	OPR_sft_l,
	OPR_invert,
	OPR_bit_or,
	OPR_bit_xor,
	OPR_bit_and,
	OPR_decode,
	OPR_encode,
	OPR_expand,

	OPR_actask,
	OPR_any_e,
	OPR_alt_e,
	all_stropr
	sfl_key

	OPR_end,
	OPR_num,

	NLD_const,
	NLD_sfln,
	NLD_node,
	NLD_sel,
	NLD_or,
	NLD_tst,
	NLD_cond,
	NLD_decode,
	NLD_reverse,
	};


/* ZqxiقǋBl̑召֌WӖj */

enum {
	ELp_value    =  10,
	ELp_dot      =  90,

	MOp_expr     = 100,		/* Version.1̏ꍇ̒P */

	MOp_plus     = 100,
	MOp_minus    = 100,
	MOp_invert   = 100,
	MOp_bit_or   = 100,
	MOp_bit_xor  = 100,
	MOp_bit_and  = 100,
	MOp_lognot   = 100,
	MOp_decode   = 100,
	MOp_encode   = 100,
	MOp_partial  =  20,
	MOp_expand   =  40,
	MOp_0expand  =  40,
	MOp_incre    = 100,
	MOp_decre    = 100,

	BIp_expr     = 200,		/* Version.1̏ꍇ̂Q */

	BIp_or       = 200,
	BIp_xor      = 190,
	BIp_and      = 180,
	BIp_catinate = 220,
	BIp_logand   = 210,
	BIp_plus     = 140,
	BIp_minus    = 140,
	BIp_multi    = 130,
	BIp_divide   = 130,
	BIp_residue  = 130,
	BIp_sft_r    = 150,
	BIp_sft_l    = 150,
	BIp_cmp_eq   = 170,
	BIp_cmp_ne   = 170,
	BIp_cmp_gt   = 160,
	BIp_cmp_ge   = 160,
	BIp_cmp_lt   = 160,
	BIp_cmp_le   = 160,

	NO_priority  =1000,
	};


/* ` ::= */
#define declare_opr \
	def_opr("{"	, '{'          , NO_priority )\
	def_opr("}"	, '}'          , NO_priority )\
	def_opr(";"	, ';'          , NO_priority )\
	def_opr(","	, ','          , NO_priority )\
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr("."	, '.'          , ELp_dot     )\
	def_opr("["	, '['          , NO_priority )\
	def_opr("]"	, ']'          , NO_priority )\
	def_opr(">"	, '>'          , NO_priority )\
	def_opr("<"	, '<'          , NO_priority )\


/*  */
#define behavior_opr \
	def_opr("{"	, '{'          , NO_priority )\
	def_opr("}"	, '}'          , NO_priority )\
	def_opr(";"	, ';'          , NO_priority )\
	def_opr(","	, ','          , NO_priority )\
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr("."	, '.'          , ELp_dot     )\
	def_opr(":"	, ':'          , NO_priority )\
	def_opr("["	, '['          , NO_priority )\
	def_opr("]"	, ']'          , NO_priority )\
	def_opr(":=", OPR_eq_reg   , NO_priority )\
	def_opr("="	, OPR_eq_term  , NO_priority )\
	def_opr(">"	, '>'          , NO_priority )\
	def_opr("<"	, '<'          , NO_priority )\


/* Q */
#define v1_expression_opr \
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr("==", OPR_cmp_eq   , BIp_expr    )\
	def_opr("!=", OPR_cmp_ne   , BIp_expr    )\
	def_opr(">" , OPR_cmp_gt   , BIp_expr    )\
	def_opr(">=", OPR_cmp_ge   , BIp_expr    )\
	def_opr("<=", OPR_cmp_le   , BIp_expr    )\
	def_opr("<" , OPR_cmp_lt   , BIp_expr    )\
	def_opr("|"	, OPR_or       , BIp_expr    )\
	def_opr("@"	, OPR_xor      , BIp_expr    )\
	def_opr("&"	, OPR_and      , BIp_expr    )\
	def_opr("||", OPR_catinate , BIp_expr    )\
	def_opr("&&", OPR_logand   , BIp_expr    )\
	def_opr("+"	, OPR_plus     , BIp_expr    )\
	def_opr("-"	, OPR_minus    , BIp_expr    )\
	def_opr("*"	, OPR_multi    , BIp_expr    )\
	def_opr("/"	, OPR_divide   , BIp_expr    )\
	def_opr("/%", OPR_residue  , BIp_expr    )\
	def_opr(">>", OPR_sft_r    , BIp_expr    )\
	def_opr("<<", OPR_sft_l    , BIp_expr    )\

#define v2_expression_opr \
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr("==", OPR_cmp_eq   , BIp_cmp_eq  )\
	def_opr("!=", OPR_cmp_ne   , BIp_cmp_ne  )\
	def_opr(">" , OPR_cmp_gt   , BIp_cmp_gt  )\
	def_opr(">=", OPR_cmp_ge   , BIp_cmp_ge  )\
	def_opr("<=", OPR_cmp_le   , BIp_cmp_le  )\
	def_opr("<" , OPR_cmp_lt   , BIp_cmp_lt  )\
	def_opr("|"	, OPR_or       , BIp_or      )\
	def_opr("^"	, OPR_xor      , BIp_xor     )\
	def_opr("&"	, OPR_and      , BIp_and     )\
	def_opr("||", OPR_catinate , BIp_catinate)\
	def_opr("&&", OPR_logand   , BIp_logand  )\
	def_opr("+"	, OPR_plus     , BIp_plus    )\
	def_opr("-"	, OPR_minus    , BIp_minus   )\
	def_opr("*"	, OPR_multi    , BIp_multi   )\
	def_opr("/"	, OPR_divide   , BIp_divide  )\
	def_opr("/%", OPR_residue  , BIp_residue )\
	def_opr(">>", OPR_sft_r    , BIp_sft_r   )\
	def_opr("<<", OPR_sft_l    , BIp_sft_l   )\


/* P */
#define v1_mono_expr_opr \
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr(":"	, OPR_partial  , MOp_partial )\
	def_opr("/"	, OPR_decode   , MOp_expr    )\
	def_opr(">"	, '>'          , MOp_partial )\
	def_opr("<"	, '<'          , MOp_partial )\
	def_opr("+"	, OPR_plus     , MOp_plus    )\
	def_opr("-"	, OPR_minus    , MOp_minus   )\
	def_opr("^"	, OPR_invert   , MOp_expr    )\
	def_opr("/|", OPR_bit_or   , MOp_expr    )\
	def_opr("/@", OPR_bit_xor  , MOp_expr    )\
	def_opr("/&", OPR_bit_and  , MOp_expr    )\
	def_opr("++", OPR_incre    , MOp_expr    )\
	def_opr("--", OPR_decre    , MOp_expr    )\
	def_opr("\\", OPR_encode   , MOp_expr    )\
	def_opr("#"	, OPR_expand   , MOp_expand  )\
	def_opr("!" , OPR_lognot   , MOp_expr    )\


#define v2_mono_expr_opr \
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr(":"	, OPR_partial  , MOp_partial )\
	def_opr("/"	, OPR_decode   , MOp_decode  )\
	def_opr(">"	, '>'          , MOp_partial )\
	def_opr("<"	, '<'          , MOp_partial )\
	def_opr("+"	, OPR_plus     , MOp_plus    )\
	def_opr("-"	, OPR_minus    , MOp_minus   )\
	def_opr("~"	, OPR_invert   , MOp_invert  )\
	def_opr("/|", OPR_bit_or   , MOp_bit_or  )\
	def_opr("/^", OPR_bit_xor  , MOp_bit_xor )\
	def_opr("/&", OPR_bit_and  , MOp_bit_and )\
	def_opr("++", OPR_incre    , MOp_incre   )\
	def_opr("--", OPR_decre    , MOp_decre   )\
	def_opr("\\", OPR_encode   , MOp_encode  )\
	def_opr("#"	, OPR_expand   , MOp_expand  )\
	def_opr("!" , OPR_lognot   , MOp_lognot  )\


/* vf */
#define element_opr \
	def_opr(","	, ','          , NO_priority )\
	def_opr("("	, '('          , NO_priority )\
	def_opr(")"	, ')'          , NO_priority )\
	def_opr("."	, '.'          , ELp_dot     )\
	def_opr("["	, '['          , NO_priority )\
	def_opr("]"	, ']'          , NO_priority )\


#define num_expr_opr \
	def_opr("\"", LEX_opr      , NO_priority )\
	def_opr("#" , LEX_opr      , NO_priority )\
	def_opr("$" , LEX_opr      , NO_priority )\
	def_opr("&" , OPR_and      , BIp_and     )\
	def_opr("'" , LEX_opr      , NO_priority )\
	def_opr("(" , '('          , NO_priority )\
	def_opr(")" , ')'          , NO_priority )\
	def_opr("!" , LEX_opr      , NO_priority )\
	def_opr("*" , OPR_multi    , BIp_multi   )\
	def_opr("+" , OPR_plus     , BIp_plus    )\
	def_opr("," , LEX_opr      , NO_priority )\
	def_opr("-" , OPR_minus    , BIp_minus   )\
	def_opr("." , LEX_opr      , NO_priority )\
	def_opr("/" , OPR_divide   , BIp_divide  )\
	def_opr("/%", OPR_residue  , BIp_residue )\
	def_opr(":" , LEX_opr      , NO_priority )\
	def_opr(";" , LEX_opr      , NO_priority )\
	def_opr("<" , LEX_opr      , NO_priority )\
	def_opr("=" , LEX_opr      , NO_priority )\
	def_opr(">" , LEX_opr      , NO_priority )\
	def_opr("?" , LEX_opr      , NO_priority )\
	def_opr("@" , OPR_xor      , BIp_xor     )\
	def_opr("[" , LEX_opr      , NO_priority )\
	def_opr("\\", LEX_opr      , NO_priority )\
	def_opr("]" , LEX_opr      , NO_priority )\
	def_opr("^" , LEX_opr      , NO_priority )\
	def_opr("`" , LEX_opr      , NO_priority )\
	def_opr("{" , LEX_opr      , NO_priority )\
	def_opr("|" , OPR_or       , BIp_or      )\
	def_opr("}" , LEX_opr      , NO_priority )\
	def_opr("~" , OPR_invert   , BIp_invert  )\
	def_opr(":=", LEX_opr      , NO_priority )\
	def_opr("!=", LEX_opr      , NO_priority )\
	def_opr("==", LEX_opr      , NO_priority )\
	def_opr(">=", LEX_opr      , NO_priority )\
	def_opr("<=", LEX_opr      , NO_priority )\
	def_opr("&&", LEX_opr      , NO_priority )\
	def_opr("||", LEX_opr      , NO_priority )\
	def_opr("++", LEX_opr      , NO_priority )\
	def_opr("--", LEX_opr      , NO_priority )\
	def_opr(">>", OPR_sft_r    , BIp_sft_r   )\
	def_opr("<<", OPR_sft_l    , BIp_sft_l   )\
	def_opr("/|", LEX_opr      , NO_priority )\
	def_opr("/@", LEX_opr      , NO_priority )\
	def_opr("/^", LEX_opr      , NO_priority )\
	def_opr("/&", LEX_opr      , NO_priority )\


/* ===== for SFL spec v1 & v2 ===== */

#define all_sign \
/* L ::= */ \
	def_sign("\"", '"')\
	def_sign("#" , '#')\
	def_sign("$" , '$')\
	def_sign("%" , '%')\
	def_sign("&" , '&')\
	def_sign("'" , '\'')\
	def_sign("(" , '(')\
	def_sign(")" , ')')\
	def_sign("*" , '*')\
	def_sign("+" , '+')\
	def_sign("," , ',')\
	def_sign("-" , '-')\
	def_sign("." , '.')\
	def_sign("/" , '/')\
	def_sign(":" , ':')\
	def_sign(";" , ';')\
	def_sign("<" , '<')\
	def_sign("=" , '=')\
	def_sign(">" , '>')\
	def_sign("?" , '?')\
	def_sign("@" , '@')\
	def_sign("[" , '[')\
	def_sign("\\", '\\')\
	def_sign("]" , ']')\
	def_sign("^" , '^')\
	def_sign("`" , '`')\
	def_sign("{" , '{')\
	def_sign("|" , '|')\
	def_sign("}" , '}')\
	def_sign("~" , '~')\
	def_sign("?" , '?')\


enum {
	module_prefix  = 'm',
	circuit_prefix = 'c',
	nld_prefix     = 'n',
	pcd_prefix     = 'p',
	};


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


enum {
	INST_IDNO = -3,		/* CX^Xhcԍ */
	DENY_CNT  = -2, 	/* [q̕s݃JE^̔zʒu */
	WRITE_ENO = -1,		/* WX^E[q̏ݎsʒu */
	INACT_CNT = -1, 	/* [q̕sNJE^̔zʒu */
	};


/*---------------------------------------------------------------

tGA̒`

@WX^
	WRITE_ENO = -1,		WX^E[q̏ݎsʒu

@f[^[q
	INST_IDNO = -3,		CX^Xhcԍ
	DENY_CNT  = -2, 	[q̕s݃JE^̔zʒu
	WRITE_ENO = -1,		WX^E[q̏ݎsʒu

@[q
	INACT_CNT = -1, 	[q̕sNJE^̔zʒu

----------------------------------------------------------------*/


/* Xe[WEZOg̔zvf */
enum {
	STG_ACTIVE = 0,/* OFANeBuEtO@ʓ̋NtOɎgp   */
	STG_ARR_IX,    /* PF̔zԍ                                   */
	STG_TASKNO,    /* QFANeBu^XN̔zԍiOԂ͒~Ӗj   */
	STG_STTSEG,    /* RF݂̃Xe[g^ZOg̔zԍ             */
	STG_PARENT,    /* SFR[ZOg^Xe[W̔zԍ   */
	STG_RETSTT,    /* TFZOgR[̃^[Xe[g̔zԍ */

	STG_STTENO,    /* UFZOgEXe[g̕ύX@isʒuj*/
	STG_NXTSTT,    /* VFZOgEXe[g̕ύX@iJڐj  */
	STG_TSKENO,    /* WF^XN̋N@isʒuj  */
	STG_NXTTSK,    /* XF^XN̋N@iN^XNj*/

	STG_ARRLEN,    
	};


/* Xe[g̔zvf */
enum {
	STT_ACTIVE = 0,/* OFANeBuEtO@̋NtOɎgp */
	STT_ARR_IX,    /* PF̔zԍ */
	STT_PARENT,    /* QFZOg^Xe[W̔zԍ */ 
	STT_ARRLEN,    
	};


/* ^XN̔zvf */
enum {
	TSK_ACTIVE = 0,/* OFANeBuEtO@̋NtOɎgp */
	TSK_ARR_IX,    /* PF̔zԍ */
	TSK_PARENT,    /* QFXe[W̔zԍ */ 
	TSK_ARRLEN,    
	};


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#undef  ENTRY
#define ENTRY 


#endif PS_TDEF_H

