/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_token.c
 *
 * sfl token manipulate functions.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_lex.h"
#include "ps_strct.h"


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY expr* new_expr(alloc_ctl* acp,int opr,int fig,expr* op1,expr* op2,expr* beh) {
	expr* ep = new_alloc(acp,sizeof(*ep));
	ep->opr = opr;
	ep->fig = fig;
	ep->op1 = op1;
	ep->op2 = op2;
	ep->beh = beh;
	return ep;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY component* new_component(alloc_ctl* acp) {
	component* cp = new_alloc(acp,sizeof(*cp));
	cp->endp = &(cp->top);
	return cp;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY token* new_token(alloc_ctl* acp, int typ, token* tp) {
	static symbol sym = {"sflnode",0};
	token* np = new_alloc(acp,sizeof(*np));
	if (tp == 0) {
		np->tokren = np->toksym = &sym;
		np->figure = 1;
		}
	else {
		memcpy(np,tp,sizeof(*np));
		tp->twin = np;
		np->twin = tp;
		}
	np->id = typ;
	np->prototype = 0;
	np->translate = 0;
	np->reference = 0;
	np->ipp = 0;
	np->acp = acp;
	return np;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


#include "ps_tdef.h"
#include "ps_proto.h"


#if defined(EXTRA)
#	define Ex_sflrd
#	include "extra.h"
#	endif


/* ========================================================================= */
/* =====   error message                                             ===== */
/* ========================================================================= */


ENTRY char* token_name(token* tp) {
	char* buf;
	token* ptp;
	if (tp == 0) return "null token";
	else if (tp->tokren == 0) return opr_name(tp->id);
	else if (tp->tokren->name == 0) return "no name token";
	ptp = tp->parent;
	if (ptp != 0) {
		switch(ptp->id) {
		case DEF_submod:
		case DEF_stage_name:
			buf = get_looped_buf(0);
			sprintf(buf,"%s.%s",token_name(ptp),tp->tokren->name);
			return buf;
			}
		}
	return tp->tokren->name;
	}


ENTRY char* token_file(token* tp) {
	return symcate_name(tp->loc.file);
	}


ENTRY int token_line(token* tp) {
	return tp->loc.line;
	}


ENTRY void dsp_token_name(token* tp) {
	printf("TOKEN: file=%s, line=%u, code=%u, name=%s\n",
		token_file(tp),token_line(tp),token_id(tp),token_name(tp));
	}


ENTRY char* token_location(token* tp) {
	char* buf = get_looped_buf(0);
	sprintf(buf,"'%s' (%s -%d)",token_name(tp),token_file(tp),token_line(tp));
	return buf;
	}


static void put_tok_clm(FILE* cfp, lex* lexp, token* tp) {
	if (cfp == NULL) return;
	error_type(cfp,ERR_user);
	fprintf(cfp,"%s : %s.\n",token_location(tp),lexp->errbuf);
	}


ENTRY void tok_claim(lex* lexp,token* tp) {
	put_tok_clm(lexp->claimfp    ,lexp,tp);
	put_tok_clm(open_error_file(),lexp,tp);
	lexp_errclr(lexp);
	}


static void put_tok_err(FILE* cfp, lex* lexp, token* tp) {
	if (cfp == NULL) return;
	put_tok_clm(cfp,lexp,tp);
	put_source_back(cfp,&(tp->loc));
	}


static int vvv = 1;
static int ddd = 0;


ENTRY void tok_error(lex* lexp,token* tp) {
	put_tok_err(lexp->claimfp    ,lexp,tp);
	put_tok_err(open_error_file(),lexp,tp);
	longjmp(**(lexp->jmpbfpp),ERR_user);
	}


/* ========================================================================= */
/* =====    Hash Table                                                 ===== */
/* ========================================================================= */


ENTRY component* component_table(token* gtp) {
	if (gtp->comp_tbl == 0) {
		gtp->comp_tbl = new_component(gtp->acp);
		}
	return gtp->comp_tbl;
	}


static unsigned int token_hcode(void* q) {
	return ((token*)q)->toksym->code;
	}


ENTRY token* token_lookup(token* gtp, token* tp, int* newfp) {
	unsigned int i,ix;
	unsigned int dx = 0;
	alloc_ctl* acp = gtp->acp;
	component* cp;
	hashtbl* hp;
	int empty = 0;
	footmark("token_lookup");
	if (gtp == 0 || tp == 0) {
		*newfp = 0;
		return 0;
		}
	cp = component_table(gtp);
	if (cp->comphash == 0) {
		cp->comphash = new_hashtbl(acp);
		}
	hp = cp->comphash;
	SYMBOL_PA(++(hp->lup_cnt));
retry:
	ix = tp->toksym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {
		token* p;
		SYMBOL_PA(++(hp->try_cnt));
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0) {
			/* o^ĂȂ */
			uni_link* up;
			token* ntp;
			if (token_id(tp) == LEX_SYM) {
				/* ΏۂIDV{̂܂܂Ȃo^Ȃ */
				*newfp = 0;
				return 0;
				}
			/* Vo^ */
			hp->tblent++;
			if (*newfp != 0) {
				/* Rs[ēo^ */
				ntp = new_token(acp,token_id(tp),tp);
				}
			else ntp = tp;
			ntp->parent = gtp;
			if (empty != 0) ix = dx;
			hp->tblpp[ix] = ntp;
			up = new_uni_link(acp,ntp,0);
			*(cp->endp) = up;
			cp->endp = &(up->np);
			cp->count++;
			*newfp = 1;			/* new flag */
			return ntp;
			}
		/* o^Ăꍇ */
		if (p == hash_del_mp) {	/* deleted token */
			/*
			ĂGg
			F
			nbVR[hijCfbNXƂāAe[u
			AʒũGgƃV{vȂꍇ͎̃Gg
			Ƃ̔rsĂB̂߁AGgONA邱Ƃ
			łȂBhash_del_mpŏʒu}[NĂB
			*/
			if (empty == 0) {
				/* o^łꏊ邱Ƃ󂵂Ă */
				empty = 1;
				dx = ix;
				}
			}
		else if (p->toksym == tp->toksym) {
			/* V{vĂ̂o */
			*newfp = 0;
			return p;
			}
		if (i > 10 && hp->tblent > hp->tblsiz/2) {
			/* 󂫃Gg1/2ȉɂȂAe[ug */
			break;
			}
		}
	expand_hash_tbl(hp,10,token_hcode);
	goto retry;
	}


ENTRY void token_rename(lex* lexp, token* tp, char* name) {
	token* gtp;
	token* rtp;
	token  tok;
	token* ntp = &tok;
	unsigned int i,ix;
	component* cp;
	hashtbl* hp;
	int newflg;
	alloc_ctl* acp = tp->acp;
	footmark("token_rename");
	if (tp == 0) return;
	gtp = tp->parent;
	if (gtp == 0 || gtp->comp_tbl == 0) return;
	cp = gtp->comp_tbl;
	if (cp->comphash == 0) cp->comphash = new_hashtbl(acp);
	hp = cp->comphash;
	ntp->tokren = ntp->toksym = symbol_lookup(lexp, name);
	ntp->id = LEX_SYM;
	if (ntp->toksym == tp->toksym) return;
	/* VK̖̂gĂȂƂmF */
	newflg = 0;
	if (token_lookup(gtp, ntp, &newflg) != 0) {
		sprintf(lexp->errbuf,"'%s' is already used",name);
		cmd_error(lexp, ERR_user);
		}
	/* ݂̖Oœo^Ătoken菜 */
	ix = tp->toksym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {
		ix %= hp->tblsiz;
		rtp = hp->tblpp[ix];
		if (rtp == 0) break;
		if (rtp == hash_del_mp) ;	/* deleted token */
		else if (rtp->toksym == tp->toksym) {
			hp->tblpp[ix] = hash_del_mp;
			goto replace;
			}
		}
	sprintf(lexp->errbuf,"'%s' no such member",tp->tokren->name);
	cmd_error(lexp, ERR_user);
replace:
	/* VK̖Oœo^ */
	rtp->toksym = ntp->toksym;
	rtp->tokren = ntp->tokren;
	ix = rtp->toksym->code;
	for (i = 0 ; i < hp->tblsiz ; ++i,++ix) {
		token* p;
		ix %= hp->tblsiz;
		p = hp->tblpp[ix];
		if (p == 0 || p == hash_del_mp) {
			hp->tblpp[ix] = rtp;
			break;
			}
		}
	}


/* ========================================================================= */
/* =====   g[N̓ǂݍ                                          ===== */
/* ========================================================================= */


ENTRY int next_tokcode(lex* lexp) {
	int tc;
	tc = sfl_word(lexp);
	unget_word(lexp,tc,lexp->toksym->name, &(lexp->tokloc));
	if (lexp->lead_delim) unget_word(lexp,LEX_SPC," ",&(lexp->tokloc));
	return tc;
	}


ENTRY void sfl_assert(lex* lexp,int typ) {
	int tc;
	footmark("sfl_assert");
	tc = sfl_word(lexp);
	if (tc != typ) {
		if (tc == LEX_SYM && typ == '}') {
			sprintf(lexp_errbuf(lexp),"undeclared symbol");
			}
		else {
			sprintf(lexp_errbuf(lexp),"sfl_assert(): '%s' expected",type_name(typ));
			}
		lex_error(lexp,ERR_user);
		}
	}


ENTRY void unget_token(lex* lexp, token* tp) {
	footmark("unget_token");
	unget_word(lexp,tp->id,tp->toksym->name, &(tp->loc));
	if (is_lead_delim(tp)) unget_word(lexp,LEX_SPC," ",&(tp->loc));
	}


ENTRY unsigned long str2num(lex* lexp, char *bp) {
	int radix = 10;
	unsigned int c;
	unsigned int  d;
	unsigned long data = 0;
	footmark("str2num");
	c = (unsigned int)*bp;
	if (c >= '0' && c <= '9') {
		while((c = (unsigned int)*bp++) != 0) {
			if (c == '_') continue;
			if (c >= 'A' && c <= 'Z') c += 'a' - 'A';
			if      (c >= '0' && c <= '9') d = c - '0';
			else if (c >= 'a' && c <= 'f') d = c - 'a' + 10;
			else d = 17;
			if (d > (uint)radix) {
				switch(c) {
				case 'b': radix =  2; continue;
				case 'd': radix = 10; continue;
				case 'o': radix =  8; continue;
				case 'x': radix = 16; continue;
				default : 
					sprintf(lexp->errbuf,"illegal number");
					lex_error(lexp, ERR_user);
					}
				}
			data = data * radix + d;
			}
		}
	return data;
	}


ENTRY token* get_token(tMYc token* gtp, token* lxp) {
	lex*   lexp = my->sfllexp;
	token* ltp;
	int    set_flg;
	footmark("get_token");
	memset(lxp,0,sizeof(*lxp));
	lxp->id = sfl_word(lexp);
	lxp->toksym = lxp->tokren = lexp->toksym;
	lxp->loc    = lexp->tokloc;
	lxp->figure = 1;
	if (lexp->lead_delim) with_lead_delim(lxp)  ;
	switch(lxp->id) {
	case LEX_NUM:
		lxp->value = str2num(lexp,lexp->tokbuf);
		break;
	case LEX_SFLN:
		ltp = str2sflntok(MYc lexp->tokbuf);
		if (ltp != 0) {
			lxp->value  = ltp->value ;
			lxp->figure = ltp->figure;
			lxp->wpp    = ltp->wpp;
			lxp = ltp;
			lxp->loc = lexp->tokloc;
			if (my->max_figure < ltp->figure) my->max_figure = ltp->figure;
			}
		break;
	case LEX_SYM:
		if (gtp == 0) break;
		set_flg = 1;
		ltp = token_lookup(gtp, lxp, &set_flg);
		if (ltp != 0) lxp = ltp;
		break;
		}
	return lxp;
	}


/* ========================================================================= */
/* =====    f[^\̓ꐫmF                                     ===== */
/* ========================================================================= */


static int is_tpl_tok(token* tp) {
	switch(token_id(tp)) {
	case TPL_module:
	case TPL_circuit:
	case TPL_declare:
		return 1;
		}
	return 0;
	}


static answer pair_token_assert(tMYc token* dtp, token* stp) {
	lex* lexp = my->sfllexp;
	uni_link*  lp;
	token tok;
	token* tp;
	token* np;
	int set_flg;
	component* cp;
	cp = dtp->comp_tbl;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		tok = *tp;
		tok.id = LEX_SYM;
		set_flg = 1;
		np = token_lookup(stp, &tok, &set_flg);
		if (np == 0) {
			sprintf(lexp_errbuf(lexp),"    member missing %s of %s",
				token_location(tp),token_location(dtp));
			tok_claim(lexp,stp);
			return FAIL;
			}
		else {
			/* same name token found ! */
			if (same_token_assert(MYc tp,np) == FAIL) return FAIL;
			}
		}
	return GOOD;
	}


static answer same_token_member(tMYc token* dtp,token* stp) {
	lex* lexp = my->sfllexp;
	component* dcp;
	component* scp;
	dcp = dtp->comp_tbl;
	scp = stp->comp_tbl;
	if (scp == 0) {
		if (dcp == 0) return GOOD;	/* OK! */
		sprintf(lexp_errbuf(lexp),"    structure mismatch with %s",
				token_location(dtp));
		tok_claim(lexp,stp);
		return FAIL;
		}
	if (dcp == 0) {
		sprintf(lexp_errbuf(lexp),"    structure mismatch with %s",
				token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}
	/* scp != 0 && dcp != 0 */
	if (pair_token_assert(MYc dtp,stp) == FAIL) return FAIL;
	if (dcp->count != scp->count) {
		sprintf(lexp_errbuf(lexp),"    member-count of %s = %d (!=%d)",
			token_location(dtp), dcp->count, scp->count);
		pair_token_assert(MYc dtp,stp);	/* G[̓ */
		return FAIL;
		}
	/* same check for expression */
	lexp_errclr(lexp);
	if (same_exp_assert(my->sfllexp,dcp->behavior,scp->behavior) == FAIL) {
		sprintf(lexp_errbuf(lexp),"    behavior mismatch : %s, %s",
			token_location(stp),
			token_location(dtp) 
			);
		return FAIL;
		}
	lexp_errclr(lexp);
	return GOOD;
	}


static answer compare_record(bag_arr* dp, bag_arr* sp, token** dtpp, token** stpp) {
	token** dapp = (token**)(dp->ap);
	token** sapp = (token**)(sp->ap);
	int di,si;
	for (di = si = 0 ; di < dp->ix && si < sp->ix ; ++si, ++di) {
		*dtpp = dapp[di];
		*stpp = sapp[si];
		if (dapp[di]->toksym != sapp[si]->toksym) break;
		}
	if (di != dp->ix || si != sp->ix) return FAIL;
	return GOOD;	/* match */
	}



ENTRY answer same_arg_assert(tMYc token* dtp, token* stp) {
	lex* lexp = my->sfllexp;
	uni_link* dlp;
	uni_link* slp;
	token* edtp;
	token* estp;
	if (dtp == stp) return GOOD;
	if (dtp == 0 || stp == 0) return FAIL;
	dlp = dtp->arg;
	slp = dtp->arg;
	for ( ; dlp != 0 && slp != 0 ; dlp = dlp->np, slp = slp->np) {
		edtp = dlp->ap;
		estp = slp->ap;
		if (edtp->toksym != estp->toksym) {
			sprintf(lexp_errbuf(lexp),"    argument mismatch with %s",token_location(estp));
			tok_claim(lexp,edtp);
			return FAIL;
			}
		}
	if (dlp != slp) {
		sprintf(lexp_errbuf(lexp),"    argument count mismatch with %s",token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}
	return GOOD;
	}


ENTRY answer same_token_assert(tMYc token* dtp,token* stp) {
	lex* lexp = my->sfllexp;
	token* edtp = dtp;	/* G[ꏊ\̂߂̏l */
	token* estp = stp;	/* G[ꏊ\̂߂̏l */
	uni_link* dlp;
	uni_link* slp;
	component* dcp;
	component* scp;
	mod_def_env* dep;
	mod_def_env* sep;
	/* same check for arg link list */
	if (dtp == 0) {
		if (stp == 0) return GOOD;
		sprintf(lexp_errbuf(lexp),"    same member missing");
		tok_claim(lexp,stp);
		return FAIL;
		}
	if (stp == 0) {
		sprintf(lexp_errbuf(lexp),"    same member missing");
		tok_claim(lexp,dtp);
		return FAIL;
		}
	/* same check for token atribute */
	if (dtp->id != stp->id) {
		sprintf(lexp_errbuf(lexp),"    type mismatch with %s", token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}
	if (dtp->toksym	!= stp->toksym) {
		sprintf(lexp_errbuf(lexp),"    name mismatch with %s", token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}
	if (dtp->value != stp->value) {
		sprintf(lexp_errbuf(lexp),"    value mismatch with %s", token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}
	if (dtp->figure	!= stp->figure) {
		sprintf(lexp_errbuf(lexp),"    data width mismatch with %s", token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}

	switch(token_id(dtp)) {
	case DEF_mem:
		/* AhXTCYSFLN */
		if (get_mem_adr_tokp(dtp) != get_mem_adr_tokp(stp)) {
			sprintf(lexp_errbuf(lexp),"    memory address size mismatch with %s", token_location(stp));
			tok_claim(lexp,dtp);
			return FAIL;
			}
		/* AhX̃rbg */
		if (get_mem_adr_bits(dtp) != get_mem_adr_bits(stp)) {
			sprintf(lexp_errbuf(lexp),"    memory address width mismatch with %s", token_location(stp));
			tok_claim(lexp,dtp);
			return FAIL;
			}
		break;
	case TPL_module:
	case TPL_circuit:
	case TPL_declare:
		dep = get_token_env(dtp);
		sep = get_token_env(stp);
		dlp = dtp->arg;
		slp = stp->arg;
		for ( ; dlp != 0 && slp != 0 ; dlp = dlp->np, slp = slp->np) {
			if (dlp->ap != slp->ap) {
				sprintf(lexp_errbuf(lexp),"    argument mismatch with %s",token_location(stp));
				tok_claim(lexp,dtp);
				return FAIL;
				}
			}
		if (dlp != slp) {
			sprintf(lexp_errbuf(lexp),"    argument count mismatch with %s",token_location(stp));
			tok_claim(lexp,dtp);
			return FAIL;
			}
		if (compare_record(dep->bagp, sep->bagp, &edtp, &estp) == FAIL) {
			sprintf(lexp_errbuf(lexp),"    source mismatch with %s",token_location(estp));
			tok_claim(lexp,edtp);
			return FAIL;
			}
		break;
	default:
		if (same_arg_assert(MYc dtp,stp) == FAIL) return FAIL;
		}
	dcp = dtp->comp_tbl;
	scp = stp->comp_tbl;
	if ((dcp == 0 && scp != 0) ||
		(dcp != 0 && scp == 0) ) {
		sprintf(lexp_errbuf(lexp),"    component mismatch with %s",token_location(stp));
		tok_claim(lexp,dtp);
		return FAIL;
		}
	if (dcp != 0 && scp != 0 && !is_tpl_tok(dtp)) {
		edtp = dcp->first;
		estp = scp->first;
		if (edtp != 0) {
			if (estp != 0) {	/* edtp != 0 && estp != 0 */
				if (edtp->toksym != estp->toksym) {
					sprintf(lexp_errbuf(lexp),"    first state mismatch with %s",token_location(estp));
					tok_claim(lexp,edtp);
					return FAIL;
					}
				}
			else {				/* edtp != 0 && estp == 0 */
				sprintf(lexp_errbuf(lexp),"    first state mismatch");
				tok_claim(lexp,edtp);
				return FAIL;
				}
			}
		else {
			if (estp != 0) {	/* edtp == 0 && estp != 0 */
				sprintf(lexp_errbuf(lexp),"    first state mismatch");
				tok_claim(lexp,estp);
				return FAIL;
				}
			}
		}
	/* same check for each group token */
	if (same_token_member(MYc dtp,stp) == FAIL) return FAIL;
	return GOOD;	/* same */
	}


/* ========================================================================= */
/* =====    TuEW[ECX^X̕                       ===== */
/* ========================================================================= */


static void clear_twin_link(token* stp) {
	component* cp;
	uni_link*  lp;
	stp->twin = 0;
	cp = stp->comp_tbl;
	if (cp == 0) return;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		clear_twin_link(lp->ap);
		}
	}


static void member_duplicate(token* dtp, token* stp) {
	token* tp;
	token* np;
	component* cp;
	uni_link* lp;
	int set_flg;
	stp->twin      = dtp;
	dtp->twin      = stp;
	dtp->value     = stp->value;
	dtp->figure    = stp->figure;
	dtp->prototype = stp;
	dtp->translate = 0;
	dtp->reference = 0;
	dtp->ipp       = 0;
	dtp->comp_tbl  = 0;
	dtp->wpp       = stp->wpp;
	dtp->arg       = 0;
	cp = stp->comp_tbl;
	if (cp == 0) return;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		set_flg = 1;
		np = token_lookup(dtp, tp, &set_flg);
		if (set_flg == 0) {
			sys_error("member_duplicate set_flg==0");
			}
		member_duplicate(np, tp);
		}
	}


static void token_arg_duplicate(token* dtp) {
	token* tp;
	token* stp;
	component* cp;
	uni_link*  lp;
	uni_link** lpp;
	alloc_ctl* acp;
	stp = dtp->prototype;
	if (stp == 0) {
		sys_error("token_arg_duplicate stp == 0");
		}
	acp = dtp->acp;
	lpp = &(dtp->arg);
	for (lp = stp->arg ; lp != 0 ; lp = lp->np) {
		tp = ((token*)(lp->ap))->twin;
		if (tp == 0) {
			sys_error("token_arg_duplicate twin == 0");
			}
		*lpp = new_uni_link(acp,tp,0);
		lpp = &((*lpp)->np);
		}
	cp = dtp->comp_tbl;
	if (cp == 0) return;
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		token_arg_duplicate(lp->ap);
		}
	}


ENTRY void sub_token_duplicate(token* dtp, token* stp) {
	if (dtp == 0 || stp == 0) return;
	clear_twin_link(stp);
	member_duplicate(dtp, stp);
	token_arg_duplicate(dtp);
	}


/* ========================================================================= */
/* =====    f[^\̒ǉE폜                                     ===== */
/* ========================================================================= */


static token* get_new_member(tMYc token* parp, token* lxp, int typ) {
	lex* lexp = my->sfllexp;
	token* tp;
	int tc;
	int ntc;
	footmark("get_new_member");
	if (parp == 0) {
		sprintf(lexp_errbuf(lexp),"get_new_member(): parp == 0");
		lex_error(lexp,ERR_system);
		}
	tp = get_token(MYc parp,lxp);
	tc = token_id(tp);
	if (tc == LEX_SYM) ;
	else if (tc >= DEF_top && tc <= DEF_end) {
		if (tc == typ) {
			ntc = next_tokcode(lexp);
			if (ntc == '(' || ntc == '{') goto ret;
			}
		sprintf(lexp_errbuf(lexp),"conflict.1 with %s",token_location(tp));
		tok_error(lexp,lxp);
		}
	else {
		sprintf(lexp_errbuf(lexp),"'symbol' expected");
		tok_error(lexp,lxp);
		}
ret:
	return tp;
	}


ENTRY token* define_new_member(tMYc token* parp, int typ) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	token* ntp;
	int set_flg;
	footmark("define_new_member");
	tp = get_new_member(MYc parp, lxp, typ);
	if (token_id(tp) == typ) {
		ntp = tp;
		goto ret;
		}
	token_id(tp) = typ;
	set_flg = 1;
	ntp = token_lookup(parp, tp, &set_flg);
	if (set_flg == 0) {
		sprintf(lexp_errbuf(lexp),"'%s' registration fail",type_name(typ));
		tok_error(lexp,lxp);
		}
ret:
	del_entity(my->tokecp,lxp);
	return ntp;
	}


ENTRY void check_dup_member(tMYc int set_flg,token* now_tp,token* set_tp) {
	lex* lexp = my->sfllexp;
	footmark("check_dup_member");
	if (set_flg) return;
	if (same_token_assert(MYc set_tp,now_tp) == FAIL) {
		sprintf(lexp_errbuf(lexp),"    %s mismatch : re-definition of '%s'",
				tok_id_name(now_tp),token_name(now_tp));
		tok_error(lexp,set_tp);
		}
	/* 
	set_tp`邽߂ɎgpꊇԊ҂ijB
	del_mactl(set_tp->acp);
	񂪁Atemplate̓ŁA
	Pmoduleǂݍ݂ŁAۂɒ`modulePƂ͌ȂȂB
	ŁAsfllexp->sflacpƂĈꊇԊ҂邽߁AXɕԊ҂ȂƂɂB
	*/
	}


/* ========================================================================= */
/* =====    t@VeB̕t^𖞂悤ɃV{C   ===== */
/* ========================================================================= */


enum {
	APLHABET_ONLY = 1,
	NUMBER_ONLY,
	APLHA_NUM_ONLY,
	};

enum {
	CAPITAL_LET_ONLY = 1,
	SMALL_LET_ONLY,
	};


/* OƂĂ̐ */


int symbol_max_len  = 0;
int symbol_charset  = 0;
int symbol_charcaps = 0;


ENTRY char* name_restrict(char* o_name, int try_cnt) {
	char* r_name = get_looped_buf(0);
	int len = strlen(o_name);
	int modify = 0;
	int sym_cnt;
	int ext_cnt;
	int i,j,c,d;
	sprintf(r_name,"%s",o_name);
	/* ̒̐ */
	if (symbol_max_len != 0 && len > symbol_max_len) {
		modify = 1;
		switch(symbol_charset) {
		case NUMBER_ONLY:
			sym_cnt = symbol_max_len - 4;
			if (sym_cnt < 0) {
				sym_cnt = 0;
				symbol_max_len = 4;
				}
			ext_cnt = symbol_max_len - sym_cnt;
			for (i = 0 ; i < ext_cnt ; ++i) {
				d = try_cnt % 10;
				try_cnt /= 10;
				r_name[symbol_max_len-1-i] = (char)('0' + d);
				}
			break;
		default:
			sym_cnt = symbol_max_len - 3;
			if (sym_cnt < 0) {
				sym_cnt = 0;
				symbol_max_len = 3;
				}
			ext_cnt = symbol_max_len - sym_cnt;
			for (i = 0 ; i < ext_cnt ; ++i) {
				d = try_cnt % 26;
				try_cnt /= 26;
				r_name[symbol_max_len-1-i] = (char)('a' + d);
				}
			break;
			}
		r_name[symbol_max_len] = 0;
		len = symbol_max_len;
		}
	switch(symbol_charset) {
	case APLHABET_ONLY:
		for (j = i = 0; i < len ; ++i) {
			c = r_name[i];
			if ((c >= 'A' && c <= 'Z') ||
				(c >= 'a' && c <= 'z')) continue;
			r_name[i] = (char)('a' + j);
			j = (j + 1) % 26;
			modify = 1;
			}
		break;
	case NUMBER_ONLY:
	case APLHA_NUM_ONLY:
		for (j = i = 0; i < len ; ++i) {
			c = r_name[i];
			if ((c >= 'A' && c <= 'Z') ||
				(c >= 'a' && c <= 'z') ||
				(c >= '0' && c <= '9') ) continue;
			r_name[i] = (char)('0' + j);
			j = (j + 1) % 10;
			modify = 1;
			}
		break;
		}
	switch(symbol_charcaps) {
	case CAPITAL_LET_ONLY:
		for (i = 0; i < len ; ++i) {
			c = r_name[i];
			if (c >= 'a' && c <= 'z') {
				c += 'A' - 'a';
				r_name[i] = (char)c;
				modify = 1;
				}
			}
		break;
	case SMALL_LET_ONLY:
		for (i = 0; i < len ; ++i) {
			c = r_name[i];
			if (c >= 'A' && c <= 'Z') {
				c += 'a' - 'A';
				r_name[i] = (char)c;
				modify = 1;
				}
			}
		break;
		}
	if (modify) o_name = r_name;
	return o_name;
	}


static symbol* valid_name_symbol(tMYc symbol* sym, int try_cnt) {
	char* r_name = name_restrict(sym->name,try_cnt);
	if (r_name != sym->name) sym = symbol_lookup(my->cmdlexp,r_name);
	return sym;
	}


/* ========================================================================= */
/* =====    \ƃobeBOĂt@VeBC       ===== */
/* ========================================================================= */


typedef struct {
	token* tp;
	int    len;
	char*  name;
	} name_atrib;


static int toksym_comp(q_CONST void* m1, q_CONST void* m2) {
	name_atrib* n1 = *(name_atrib**)m1;
	name_atrib* n2 = *(name_atrib**)m2;
	if (n1->len > n2->len) return  1;
	if (n1->len < n2->len) return -1;
	return str_comp(n1->name,n2->name);
	}


static int is_extpin(token* tp) {
	switch(token_id(tp)) {
	case DEF_input:
	case DEF_output:
	case DEF_bidirect:
	case DEF_instrin:
	case DEF_instrout:
		/* O[qH */
		return 1;
		}
	return 0;
	}


/* R|[lgŎgp閼̂\ɈvȂ悤ɏC */


static void change_reverved_name(tMYc token* gtp) {
	char*      name = get_looped_buf(512);
	lex*       lexp = my->cmdlexp;
	hashtbl*   hp = my->rsv_hp;
	symbol*    sym;
	sym_val*   val;
	token*     tp;
	token*     ktp;
	component* cp;
	uni_link*  lp;
	name_atrib** all_list;
	name_atrib** in_list;
	name_atrib*  list_data;
	int        i,j,k;
	int        all_cnt,ext_cnt,chk_cnt;
	if (gtp == 0) return;
	cp = gtp->comp_tbl;
	if (cp == 0) return;
	for (all_cnt = 0,lp = cp->top ; lp != 0 ; lp = lp->np) ++all_cnt;
	if (all_cnt == 0) return;
	all_list  = new_mem(all_cnt * sizeof(name_atrib*));
	in_list   = new_mem(all_cnt * sizeof(name_atrib*));
	list_data = new_mem(all_cnt * sizeof(name_atrib));
	/* ʃR|[lg̈ꗗXg */
	for (i = 0, lp = cp->top ; lp != 0 ; ++i, lp = lp->np) {
		name_atrib* nap = &list_data[i];
		all_list[i] = nap;
		nap->tp = (token*)(lp->ap);
		nap->name = nap->tp->toksym->name;
		nap->len = strlen(nap->name);
		}
	/*----------------------------------------------------
	ꗗXg𖼑OŃ\[g
	̕ύX̍ۂɈӐmۂ邽߁j
	----------------------------------------------------*/
	qsort((void*)all_list, all_cnt, sizeof(name_atrib*), toksym_comp);
	/*----------------------------------------------------
	ꗗXgɊOsΐ擪Ɉړ
	iOsD悵Ė̂̕ύXs߁j
	----------------------------------------------------*/
	for (i = j = k = 0 ; i < all_cnt ; ++i) {
		name_atrib* nap = all_list[i];
		tp = nap->tp;
		if (is_extpin(tp)) all_list[j++] = nap;
		else in_list[k++] = nap;	/* ̖̂ꎞۊǂ */
		}
	ext_cnt = j;
	/* Ô̌ɓ̖̂q */
	for (i = 0 ; i < k ; ++i) {
		all_list[j+i] = in_list[i];
		}
	/* obeBOOLΕύX */
	chk_cnt = ext_cnt;
	for (i = 0 ; i < all_cnt ; ++i) {
		/* Os̏ꍇ́AOs͈̔͂ŁAobeBOs */
		if (i >= ext_cnt) chk_cnt = all_cnt;
		tp = all_list[i]->tp;
		sym = tp->toksym;
		for (j = 0;;) {
			/* OƂĂ̐ */
			sym = valid_name_symbol(MYc sym,j);
			/* \ꂩǂf */
			val = sym2val_lookup(hp,sym,0,0);
			if (val != 0) {
				/* \ƃobeBOĂ */
				goto re_name;
				}
			/* ̃R|[lgƃobeBOĂ邩ǂf */
			for (k = 0 ; k < chk_cnt ; ++k) {
				if (k == i) continue;	/* gȂ̂skip */
				ktp = all_list[k]->tp;
				if (ktp->tokren == sym) goto re_name;
				}
			break;
		re_name:
			++j;
			/* \܂͑̃R|[lgƃobeBOĂ̂ŁA */
			sprintf(name,"%s_%d",tp->toksym->name,j);
			sym = symbol_lookup(lexp, name);
			}
		tp->tokren = sym;
		}
	del_mem(all_list);
	del_mem(in_list);
	del_mem(list_data);
	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		change_reverved_name(MYc lp->ap);
		}
	}


ENTRY void mod_name_change(tMYc token* mtp) {
	char*    name = get_looped_buf(512);
	hashtbl* hp = my->rsv_hp;
	symbol*  sym;
	/* \ꂩǂf */
	if (sym2val_lookup(hp,mtp->toksym,0,0) != 0) {
		/* \ƃobeBOĂ */
		sprintf(name,"m_%s",mtp->toksym->name);
		sym = symbol_lookup(my->cmdlexp,name);
		mtp->tokren = sym;
		}
	}


ENTRY void with_toksym_alias(tMYc token* mtp) {
	mod_name_change(MYc mtp);
	change_reverved_name(MYc mtp);
	}


/* ========================================================================= */
/* =====   ev[g`                                          ===== */
/* ========================================================================= */
;


static char *tpl_delm = "_";


static bag_arr* record_block(char left, char right, lex* lexp) {
	int save_meta_off  = lexp->meta_off ;
	int save_eof_ng    = lexp->eof_ng   ;
	int save_in_drct   = lexp->in_drct  ;
	int save_macro_ctl = lexp->macro_ctl;
	int save_save_dol  = lexp->save_dol ;
	int save_skip_spc  = lexp->skip_spc ;
	int save_skip_nl   = lexp->skip_nl  ;
	int save_in_record = lexp->in_record;

	bag_arr* bagp = new_bag(lexp->acp);
	int block_cnt = 0;
	token* lxp;

	lexp->meta_off   = 1;
	lexp->eof_ng     = 0;
	lexp->in_drct    = 0;
	lexp->macro_ctl  = MAC_SYM;
	lexp->save_dol   = 1;
	lexp->skip_spc   = 0;
	lexp->skip_nl    = 0;
	lexp->in_record  = 1;

	for(;;) {
		lxp = new_alloc(lexp->acp,sizeof(*lxp));
		lxp->id = sfl_word(lexp);
		lxp->tokren = lxp->toksym = lexp->toksym;
		lxp->loc = lexp->tokloc;
		if (lexp->lead_delim) with_lead_delim(lxp);
		append_bag_que(bagp,lxp);
		if (lxp->id == left) ++block_cnt;
		else if (lxp->id == right) {
			if (--block_cnt == 0) break;
			}
		}

	lexp->meta_off  = save_meta_off ;
	lexp->eof_ng    = save_eof_ng   ;
	lexp->in_drct   = save_in_drct  ;
	lexp->macro_ctl = save_macro_ctl;
	lexp->save_dol  = save_save_dol ;
	lexp->skip_spc  = save_skip_spc ;
	lexp->skip_nl   = save_skip_nl  ;
	lexp->in_record = save_in_record;

	return bagp;
	}




static int template_source(lex* lexp) {
	source* sfp = lexp->sfp;
	mod_def_env* envp = (mod_def_env*)(sfp->envp);	/* }N̒`e */
	bag_arr* bagp = envp->bagp;
	token* tp;
	int c;
	int i;
top:
	if (sfp->string != 0) {
		c = sfp->string[0];
		if (c != 0) {
			sfp->string++;
			return c;
			}
		}
	i = (sfp->mbufix)++;
	if (i >= bagp->ix) return EOF;	/* I */
	tp = ((token**)(bagp->ap))[i];
	lexp->lexloc = sfp->loc = tp->loc;
	sfp->string = token_name(tp);
	if (is_lead_delim(tp)) return ' ';
	goto top;
	}


static void dsp_indent(FILE* spkfp,int ind_lvl) {
	while (ind_lvl--> 0) fprintf(spkfp,"    ");
	}


ENTRY void dsp_template(tMYc char* fn) {
	lex* lexp = my->cmdlexp;
	token* tp;
	component* cp;
	uni_link* lp;
	uni_link* arg;
	FILE* spkfp;
	mod_def_env* envp;
	token**   dapp;
	bag_arr*  bagp;
	char* name;
	int i;
	if (my->class_tp == 0) return;
	cp = my->class_tp->comp_tbl;
	if (cp == 0) return;
	if (fn != NULL && *fn != 0) {
		spkfp = fopen(fn,"wt");
		if (spkfp == NULL) {
			sprintf(lexp->errbuf,"Can't open (%s)",fn);
			lex_error(lexp,ERR_user);
			}
		}
	else {
		spkfp = lexp->speakfp;
		}
	cmd_lexp = lexp;



	for (lp = cp->top ; lp != 0 ; lp = lp->np) {
		tp = lp->ap;
		switch(token_id(tp)) {
		case TPL_module:
		case TPL_circuit:
		case TPL_declare:
			if (fn == NULL) break;
			if (strcmp(fn,tp->toksym->name) != 0) continue;
			break;
		default:
			continue;
			}
		envp = get_token_env(tp);
		bagp = envp->bagp;
		dapp = (token**)(envp->bagp->ap);
		switch(token_id(tp)) {
		case TPL_module : name = "module" ; break;
		case TPL_circuit: name = "circuit"; break;
		case TPL_declare: name = "declare"; break;
			}
		fprintf(spkfp,"%s %s <",name,token_name(tp));
		name = "";
		for (arg = tp->arg ; arg != 0 ; arg = arg->np) {
			fprintf(spkfp,"%s%s",name,((symbol*)(arg->ap))->name);
			name = ",";
			}
		fprintf(spkfp,"> ");
		for (i = 0 ; i < bagp->ix ; ++i) {
			token* tp = dapp[i];
			fprintf(spkfp,"%s", token_name(tp));
			}
		}
	fprintf(spkfp,"\n");
	if (spkfp != lexp->speakfp) fclose(spkfp);
	}


/* W[`̍ۂ̊ۑ */

ENTRY mod_def_env* save_my_env_at_define(tMYc alloc_ctl* acp) {
	mod_def_env* save = new_alloc(acp,sizeof(mod_def_env));
	/* W[`̍ۂ̃O[o̕ۑ */
	save->cmd_lexp   = cmd_lexp;
	save->define_tp  = my->define_tp;
	save->max_figure = my->max_figure;
	/* Ex_sflrd_my_clear */
	save->cond_cnt   = my->cond_cnt;
	return save;
	}


/* W[`̍ۂ̊ */

static void restore_my_env_at_define(tMYc mod_def_env* save) {
	/* W[`̍ۂ̃O[o̕ */
	cmd_lexp        = save->cmd_lexp  ;
	my->define_tp   = save->define_tp ;
	my->max_figure  = save->max_figure;
	/* Ex_sflrd_my_clear */
	my->cond_cnt = save->cond_cnt;
	}


/* '< @{ ,  } '> */

ENTRY void get_arg_link_of_token(tMYc token* def_tp,int typ,int left,int right) {
	lex* lexp = my->sfllexp;
	token* lxp = new_entity(my->tokecp);
	token* tp;
	uni_link** lpp;
	footmark("get_arg_link_of_token");
	sfl_assert(lexp,left);
	tp = get_token(MYc 0,lxp);	/* PA[Mg擾 */
	if (def_tp->arg != 0) {
		sprintf(lexp_errbuf(lexp),"argument is already defined");
		tok_error(lexp,lxp);
		}
	if (token_id(tp) == right) goto ret;
	for (lpp = &(def_tp->arg) ; ; lpp = &((*lpp)->np)) {
		if(typ != 0 && token_id(tp) != typ) {
			sprintf(lexp_errbuf(lexp),"%s expected",type_name(typ));
			tok_error(lexp,lxp);
			}
		*lpp = new_uni_link(def_tp->acp,tp->toksym,0);
		tp = get_token(MYc 0,lxp);
		if (token_id(tp) == right)  goto ret;
		if (token_id(tp) != ',') { 
			sprintf(lexp_errbuf(lexp),"',' or '%c' expected",right);
			tok_error(lexp,lxp);
			}
		tp = get_token(MYc 0,lxp);	/* Q..A[Mg擾 */
		}
ret:
	del_entity(my->tokecp,lxp);
	}



ENTRY void define_tpl_real_arg(tMYc token* module_tp,int r_ang) {
	lex* lexp = my->sfllexp;
	alloc_ctl* acp = module_tp->acp;
	uni_link** lpp;
	char* buf;
	int   tc;
	footmark("define_tpl_real_arg");
	for (lpp = &(module_tp->arg) ; ; lpp = &((*lpp)->np)) {
		/* A[Mg擾 */
		tc = get_eval_arg(lexp,acp,lexp->sflspec,r_ang,&buf);
		if (tc != LEX_STR) {
			sprintf(lexp_errbuf(lexp),"argument missing");
			lex_error(lexp,ERR_user);
			}
		*lpp = new_uni_link(acp,buf,0);
		tc = sfl_word(lexp);
		if (tc == r_ang)  goto ret;
		if (tc != ',') { 
			sprintf(lexp_errbuf(lexp),"',' or '%c' expected",r_ang);
			lex_error(lexp,ERR_user);
			}
		}
ret:;
	}



/* A[Mgl̍쐬 */

ENTRY void make_tpl_class_name(lex* lexp,token* tp) {
	uni_link** lpp;
	char*   name;
	char*   buf;
	int     len;
	int     dlen;
	if (tp == 0) return;
	dlen = strlen(tpl_delm);
	len = strlen(tp->toksym->name);
	for(lpp = &(tp->arg) ; *lpp != 0 ; lpp = &((*lpp)->np)) {
		name = (*lpp)->ap;
		len += dlen + strlen(name);
		}
	buf = new_alloc(tp->acp,len+1);
	len = sprintf(buf,"%s",tp->toksym->name);
	for(lpp = &(tp->arg) ; *lpp != 0 ; lpp = &((*lpp)->np)) {
		name= (*lpp)->ap;
		len += sprintf(&buf[len],"%s%s",tpl_delm,name);
		}
	tp->tokren = tp->toksym = symbol_lookup(lexp,buf);
	}




/* ev[ggăW[`i錾j */

ENTRY token* apply_template(
	tMYc 
	token* tpl_tp,		/* ev[g */
	token* mtp,
	token* (*reader)(tMYc token*, int, token*)
) {
	lex* lexp = my->sfllexp;
	mod_def_env*  envp;
	macro*    mp;
	char*     tname;
	source*   rfp;
	uni_link* arg;
	uni_link* p;
	/* ev[g`̍ĊJʒuo*/
	envp = get_token_env(tpl_tp);
	/* oiarg N̓NAĂj */
	arg = mtp->arg;
	mtp->arg = 0;
	tname = tpl_tp->toksym->name;
	/* V}NZP */
	mp = new_alloc(my->tmpacp, sizeof(*mp));
	mp->macsym = tpl_tp->toksym;
	mp->string = 0;	/* KOX^[ĝ */
	rfp = new_source(lexp,lexp,READ_TPL,mp,0,0,0);
	if (rfp == 0) {
		/* ev[g`t@C̍ĊJɎsBiOQFbI||Ij */
		sprintf(lexp->errbuf,"template file missing (%s)",tname);
		lex_error(lexp,ERR_user);
		}
	rfp->tpl_tap = template_source;
	rfp->envp = envp;	/*  */
	/* Ǝ̑Ήi}N``Łj */
	envp->machash = 0;
	for (p = tpl_tp->arg ; p != 0 && arg != 0 ; p = p->np, arg = arg->np) {
		macro_lookup(my->tmpacp,&(envp->machash),p->ap,(char*)(arg->ap));
		}
	if (p != 0 || arg != 0) {
		/* Ǝ̐vĂȂ */
		sprintf(lexp->errbuf,"template argument mismatch (%s)",tname);
		lex_error(lexp,ERR_user);
		}
	{	mod_def_env*  save_env;
		hashtbl*      save_tplhash;
		jmp_buf*      save_jbp;
		jmp_buf       jbuf;
		int rtc;
		/* ݂̊ۑ */
		save_env = save_my_env_at_define(MYc my->tmpacp);
		save_tplhash = lexp->tplhash;
		save_jbp = my->jmpbfp;
		/* ev[g`̊ */
		restore_my_env_at_define(MYc envp);
		lexp->tplhash = envp->machash;
		/* gāAev[g`̍ēǊJn */
		my->jmpbfp = &jbuf;
		rtc = setjmp(jbuf);
		if (rtc == 0) {
			mtp = new_token(lexp->sflacp,mtp->id,mtp);
			mtp = (*reader)(MYc tpl_tp->parent, mtp->id, mtp);
			}
		/* ̊𕜌 */
		my->jmpbfp = save_jbp;
		lexp->tplhash = save_tplhash;
		restore_my_env_at_define(MYc save_env);
		if(rtc != 0) {
			/* ُI */
			longjmp(*(my->jmpbfp),rtc);
			}
		}
	/* ev[g`̍ēǂɏIiIj */
	return mtp;
	}


static void macdef_tpl_arg(tMYc token* tpl_tp, mod_def_env* envp) {
	uni_link* p;
	/* 
	}No^B
	œo^éA}N݂̂łB}N{̂́A""łA
	}NWJƂɂ́A}N̂̂ɂȂB܂Aev[g
	o^ɁÂ͉܂܎c悤ɂĂ̂łB
	*/
	envp->machash = 0;
	for (p = tpl_tp->arg ; p != 0 ; p = p->np) {
		macro_lookup(my->tmpacp,&(envp->machash),p->ap,"");
		}
	}


/* {W[̖{̒`L^ */

ENTRY void record_template(tMYc token* tpl_tp,mod_def_env* envp) {
	lex* lexp = my->sfllexp;
	hashtbl* save_tplhash;
	token tok;
	get_token(MYc 0,&tok);
	unget_token(lexp,&tok);
	if (tok.id != '{') {
		sprintf(lexp_errbuf(lexp)," '{' expected");
		tok_error(lexp,&tok);
		}
	macdef_tpl_arg(MYc tpl_tp, envp);
	save_tplhash = lexp->tplhash;
	lexp->tplhash = envp->machash;
	envp->bagp = record_block('{','}',lexp);
	lexp->tplhash = save_tplhash;
	}


/* ========================================================================= */
/* =====   orQsnjdme[u                              ===== */
/* ========================================================================= */


setup_parm token_ini[] = {
	sup_int(symbol_max_len ),
	sup_int(symbol_charset ),
	sup_int(symbol_charcaps),
	{0,0,0,0},
	};


