/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_val.c
 *
 * SFL value operation.
 * Version 1.10 Beta   Date 1999.5.8
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#define foot_on 0
#include "ps_selec.h"
#include "ps_misc.h"
#include "ps_val.h"


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY void fill_value(uint fig, word* wp, fullword fd) {
	halfword mask;
	int wlen;
	int i;
	wlen = cal_arr_len(fig);
	for (i = 0 ; i < wlen ; ++i) wp[i].f = fd;
	if (--i >= 0) {
		mask = (halfword)(~(FFFF << cal_last_word_bits(fig)));
		wp[i].s.h &= mask;		/* higt rest 0 clear */
		wp[i].s.l &= mask;		/* higt rest 0 clear */
		}
	}


ENTRY void word_copy(uint nfig, word* np, uint sfig, word* sp) {
	uint nlen = cal_arr_len(nfig);
	uint slen = cal_arr_len(sfig);
	uint len2;
	halfword mask;
	if (nlen < slen) {
		if (nlen > 0) {
			memcpy(np,sp,sizeof(word)*nlen);
			mask = (halfword)(~(FFFF << cal_last_word_bits(nfig)));
			np[nlen-1].s.h &= mask;		/* higt rest 0 clear */
			np[nlen-1].s.l &= mask;		/* higt rest 0 clear */
			}
		}
	else {
		memcpy(np,sp,sizeof(word)*slen);
		len2 = nlen - slen;;
		if (len2 > 0) memset(np+slen,0,sizeof(word)*len2);
		}
	}


ENTRY int word_comp(uint fig, word* np, word* sp) {
	uint len = cal_arr_len(fig);
	uint i;
	for (i = 0 ; i < len ; ++i) {
		if ((*np++).f != (*sp++).f) return 1;
		}
	return 0;
	}


ENTRY uint sfln_valid_bits(int wlen, word* wp) {
	halfword d;
	halfword mask;
	int i,j;
	/* LrbgvZ */
	for (j = wlen - 1 ; j >= 0 ; --j) {
		d = wp[j].s.l;
		mask = ((halfword)0x1) << (word_bitsiz-1);
		for (i = word_bitsiz ; i > 0 ; --i) {
			if (d & mask) goto ret;
			d <<= 1;
			}
		}
	return 1;	/* 0f[^́A1rbgƂ */
ret:
	return j * word_bitsiz + i;
	}


ENTRY void decriment_word(unsigned int fig,  word* wp) {
	fullword f;
	int wlen;
	int i;
	wlen = cal_arr_len(fig);
	for(i = 0 ; i < wlen ; ++i) {
		f = (fullword)(wp[i].s.l) - 1;
		wp[i].s.h = wp[i].s.l = (halfword)f;
		if ((f >> word_bitsiz) == 0) break;
		}
	}


ENTRY void increment_word(unsigned int fig,  word* wp) {
	fullword f;
	int wlen;
	int i;
	wlen = cal_arr_len(fig);
	for(i = 0 ; i < wlen ; ++i) {
		f = (fullword)(wp[i].s.l) + 1;
		wp[i].s.h = wp[i].s.l = (halfword)f;
		if ((f >> word_bitsiz) == 0) break;
		}
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


static word* str2dec(halfword d, char* bp) {
	/* ̊֐̂rekmi[p̃obt@̃Zbg */
	enum {set_max = 8};
	static int set_ix = 0;
	static word** set_wpp = 0;
	static int*   set_szp = 0;
	/* rekmi[p̃obt@ */
	word* wb;
	int   wb_siz;
	int   wb_cnt;
	/* -- */
	fullword w;		/* ݎ荞ݒ̃f[^ */
	int   c;
	int   i;
	if (set_wpp == 0) {
		set_wpp = new_mem(set_max * sizeof(word*));
		memset(set_wpp,0, set_max * sizeof(word*));
		set_szp = new_mem(set_max * sizeof(int));
		memset(set_szp,0, set_max * sizeof(int));
		}
	/* gprekmi[p̃obt@I */
	set_ix = (set_ix + 1) % set_max;
	wb_siz = set_szp[set_ix];
	wb     = set_wpp[set_ix];
	if (wb_siz == 0) {
		/* ԃf[^i[p̃obt@p */
		set_szp[set_ix] = wb_siz = 16;
		set_wpp[set_ix] = wb = new_mem(wb_siz * sizeof(word));
		}
	/* f[^i[ */
	wb[1].s.l = d;
	wb_cnt = 2;
	/* wb̔gpĐl\ */
	while((c = *bp++) != 0) {
		if (c == '_') continue;
		if (c >= '0' && c <= '9') d = (halfword)(c - '0');
		else {
			break;	/* error end */
			}
		for (i = 1 ; i < wb_cnt ; ++i ) {
			w = (fullword)(wb[i].s.l) * 10 + d;
			wb[i].s.l = (halfword)w;
			d = (halfword)(w >> word_bitsiz);
			}
		if (d != 0) {
			if (++wb_cnt >= wb_siz) {
				/* ԃf[^i[p̃obt@g */
				size_t n_siz;
				n_siz = size_doubler(wb_siz,16);
				set_wpp[set_ix] = wb = resize_mem(wb,wb_siz*sizeof(word),n_siz*sizeof(word));
				set_szp[set_ix] = wb_siz = n_siz;
				}
			wb[i].s.l = d;
			}
		}
	/* fullwordɊg債Ărekm\ */
	for (i = 1 ; i < wb_cnt ; ++i ) {
		wb[i].s.h = wb[i].s.l;
		}
	ARRLEN(wb) = (halfword)(wb_cnt - 1);
	BITSIZ(wb) = (halfword)sfln_valid_bits(wb_cnt-1, wb+1);
	return wb;
	}


/*=== SFL number ===*/


static int dmy_int;

ENTRY word* str2sfln(int no_zero, char* bp) {
	/* ̊֐̂rekmi[p̃obt@̃Zbg */
	enum {set_max = 8};
	static int set_ix = 0;
	static word** set_wpp = 0;
	static int*   set_szp = 0;
	/* rekmi[p̃obt@ */
	word* wb;
	int   wb_siz;
	int   wb_cnt;
	/* -- */
	word*     wp;
	halfword  dl,dh;
	fullword  data_l,data_h;	/* ݎ荞ݒ̃f[^ */
	fullword  mask;
	word      u;
	int       radix;			/*  */
	int       radbit;			/* ̃rbgTCY */
	int       bits;				/* data ɒ~ĂrbgTCY */
	int       figure;			/* Ŝ̃rbgTCY */
	int       arrlen;
	int       c;
	int       i;
	footmark("str2sfln");
	dmy_int = no_zero;
	if (set_wpp == 0) {
		set_wpp = new_mem(set_max * sizeof(word*));
		memset(set_wpp,0, set_max * sizeof(word*));
		set_szp = new_mem(set_max * sizeof(int));
		memset(set_szp,0, set_max * sizeof(int));
		}
	/* gprekmi[p̃obt@I */
	set_ix = (set_ix + 1) % set_max;
	wb_siz = set_szp[set_ix];
	wb     = set_wpp[set_ix];
	if (wb_siz == 0) {
		/* ԃf[^i[p̃obt@p */
		set_szp[set_ix] = wb_siz = 16;
		set_wpp[set_ix] = wb = new_mem(wb_siz * sizeof(word));
		}
	ARRLEN(wb) = 0;
	BITSIZ(wb) = 1;
	wb[1].f = 0;
	if (bp == 0) return wb;
	radix  = 10;
	radbit = 0;
	bits   = 0;
	figure = 0;
	data_l = 0;
	data_h = 0;
	/* ̕sf[^p */
	u.f = UUUUUUUU;
	u.s.l >>= word_bitsiz - radbit;
	u.s.h >>= word_bitsiz - radbit;
	/* ŏʂ̃f[^ɂ̓_~[Op */
	wb_cnt = wb_siz - 1;
	wb[wb_cnt--].f = 0;		/* lower word guard */
	/* ʂɃ[hl߂čsilraj*/
	while((c = *bp++) != 0) {
		if      (c == '_') continue;
		if      (c >= 'A' && c <= 'Z') c += 'a' - 'A';
		if      (c >= '0' && c <= '9') dl = dh = (halfword)(c - '0');
		else if (c >= 'a' && c <= 'f') dl = dh = (halfword)(c - 'a' + 10);
		else if (c == 'u') dl = u.s.l, dh = u.s.h;
		else dl = 17;
		if (dl > radix) {
			switch(c) {
			case 'b': radbit = 1; break;
			case 'o': radbit = 3; break;
			case 'x': radbit = 4; break;
			default : goto set;
				}
			radix = 1 << radbit;
			/* ̕sf[^p */
			u.f = UUUUUUUU;
			u.s.l >>= word_bitsiz - radbit;
			u.s.h >>= word_bitsiz - radbit;
			continue;
			}
		if (radbit == 0) {
			if (dl != 0) {
				/* POiɂ */
				return str2dec(dl, bp);
				}
			continue;
			}
		data_l = (data_l << radbit) | dl;
		data_h = (data_h << radbit) | dh;
		bits += radbit;
		figure += radbit;
		if (bits >= word_bitsiz) {	/* P[h̃f[^܂ */
			bits -= word_bitsiz;
			if (wb_cnt < 2) {
				/* ԃf[^i[p̃obt@g */
				size_t n_siz;
				word* nb;
				n_siz = size_doubler(wb_siz,16);
				nb = (word*)new_mem(n_siz*sizeof(word));
				/* ӁFʑɃRs[Ă */
				memcpy(nb+n_siz-wb_siz,wb,wb_siz*sizeof(word));
				del_mem(wb);
				set_szp[set_ix] = wb_siz = n_siz;
				set_wpp[set_ix] = wb = nb;
				}
			wb[wb_cnt].s.l = (halfword)(data_l >> bits);
			wb[wb_cnt].s.h = (halfword)(data_h >> bits);
			wb_cnt--;
			}
		}
set:
	if (figure == 0) figure = 1;
	arrlen = cal_arr_len(figure);
	/* ʑɌԂoȂpɋlߒikraj*/
	wp = wb + 1;
	mask = ~(FFFFFFFF << bits);
	for (i = 0 ; i < arrlen ; ++i) {
		++wb_cnt;
		data_l = ((fullword)wb[wb_cnt].s.l << bits) | (data_l & mask);
		data_h = ((fullword)wb[wb_cnt].s.h << bits) | (data_h & mask);
		wp->s.l = (halfword)data_l;
		wp->s.h = (halfword)data_h;
		data_l >>= word_bitsiz;
		data_h >>= word_bitsiz;
		++wp;
		}
	ARRLEN(wb) = (halfword)(arrlen);
	BITSIZ(wb) = (halfword)(figure);
	return wb;
	}


ENTRY void dsp_sflnum(word* wp) {
	word* vp;
	int i;
	vp = wp + 1;
	printf("dsp SFLnum  bitsiz=%d, array len=%d\n",BITSIZ(wp),ARRLEN(wp));
	for (i = 0 ; i < ARRLEN(wp) ; ++i) {
		printf("    %04x - %04x\n", vp->s.h, vp->s.l);
		++vp;
		}
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


ENTRY char* word2hexstr(int bitsiz, word* vp) {
	word  data;
	int   arrlen;
	int   bits;
	int   shl;
	int   n;
	int   i;
	int   x_on;
	char* sp;
	char* buf;
	if (vp == 0) return "";
	arrlen = cal_arr_len(bitsiz);
	if (arrlen == 0 || bitsiz == 0) return "";
	sp = buf = get_looped_buf(0);
	*sp++ = '0';
	x_on = 0;
	bits = cal_last_word_bits(bitsiz);
	shl  = word_bitsiz - bits;
	if (shl != 0) {
		bitsiz -= bits;
		data.f = vp[--arrlen].f << shl;
		n = (bits - 1) % 4 + 1;
		if (n != 4) {
			*sp++ = 'b';
			for (i = 0 ; i < n ; ++i) {
				*sp++ = (char)((data.s.l & hw_sign) ? '1' : '0');
				data.s.l <<= 1;
				}
			data.s.l >>= n;
			bits -= n;
			}
		data.s.l >>= shl;					/* upper area 0 clear */
		if (bits > 0) {
			char form[8];
			sprintf(form,"x%c%02dx",'%',bits/4);
			sprintf(sp,form,data.s.l);
			while(*sp != 0) ++sp;
			x_on = 1;
			}
		}
	*sp = 0;
	if (bitsiz != 0) {
		if (x_on == 0) *sp++ = 'x';
		while(--arrlen >= 0) {
			sprintf(sp,"%04x",vp[arrlen].s.l);
			sp += 4;
			}
		}
	return buf;
	}


/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */


enum {
	zero_ix = 0,
	one_ix,
	unknown_ix,
	hi_inp_ix
	};


static struct {
	char* lower;
	char* upper;
	} sfln_dsp_char[] = {
  /* 0------0--------- 0: zero_ix         
     |1-----|1-------- 1: one_ix          
     ||2----||2------- 2: unknown_ix      
     |||3---|||3------ 3: hi_inp_ix       
     |||    |||                         */
   {" 1u ","01uz"},	/* 0: instruct data */
   {"01u ","01uz"},	/* 1: terminal data */
   {"01uz","01uz"},	/* 2: register data */
    };


static char* value2str_dec_rev(int bitsiz, word* vp, char* vc) {
	halfword* data;
	fullword  ld;
	int   arrlen;
	int   buflen;
	int   msz;
	int   top_i;
	int   i;
	char* sp;
	buflen = (bitsiz + 2) / 3;
	sp = get_looped_buf(buflen);
	*sp++ = '\0';
	if (vp == 0) {
		*sp = vc[hi_inp_ix];	/* zzzz */
		goto ret;
		}
	if (bitsiz == 0) arrlen = 0;
	else arrlen = cal_arr_len(bitsiz);
	data = new_mem(arrlen * sizeof(halfword));
	top_i = 0;
	for (i = 0 ; i < arrlen ; ++i) {
		data[i] = vp[i].s.l;
		if (data[i] != vp[i].s.h) {
			*sp = vc[unknown_ix];	/* zzzz */
			goto del;
			}
		if (data[i] != 0) top_i = i;
		}
	/* 10ł̊ZJԂAŉʃfBWbgZbg */
	msz = 0;							/* ŏʃf[^͂OłȂ */
	while (!msz) {
		/* 10ł̊ZPs */
		ld = 0;
		msz = 1;						/* ŏʃf[^͂Ołij */
		for (i = top_i, top_i = 0 ; i >= 0 ; --i) {
			ld = (ld << word_bitsiz) | data[i];
			data[i] = (halfword)(ld / 10);
			if (data[i] && msz) {
				top_i = i;
				msz = 0;				/* ̌łOȂȂ */
				}
			ld %= 10;
			}
		*sp++ = (char)((int)ld + '0');
		}
	while(*--sp == '0' && *(sp-1) != 0) ;
del:
	del_mem(data);
ret:
	return sp;
	}


static char* value2str_reverse(int bitsiz, word* vp, char fc, int d_typ) {
	fullword dl,dh;
	uint  mask;
	uint  cl,ch;
	int   arrlen;
	int   buflen;
	int   bsiz;
	int   bits;
	char* vc;
	char* sp;
	int   c,i,j;
	switch(fc) {
	case 'b': bsiz =  1; vc = sfln_dsp_char[d_typ].lower; break;
	case 'o': bsiz =  3; vc = sfln_dsp_char[d_typ].lower; break;
	case 'd': bsiz = 10; vc = sfln_dsp_char[d_typ].lower; break;
	case 'x': bsiz =  4; vc = sfln_dsp_char[d_typ].lower; break;
	case 'B': bsiz =  1; vc = sfln_dsp_char[d_typ].upper; break;
	case 'O': bsiz =  3; vc = sfln_dsp_char[d_typ].upper; break;
	case 'D': bsiz = 10; vc = sfln_dsp_char[d_typ].upper; break;
	case 'X': bsiz =  4; vc = sfln_dsp_char[d_typ].upper; break;
	default:  bsiz =  4; vc = sfln_dsp_char[d_typ].lower; break;
		}
	if (bsiz == 10) return value2str_dec_rev(bitsiz, vp, vc);
	if (bitsiz == 0) arrlen = 0;
	else arrlen = cal_arr_len(bitsiz);
	mask = ~(FFFF << bsiz);
	buflen = (bitsiz + bsiz - 1) / bsiz;
	sp = get_looped_buf(buflen);
	*sp++ = 0;
	if (vp == 0) {
		for (i = 0 ; i < buflen ; ++i) *sp++ = vc[hi_inp_ix];	/* zzzz */
		goto ret;
		}
	dl = dh = 0L;
	bits = 0;
	j = 0;
	for (i = 0 ; i < buflen ; ++i) {
		if (bits < bsiz && j < arrlen) {
			dl |= (fullword)(vp[j].s.l) << bits;
			dh |= (fullword)(vp[j].s.h) << bits;
			bits += word_bitsiz;
			++j;
			}
		cl = (uint)dl & mask;
		ch = (uint)dh & mask;
		dl >>= bsiz;
		dh >>= bsiz;
		bits -= bsiz;
		if ((cl^ch) != 0) c = vc[unknown_ix];	/* unknown data char */
		else if (cl == 0) c = vc[zero_ix];		/* value 0 data char */
		else if (cl >  9) c = cl + 'a' - 10;
		else c = cl + '0';
		*sp++ = (char)c;
		}
ret:
	--sp;
	return sp;
	}


ENTRY char* word2str(int bitsiz, word* vp, char fc, int d_typ) {
	char* bp;
	char* sp;
	char* buf;
	int i;
	bp = value2str_reverse(bitsiz, vp, fc, d_typ);
	sp = buf = get_looped_buf(work_buf_len);
	for(i = 0 ; i < work_buf_len ; ++i) {
		if ((*sp++ = *bp--) == 0) break;
		}
	*sp = 0;
	return buf;
	}


/*****************************************************************************/
/* ========================================================================= */
/* =====                                                               ===== */
/* ========================================================================= */
/*****************************************************************************/


/* ========================================================================= */
/* =====   u`k̏e[u                                      ===== */
/* ========================================================================= */


