/*
 *  notice: japanese
 *@쌠҂̍mF
 *@@uf[^TCgJvOgp@QŁv
 *@@ɋLڂ́uvOvƓɎ舵ĒƂɁA
 *@@{hLg̉{EpEۊǂF߂܂B
 */

/*
 * ps_val.h
 *
 * SFL value operation.
 * Version 1.06 Beta   Date 1999.02.08
 * Copyright (c) Datasight Corp., 1996-1999.
 * All Rights Reserved.
 * Made by A.Nakashima
 *
 */


#if !defined(PS_VAL_H)
#define PS_VAL_H


#if defined(ENTRY)
#	undef ENTRY
#	endif
#define ENTRY extern


typedef unsigned short halfword;
typedef unsigned long  fullword;

#define FF       0x00ff
#define FFFF     ((halfword)0xffff)
#define FFFFFFFF 0xffffffffL
#define UUUUUUUU 0x0000ffffL
#define X0000000 0x00000000L
#define B0       0x00000000L
#define B1       0x00010001L
#define BU       0x00000001L

#define hw_sign 0x8000
#define fw_sign 0x80000000L


#if (_ENDIAN_ == LITTLE_ENDIAN_)
	typedef union u_word {
		fullword f;
		struct {
			halfword h;
			halfword l;
			} s;
		} word;
#else
	typedef union u_word {
		fullword f;
		struct {
			halfword l;
			halfword h;
			} s;
		} word;
#	endif


#define word_bitsiz                (sizeof(halfword)*8)
#define cal_arr_len(bitsiz)        ((bitsiz+word_bitsiz-1)/word_bitsiz)
#define cal_last_word_bits(bitsiz) (((bitsiz-1)%word_bitsiz)+1)
#define ARRLEN(wp) ((wp)[0].s.h)
#define BITSIZ(wp) ((wp)[0].s.l)


#if (INT_SIZE < 4)
	typedef union u_subvix {
		unsigned short f;
		struct {
			unsigned char sub;
			unsigned char vix;
			} s;
		} subvix;
#else
	typedef union u_subvix {
		unsigned long f;
		struct {
			unsigned short sub;
			unsigned short vix;
			} s;
		} subvix;
#endif


/* ========================================================================= */
/* =====   ps_val.h                                                    ===== */
/* ========================================================================= */


/* SFL𕶎ŕ\ꍇɎgp镶̃^CvI */

enum {
	instruct_data = 0,
	terminal_data,
	register_data
	};


void fill_value(unsigned int fig, word* wp, fullword fd);
char* word2str(int bitsiz, word* vp, char fc, int d_typ);
char* word2hexstr(int bitsiz, word* vp);
unsigned int sfln_valid_bits(int wlen, word* wp);
void decriment_word(unsigned int fig,  word* wp);
void increment_word(unsigned int fig,  word* wp);
word* str2sfln(int no_zero, char* bp);
void word_copy(unsigned int nfig, word* np, unsigned int sfig, word* sp);
int word_comp(unsigned int fig, word* np, word* sp);


#define get_sfln_word(tp) (*(tp->wpp)+(unsigned int)(tp->value))


#undef  ENTRY
#define ENTRY 


#endif PS_VAL_H
